<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| This displays the ProjectsPro information ina block |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 202 $
| $Author: jday29 $
| $Date: 2006-05-22 15:28:36 -0500 (Mon, 22 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'CPG_NUKE' ) ) {
	exit;
}

global $prefix, $db, $cpgtpl;

$block_file_info = explode('-', substr(basename(__FILE__), 6, (basename(__FILE__) - 4)));
$projectspro_base = $block_file_info[0];
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

if ( !is_active( $projectspro_base ) ) {
	$content = '';
	return;
}

get_lang('ProjectsPro');

$cpgtpl->assign_vars( array(
	'L_PROJECT_NAME' => _PRP_PROJECTNAME,
	'L_TASKS' => _PRP_TASKS,
	'L_STATUS' => _PRP_STATUS,
	'L_PRIORITY' => _PRP_PRIORITY,
	'L_MEMBERS' => _PRP_MEMBERS,
	'L_PROGRESS' => _PRP_PROGRESS,
	'L_PERCENT' => _PRP_PERCENT . ' ' . _PRP_COMPLETED,
	'L_NO_PROJECTS_FEATURED' => can_admin($projectspro_base) ? _PRP_NOPROJECTSFEATURED : '',
	)
);

$result_projects = $db->sql_query( 'SELECT p.project_id, p.project_name, p.project_percent, pr.priority_name, s.status_name, SUM(t.task_percent) AS task_percent, COUNT(t.task_id) AS task_count FROM ( '.$projectspro_prefix.'priorities pr, '.$projectspro_prefix.'status s, ( '.$projectspro_prefix.'projects p LEFT JOIN '.$projectspro_prefix.'tasks t ON p.project_id = t.project_id ) ) WHERE p.priority_id = pr.priority_id AND p.status_id = s.status_id AND p.featured = 1 GROUP BY p.project_id ORDER BY p.weight ASC, pr.weight DESC, s.weight DESC', false, __FILE__, __LINE__ );
while( list( $project_id, $project_name, $project_percent, $priority_name, $status_name, $task_percent, $task_count ) = $db->sql_fetchrow( $result_projects, SQL_NUM ) ) {
	$cpgtpl->assign_block_vars( 'projectblock', array(
		'S_PROJECT_NAME' => $project_name,
		'S_PROJECT_NAME_HTML' => htmlprepare( $project_name ),
		'S_TASK_COUNT' => $task_count,
		'S_STATUS' => $status_name,
		'S_STATUS_HTML' => htmlprepare($status_name),
		'S_PRIORITY' => $priority_name,
		'S_PRIORITY_HTML' => htmlprepare($priority_name),
		'S_PERCENT_DONE' => 0 == $project_percent ? ( ( 0 == $task_count ) ? 0 : floor( $task_percent / $task_count ) ) : $project_percent,
		'S_PERCENT_TODO' => 99 < $project_percent ? 0 : ( 100 - ( 0 == $project_percent ? ( ( 0 == $task_count ) ? 0 : floor( $task_percent / $task_count ) ) : $project_percent ) ),

		'U_PROJECT' => getlink($projectspro_base.'&amp;file=project&amp;project_id=' . $project_id ),
		)
	);
}
$db->sql_freeresult( $result_projects );

ob_start();
$cpgtpl->set_filenames(array('block' => 'blocks/'.str_replace('.php', '.html', str_replace($projectspro_base, 'ProjectsPro', basename(__FILE__)))));
$cpgtpl->display('block');
$content = ob_get_clean();
$cpgtpl->unset_block('projectblock');