<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly™ CMS                                                |
| Copyright © 2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum™ Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright © 2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| General functions used in the ProjectsPro administration section  |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
Last modification notes:
 $Source$
 $Revision: 200 $
 $Author: jday29 $
 $Date: 2006-05-18 13:42:53 -0500 (Thu, 18 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright © 2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'ADMIN_PAGES' ) ) {
	exit;
}

/**
 * Return the list of types
 **/
function ProjectsPro_type_get() {
	return array( _PRP_PROJECT, _PRP_TASK, _PRP_REPORT, _PRP_REQUEST );
}

/**
 * Get the status list for projects
 **/
function ProjectsPro_status_get( $type ) {
	global $db, $projectspro_prefix;
	
	$result_status = $db->sql_query( 'SELECT status_id, status_name FROM '.$projectspro_prefix.'status WHERE type = ' . $type . ' ORDER BY weight, status_name ASC', false, __FILE__, __LINE__ );
	$status = array();
	while( list( $status_id, $status_name ) = $db->sql_fetchrow( $result_status, SQL_NUM ) ) {
		$status[$status_id] = htmlprepare($status_name);
	}
	$db->sql_freeresult( $result_status );
	return $status;
}

/**
 * Get the priority list
 **/
function ProjectsPro_priority_get() {
	global $db, $projectspro_prefix;
	
	$result_priority = $db->sql_query( 'SELECT priority_id, priority_name FROM '.$projectspro_prefix.'priorities ORDER BY weight, priority_name ASC', false, __FILE__, __LINE__ );
	$priority = array();
	while( list( $priority_id, $priority_name ) = $db->sql_fetchrow( $result_priority, SQL_NUM ) ) {
		$priority[$priority_id] = htmlprepare($priority_name);
	}
	$db->sql_freeresult( $result_priority );
	return $priority;
}

/**
 * Get the position list for members
 **/
function ProjectsPro_position_get() {
	global $projectspro_prefix, $db;
	
	$result_position = $db->sql_query( 'SELECT position_id, position_name FROM '.$projectspro_prefix.'positions ORDER BY position_name ASC', false, __FILE__, __LINE__ );
	$position = array();
	while( list( $position_id, $position_name ) = $db->sql_fetchrow( $result_position, SQL_NUM ) ) {
		$position[$position_id] = htmlprepare($position_name);
	}
	$db->sql_freeresult( $result_position );
	return $position;
}

/**
 * Get the project information
 **/
function ProjectsPro_project_get($project_id=0 ) {
	global $projectspro_prefix, $db;
	
	if ( 0 == $project_id ) {
		return false;
	}
	
	return $db->sql_ufetchrow( 'SELECT * FROM '.$projectspro_prefix.'projects WHERE project_id = ' . $project_id, SQL_ASSOC, __FILE__, __LINE__ );
}

/**
 * Get the task information
 **/
function ProjectsPro_task_get($task_id=0 ) {
	global $projectspro_prefix, $db;
	
	if ( 0 == $task_id ) {
		return false;
	}
	
	return $db->sql_ufetchrow( 'SELECT * FROM '.$projectspro_prefix.'tasks WHERE task_id = ' . $task_id, SQL_ASSOC, __FILE__, __LINE__ );
}

/**
 * Get the report information
 **/
function ProjectsPro_report_get($report_id=0) {
	global $projectspro_prefix, $db;
	
	if (0 == $report_id) {
		return false;
	}
	
	return $db->sql_ufetchrow('SELECT * FROM '.$projectspro_prefix.'reports WHERE report_id = '.$report_id, SQL_ASSOC, __FILE__, __LINE__);
}

/**
 * Get the request information
 **/
function ProjectsPro_request_get($request_id=0) {
	global $projectspro_prefix, $db;
	
	if (0 == $request_id) {
		return false;
	}
	
	return $db->sql_ufetchrow('SELECT * FROM '.$projectspro_prefix.'requests WHERE request_id = '.$request_id, SQL_ASSOC, __FILE__, __LINE__);
}

/**
 * Get the projects list
 **/
function ProjectsPro_projects_get() {
	global $projectspro_prefix, $db;
	
	$result_projects = $db->sql_query( 'SELECT project_id, project_name FROM '.$projectspro_prefix.'projects', false, __FILE__, __LINE__ );
	$projects = array();
	while( list( $project_id, $project_name ) = $db->sql_fetchrow( $result_projects, SQL_NUM ) ) {
		$projects[$project_id] = htmlprepare($project_name);
	}
	$db->sql_freeresult( $result_projects );
	return $projects;
}

/**
 * Get the members of a project
 **/
function ProjectsPro_projects_members_get($project_id=0 ) {
	global $projectspro_prefix, $user_prefix, $db;
	
	if ( 0 == $project_id ) {
		return false;
	}
	
	$result_members = $db->sql_query( 'SELECT u.username, pm.position_id FROM '.$projectspro_prefix.'projects_members pm, ' . $user_prefix . '_users u WHERE AND pm.user_id = u.user_id AND pm.project_id = ' . $project_id, SQL_NUM, __FILE__, __LINE__ );
	$members = array();
	while( list( $username, $position_id ) = $db->sql_fetchrow( $result_members, SQL_NUM ) ) {
		$members[$username] = $position_id;
	}
	$db->sql_freeresult( $result_members );
	return $members;
}

/**
 * Get the report types
 **/
function ProjectsPro_types_get($type ) {
	global $projectspro_prefix, $db;
	
	$result_types = $db->sql_query( 'SELECT type_id, name FROM '.$projectspro_prefix.'types WHERE type = ' . $type . ' ORDER by name ASC', false, __FILE__, __LINE__ );
	$type = array();
	while( list( $type_id, $name ) = $db->sql_fetchrow( $result_types, SQL_NUM ) ) {
		$type[$type_id] = htmlprepare($name);
	}
	$db->sql_freeresult( $result_types );
	return $type;
}

/**
 * Add the header information to the template
 **/
function ProjectsPro_header() {
	global $cpgtpl;
	
	$file = isset( $_GET['file'] ) ? $_GET['file'] : '';
	
	$cpgtpl->assign_vars( array(
		'L_PROJECTS' => _PRP_PROJECTS,
		'L_TASKS' => _PRP_TASKS,
		'L_REPORTS' => _PRP_REPORTS,
		'L_REQUESTS' => _PRP_REQUESTS,
		'L_STATUS_LIST' => _PRP_STATUSLIST,
		'L_POSITION_LIST' => _PRP_POSITIONLIST,
		'L_PRIORITY_LIST' => _PRP_PRIORITYLIST,
		'L_TYPES_LIST' => _PRP_TYPESLIST,
		'L_CONFIG' => _TB_CONFIG,

		'U_PROJECTS' => '' == $file ? '' : adminlink(),
		'U_TASKS' => 'tasks' == $file ? '' : adminlink('&amp;file=tasks' ),
		'U_REPORTS' => 'reports' == $file ? '' : adminlink('&amp;file=reports' ),
		'U_REQUESTS' => 'requests' == $file ? '' : adminlink('&amp;file=requests' ),
		'U_STATUS_LIST' => 'status' == $file ? '' : adminlink('&amp;file=status' ),
		'U_PRIORITY_LIST' => 'priority' == $file ? '' : adminlink('&amp;file=priority' ),
		'U_POSITION_LIST' => 'position' == $file ? '' : adminlink('&amp;file=position' ),
		'U_TYPES_LIST' => 'types' == $file ? '' : adminlink('&amp;file=types' ),
		'U_CONFIG' => 'config' == $file ? '' : adminlink('&amp;file=config' ),
		)
	);
	
	$cpgtpl->set_filenames( array( 'header' => 'ProjectsPro/admin/header.html' ) );
	$cpgtpl->display( 'header' );
}