<?php
	if (!defined('ADMIN_MOD_INSTALL')) { exit; }

	# module installer
	function ProjectsPro_install($this_prefix, $this_base) {
		global $installer;
	
		$installer->add_query('CREATE', $this_prefix.'positions', "
			position_id int(11) NOT NULL auto_increment,
			position_name varchar(255) NOT NULL default '',
			position_description text NOT NULL,
			PRIMARY KEY	(position_id)", $this_prefix.'positions');		

		$installer->add_query('INSERT', $this_prefix.'positions', '"1", "Project Manager", "Project Manager"');	
		$installer->add_query('INSERT', $this_prefix.'positions', '"2", "Project Developer", "Project Developer"');	
		$installer->add_query('INSERT', $this_prefix.'positions', '"3", "Project Tester", "Project Tester"');	
		$installer->add_query('INSERT', $this_prefix.'positions', '"4", "Project Sponsor", "Project Sponsor"');	
	
		$installer->add_query('CREATE', $this_prefix.'priorities', "
			priority_id int(11) NOT NULL auto_increment, 
			priority_name varchar(30) NOT NULL default '', 
			weight int(11) NOT NULL default 0, 
			PRIMARY KEY	(priority_id)", $this_prefix.'priorities');
	
		$installer->add_query('INSERT', $this_prefix.'priorities', '"1", "N/A", "1"');	
		$installer->add_query('INSERT', $this_prefix.'priorities', '"2", "Low", "2"');	
		$installer->add_query('INSERT', $this_prefix.'priorities', '"3", "Low-Medium", "3"');	
		$installer->add_query('INSERT', $this_prefix.'priorities', '"4", "Medium", "4"');
		$installer->add_query('INSERT', $this_prefix.'priorities', '"5", "Medium-High", "5"');
		$installer->add_query('INSERT', $this_prefix.'priorities', '"6", "High", "6"');
	
		$installer->add_query('CREATE', $this_prefix.'status', "
			status_id int(11) NOT NULL auto_increment, 
			status_name varchar(255) NOT NULL default '', 
			status_description text NOT NULL, 
			weight int(11) NOT NULL default 0, 
			type tinyint(4) NOT NULL default 0,
			display tinyint(1) NOT NULL default 0,
			PRIMARY KEY	(status_id)", $this_prefix.'status');
	
		$installer->add_query('INSERT', $this_prefix.'status', '"1", "N/A", "N/A", "1", "0", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"2", "Concept", "Concept", "2", "0", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"3", "Requirements", "Requirements gathering", "3", "0", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"4", "Design", "Design", "4", "0", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"5", "Development", "Development", "5", "0", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"6", "Beta Test", "Beta Testing", "6", "0", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"7", "Complete", "Complete", "7", "0", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"8", "Open", "This report is open", "8", "2", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"9", "Closed", "This report is closed", "9", "2", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"10", "Bogus", "This report is bogus", "10", "2", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"11", "Duplicate", "This report is a duplicate", "11", "2", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"12", "Feedback", "This report requires/has feedback", "12", "2", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"13", "Assigned", "This report has been assigned for research", "13", "2", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"14", "Open", "This request is open", "14", "3", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"15", "Closed", "This request is closed", "15", "3", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"16", "Bogus", "This request is bogus", "16", "3", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"17", "Duplicate", "This request is a duplicate", "17", "3", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"18", "Feedback", "This request requires/has feedback", "18", "3", "1"');	
		$installer->add_query('INSERT', $this_prefix.'status', '"19", "Assigned", "This request has been assigned for research", "19", "3", "1"');	
	
		$installer->add_query('CREATE', $this_prefix.'projects', "
			project_id int(11) NOT NULL auto_increment, 
			project_name varchar(255) NOT NULL default '', 
			project_description text NOT NULL, 
			priority_id int(11) NOT NULL default 0, 
			status_id int(11) NOT NULL default 0, 
			project_percent int(11) NOT NULL default 0, 
			weight int(11) NOT NULL default 0, 
			featured tinyint(2) NOT NULL default 0, 
			date_created int(11) NOT NULL default 0, 
			date_started int(11) NOT NULL default 0, 
			date_finished int(11) NOT NULL default 0, 
			PRIMARY KEY (project_id)", $this_prefix.'projects');
	
		$installer->add_query('CREATE', $this_prefix.'projects_members', "
			project_id int(11) NOT NULL default 0,
			user_id int(11) NOT NULL default 0,
			position_id int(11) NOT NULL default 0,
			KEY project_id (project_id), KEY user_id (user_id)", $this_prefix.'projects_members');
	
		$installer->add_query('CREATE', $this_prefix.'tasks', "
			task_id int(11) NOT NULL auto_increment, 
			project_id int(11) NOT NULL default 0,
			task_name varchar(255) NOT NULL default '', 
			task_description text NOT NULL, 
			priority_id int(11) NOT NULL default 0, 
			status_id int(11) NOT NULL default 0,	
			task_percent int(11) NOT NULL default 0, 
			date_created int(11) NOT NULL default 0,
			date_started int(11) NOT NULL default 0,
			date_finished int(11) NOT NULL default 0,
			user_id int(11) NOT NULL default 0,
			notify_comment tinyint(1) NOT NULL default 0,
			PRIMARY KEY	(task_id), KEY project_id (project_id)", $this_prefix.'tasks');
	
		$installer->add_query('CREATE', $this_prefix.'tasks_members', "
			task_id int(11) NOT NULL default 0,
			user_id int(11) NOT NULL default 0,	
			KEY task_id (task_id), KEY user_id (user_id)", $this_prefix.'tasks_members');

		$installer->add_query('CREATE', $this_prefix.'reports', "
			report_id int(11) NOT NULL auto_increment, 
			project_id int(11) NOT NULL default 0,
			type_id int(11) NOT NULL default 0,
			status_id int(11) NOT NULL default 0,
			summary varchar(255) NOT NULL default '',
			description text NOT NULL default '',
			reproduce text NOT NULL default '',
			expected text NOT NULL default '',
			actual text NOT NULL default '',
			user_id int(11) NOT NULL default 0,
			ip varchar(8) NOT NULL default '0',
			date_created int(11) NOT NULL default 0,
			date_started int(11) NOT NULL default 0,
			date_finished int(11) NOT NULL default 0,
			task_id int(11) NOT NULL default 0,
			notify_comment tinyint(1) NOT NULL default 0,
			PRIMARY KEY	(report_id), KEY project_id (project_id)", $this_prefix.'reports');
	
		$installer->add_query('CREATE', $this_prefix.'reports_members', "
			report_id int(11) NOT NULL default 0,
			user_id int(11) NOT NULL default 0,	
			KEY report_id (report_id), KEY user_id (user_id)", $this_prefix.'reports_members');

		$installer->add_query('CREATE', $this_prefix.'requests', "
			request_id int(11) NOT NULL auto_increment, 
			project_id int(11) NOT NULL default 0,
			type_id int(11) NOT NULL default 0,
			status_id int(11) NOT NULL default 0,
			summary varchar(255) NOT NULL default '',
			description text NOT NULL default '',
			user_id int(11) NOT NULL default 1,
			ip varchar(8) NOT NULL default '0',
			date_created int(11) NOT NULL default 0,
			date_started int(11) NOT NULL default 0,
			date_finished int(11) NOT NULL default 0,
			task_id int(11) NOT NULL default 0,
			notify_comment tinyint(1) NOT NULL default 0,
			PRIMARY KEY	(request_id), KEY project_id (project_id)", $this_prefix.'requests');
	
		$installer->add_query('CREATE', $this_prefix.'requests_members', "
			request_id int(11) NOT NULL default 0,
			user_id int(11) NOT NULL default 0,	
			KEY request_id (request_id), KEY user_id (user_id)", $this_prefix.'requests_members');

		$installer->add_query('CREATE', $this_prefix.'types', "
			type_id int(11) NOT NULL auto_increment, 
			name varchar(255) NOT NULL default '',	
			type tinyint(4) NOT NULL default 2,
			PRIMARY KEY (type_id)", $this_prefix.'types');

		$installer->add_query('INSERT', $this_prefix.'types', '"1", "Site Issue", "2"');	
		$installer->add_query('INSERT', $this_prefix.'types', '"2", "Website", "3"');	

		$installer->add_query('CREATE', $this_prefix.'comments', "
			comment_id int(11) NOT NULL auto_increment,
			join_id int(11) NOT NULL default 0,
			join_type tinyint(4) NOT NULL default 2,
			user_id int(11) NOT NULL default 0,
			ip varchar(8) NOT NULL default '0',
			description text NOT NULL default '',
			date_created int(11) NOT NULL default 0,
			PRIMARY KEY (comment_id)", $this_prefix.'comments');

		# Configuration values
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'status_id_report_new', '8'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'status_id_request_new', '14'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'notify_admin_report', '1'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'notify_admin_request', '1'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'status_id_task_new', '1'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'priority_id_task_new', '1'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'status_id_report_promoted', '9'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'status_id_request_promoted', '15'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'report_allow_anonymous', '1'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'request_allow_anonymous', '1'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'report_comment_allow_anonymous', '1'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'request_comment_allow_anonymous', '1'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'notify_task_member', '1'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'update_monitor', '1'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'report_enable', '1'");
		$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'request_enable', '1'");
		
		return true;
	}

	# module uninstaller
	function ProjectsPro_uninstall($this_prefix, $this_tables, $this_base) {
		global $installer;
		foreach ($this_tables as $table) {
			$installer->add_query('DROP', $table);
		}
    $installer->add_query('DELETE', 'config_custom', "cfg_name='".$this_base."'");
		return true;
	}

	# module upgrader
	function ProjectsPro_upgrade($prev_version, $this_prefix, $this_base) {
		global $installer;
		if ( version_compare( $prev_version, '0.9.1.1', '<' ) ) {
			$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'status_id_task_new', '1'");
			$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'priority_id_task_new', '1'");
			$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'status_id_report_promoted', '9'");
			$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'status_id_request_promoted', '15'");
			$installer->add_query('ADD', $this_prefix.'reports', 'task_id int(11) NOT NULL default 0' );
			$installer->add_query('ADD', $this_prefix.'requests', 'task_id int(11) NOT NULL default 0' );
		}
		if ( version_compare( $prev_version, '0.9.1.3', '<' ) ) {
			$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'report_allow_anonymous', '1'");
			$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'request_allow_anonymous', '1'");
			$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'report_comment_allow_anonymous', '1'");
			$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'request_comment_allow_anonymous', '1'");
		}
		if ( version_compare( $prev_version, '0.9.1.5', '<' ) ) {
			$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'notify_task_member', '1'");
		}
		if (version_compare($prev_version, '1.0.0.2', '<')) {
			$installer->add_query('ADD', $this_prefix.'tasks', 'user_id int(11) NOT NULL default 0');
			$installer->add_query('ADD', $this_prefix.'tasks', 'notify_comment tinyint(1) NOT NULL default 0');
			$installer->add_query('ADD', $this_prefix.'requests', 'notify_comment tinyint(1) NOT NULL default 0');
			$installer->add_query('ADD', $this_prefix.'reports', 'notify_comment tinyint(1) NOT NULL default 0');
		}
		if (version_compare($prev_version, '1.0.0.3', '<')) {
			$installer->add_query('ADD', $this_prefix.'status', 'display tinyint(1) NOT NULL default 1');
		}
		if (version_compare($prev_version, '1.0.1.0', '<')) {
			$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'update_monitor', '1'");
		}
		if (version_compare($prev_version, '1.1.0.0', '<')) {
			$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'report_enable', '1'");
			$installer->add_query('INSERT', 'config_custom', "'".$this_base."', 'request_enable', '1'");

			$installer->add_query('CREATE', $this_prefix.'reports_members', "
				report_id int(11) NOT NULL default 0,
				user_id int(11) NOT NULL default 0,	
				KEY report_id (report_id), KEY user_id (user_id)", $this_prefix.'reports_members');

			$installer->add_query('CREATE', $this_prefix.'requests_members', "
				request_id int(11) NOT NULL default 0,
				user_id int(11) NOT NULL default 0,	
				KEY request_id (request_id), KEY user_id (user_id)", $this_prefix.'requests_members');
	
		}
		return true;
	}
