<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Display and edit the ProjectsPro configuration settings           |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 203 $
| $Author: jday29 $
| $Date: 2006-05-22 23:08:25 -0500 (Mon, 22 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'ADMIN_PAGES' ) ) {
	exit;
}
if ( !can_admin( $module_name ) ) {
	die( 'Access Denied' );
}

$projectspro_base = basename(dirname(dirname(__FILE__)));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the configuratoin options
 **/
function ProjectsPro_config() {
	global $prefix, $db, $pagetitle, $cpgtpl, $MAIN_CFG, $projectspro_base;
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _TB_CONFIG;
	
	$priority_task = ProjectsPro_priority_get();
	$status_task = ProjectsPro_status_get( 0 );
	$status_report = ProjectsPro_status_get( 2 );
	$status_request = ProjectsPro_status_get( 3 );
	
	require( 'header.php' );
	$cpgtpl->assign_vars( array(
		'L_REPORT_STATUS_NEW' => _PRP_REPORTSTATUSNEW,
		'L_REQUEST_STATUS_NEW' => _PRP_REQUESTSTATUSNEW,
		'L_NOTIFY_ADMIN_REPORT' => _PRP_REPORTNOTIFYADMIN,
		'L_NOTIFY_ADMIN_REQUEST' => _PRP_REQUESTNOTIFYADMIN,
		'L_TASK_STATUS_NEW' => _PRP_TASKSTATUSNEW,
		'L_TASK_PRIORITY_NEW' => _PRP_TASKPRIORITYNEW,
		'L_REPORT_STATUS_PROMOTED' => _PRP_REPORTSTATUSPROMOTED,
		'L_REQUEST_STATUS_PROMOTED' => _PRP_REQUESTSTATUSPROMOTED,
		'L_REPORT_ALLOW_ANONYMOUS' => _PRP_REPORTALLOWANONYMOUS,
		'L_REPORT_COMMENT_ALLOW_ANONYMOUS' => _PRP_REPORTCOMMENTALLOWANONYMOUS,
		'L_REQUEST_ALLOW_ANONYMOUS' => _PRP_REQUESTALLOWANONYMOUS,
		'L_REQUEST_COMMENT_ALLOW_ANONYMOUS' => _PRP_REQUESTCOMMENTALLOWANONYMOUS,
		'L_REPORT_ENABLE' => _PRP_REPORTENABLE,
		'L_REQUEST_ENABLE' => _PRP_REQUESTENABLE,
		'L_NOTIFY_TASK_MEMBER' => _PRP_TASKNOTIFYMEMBER,
		'L_UPDATE_MONITOR' => _PRP_UPDATEMONITOR,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,

		'S_FORM_OPEN_CONFIG' => open_form( adminlink('&amp;file=config&amp;mode=save' ), 'config', _TB_CONFIG ),
		'S_FORM_CLOSE_CONFIG' => close_form(),
		
		'S_REPORT_STATUS_NEW' => select_box( 'ProjectsPro[status_id_report_new]', $MAIN_CFG[$projectspro_base]['status_id_report_new'], $status_report ),
		'S_REQUEST_STATUS_NEW' => select_box( 'ProjectsPro[status_id_request_new]', $MAIN_CFG[$projectspro_base]['status_id_request_new'], $status_request ),
		'S_REPORT_STATUS_PROMOTED' => select_box( 'ProjectsPro[status_id_report_promoted]', $MAIN_CFG[$projectspro_base]['status_id_report_promoted'], $status_report ),
		'S_REQUEST_STATUS_PROMOTED' => select_box( 'ProjectsPro[status_id_request_promoted]', $MAIN_CFG[$projectspro_base]['status_id_request_promoted'], $status_request ),
		'S_NOTIFY_ADMIN_REPORT' => yesno_option( 'ProjectsPro[notify_admin_report]', $MAIN_CFG[$projectspro_base]['notify_admin_report'] ),
		'S_NOTIFY_ADMIN_REQUEST' => yesno_option( 'ProjectsPro[notify_admin_request]', $MAIN_CFG[$projectspro_base]['notify_admin_request'] ),
		'S_REPORT_ALLOW_ANONYMOUS' => yesno_option( 'ProjectsPro[report_allow_anonymous]', $MAIN_CFG[$projectspro_base]['report_allow_anonymous'] ),
		'S_REQUEST_ALLOW_ANONYMOUS' => yesno_option( 'ProjectsPro[request_allow_anonymous]', $MAIN_CFG[$projectspro_base]['request_allow_anonymous'] ),
		'S_REPORT_COMMENT_ALLOW_ANONYMOUS' => yesno_option( 'ProjectsPro[report_comment_allow_anonymous]', $MAIN_CFG[$projectspro_base]['report_comment_allow_anonymous'] ),
		'S_REQUEST_COMMENT_ALLOW_ANONYMOUS' => yesno_option( 'ProjectsPro[request_comment_allow_anonymous]', $MAIN_CFG[$projectspro_base]['request_comment_allow_anonymous'] ),
		'S_TASK_STATUS_NEW' => select_box( 'ProjectsPro[status_id_task_new]', $MAIN_CFG[$projectspro_base]['status_id_task_new'], $status_task ),
		'S_TASK_PRIORITY_NEW' => select_box( 'ProjectsPro[priority_id_task_new]', $MAIN_CFG[$projectspro_base]['priority_id_task_new'], $priority_task ),
		'S_NOTIFY_TASK_MEMBER' => yesno_option( 'ProjectsPro[notify_task_member]', $MAIN_CFG[$projectspro_base]['notify_task_member'] ),
		'S_UPDATE_MONITOR' => yesno_option( 'ProjectsPro[update_monitor]', $MAIN_CFG[$projectspro_base]['update_monitor'] ),
		'S_REPORT_ENABLE' => yesno_option( 'ProjectsPro[report_enable]', $MAIN_CFG[$projectspro_base]['report_enable'] ),
		'S_REQUEST_ENABLE' => yesno_option( 'ProjectsPro[request_enable]', $MAIN_CFG[$projectspro_base]['request_enable'] ),
		)
	);
	
	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'config' => 'ProjectsPro/admin/config.html' ) );
	$cpgtpl->display( 'config' );
	CloseTable();
}

/**
 * Save the new ProjectsPro configuration settings
 **/
function ProjectsPro_config_save() {
	global $prefix, $db, $MAIN_CFG, $projectspro_base;

	if ( isset( $_POST['ProjectsPro'] ) ) {
		foreach( $_POST['ProjectsPro'] as $field=>$value ) {
			if ( isset( $MAIN_CFG[$projectspro_base][$field] ) ) {
				$value = is_numeric( $value ) ? intval( $value ) : Fix_Quotes( $value );
				$db->sql_query( 'UPDATE ' . $prefix . "_config_custom SET cfg_value = '" . $value . "' WHERE cfg_name = '".$projectspro_base."' AND cfg_field = '" . Fix_Quotes( $field ) . "'", false, __FILE__, __LINE__ );
			}
		}
		Cache::array_delete('MAIN_CFG');
	}
	
	url_redirect( adminlink('&amp;file=config' ) );
}

get_lang('ProjectsPro');
require_once(BASEDIR.'includes/ProjectsPro/admin.php');

$pagetitle = _PRP_ADMINMENU;

$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch ($mode) {
	case 'save':
		ProjectsPro_config_save();
		break;
	default:
		ProjectsPro_config();
		break;
}
