<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Main index for ProjectsPro administration section.  Displays the  |
| list of projects and the administration links for each            |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 201 $
| $Author: jday29 $
| $Date: 2006-05-22 15:08:18 -0500 (Mon, 22 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'ADMIN_PAGES' ) ) {
	exit;
}
if ( !can_admin( $module_name ) ) {
	die( 'Access Denied' );
}

$projectspro_base = basename(dirname(dirname(__FILE__)));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

function ProjectsPro_update_monitor() {
	global $db, $prefix, $CPG_SESS, $cpgtpl, $userinfo, $projectspro_base;
	
	list($current_version) = $db->sql_ufetchrow('SELECT version FROM '.$prefix."_modules WHERE title = '".$projectspro_base."'", SQL_NUM);

	if (!isset($CPG_SESS[$projectspro_base]['update_monitor'])) {
		$CPG_SESS[$projectspro_base]['update_monitor'] = false;
	}
	if ($CPG_SESS[$projectspro_base]['update_monitor']) {
		$CPG_SESS[$projectspro_base]['update_monitor'] = Cache::array_load($projectspro_base, 'update_monitor');
	}
	if (!$CPG_SESS[$projectspro_base]['update_monitor']) {
		$modnm='PrjPro';
		$update_url = 'http://www.myndworx.com/update.php?vers='.$current_version.'&mdnm='.$modnm;
		$updinfo = get_fileinfo($update_url, false, true);
		$CPG_SESS[$projectspro_base]['update_monitor'] = array('current' => '0', 'url' => '');
		if ($updinfo) {
			$items = preg_split('#(<item>)#s', $updinfo['data'], -1, PREG_SPLIT_NO_EMPTY);
			$curvers = preg_replace('#^(.*)<version>(.*)</version>(.*)#s','\\2',$items[0], 1);
			$upgurl = preg_replace('#^(.*)<url>(.*)</url>(.*)#s','\\2',$items[0], 1);
			unset($items[0]);
			$CPG_SESS[$projectspro_base]['update_monitor'] = array('current'=>$curvers, 'url'=>$upgurl, 'num'=>count($items), 'msg'=>array());
			foreach ($items as $item) {
				if (!empty($item)) {
					$alrt_vers = preg_replace('#(.*)<version>(.*)</version>(.*)#s','\\2',$item);
					$alrt_title = preg_replace('#(.*)<title>(.*)</title>(.*)#s','\\2',$item);
					$alrt_desc = preg_replace('#(.*)<description>(.*)</description>(.*)#s','\\2',$item);
					$alrt_date = preg_replace('#(.*)<date>(.*)</date>(.*)#s','\\2',$item);
					$CPG_SESS[$projectspro_base]['update_monitor']['msg'][] = array('vers'=>$alrt_vers, 'title'=>$alrt_title, 'desc'=>$alrt_desc, 'date'=>$alrt_date);
				}
			}
			Cache::array_save($projectspro_base, 'update_monitor', $CPG_SESS[$projectspro_base]['update_monitor']);
		}
	}
	if ($CPG_SESS[$projectspro_base]['update_monitor']) {
		$cpgtpl->assign_vars(array(
			'B_UPDATE_FAILED' => false,
			'B_VERSION_GOOD' => version_compare($current_version, $CPG_SESS[$projectspro_base]['update_monitor']['current'], '>='),
			'L_UPDATE_MONITOR' => _PRP_UM,
			'L_VERSION_GOOD' => _PRP_UM_GOOD,
			'L_VERSION_UPDATE' => sprintf(_PRP_UM_REQUIRED, $CPG_SESS[$projectspro_base]['update_monitor']['current'], $CPG_SESS[$projectspro_base]['update_monitor']['url']),
			'L_POSTED_ON' => _POSTEDON,
			'S_VERSION_CURRENT' => $current_version.(version_compare($current_version, $CPG_SESS[$projectspro_base]['update_monitor']['current'], '>') ? ' '._PRP_UM_CVS : '' ),
			)
		);
		foreach($CPG_SESS[$projectspro_base]['update_monitor']['msg'] as $item) {
			$cpgtpl->assign_block_vars('update_message', array(
				'S_TITLE' => $item['title'],
				'S_DESCRIPTION' => decode_bbcode($item['desc']),
				'S_DATE' => L10NTime::strftime('%m-%d-%Y', $item['date'], $userinfo['user_dst'], $userinfo['user_timezone']),
				)
			);
		}
	} else {
		$cpgtpl->assign_vars(array(
			'B_UPDATE_FAILED' => true,
			'L_UPDATE_MONITOR' => _PRP_UM,
			'L_UPDATE_FAILED' => _PRP_UM_FAILED,
			)
		);
	}
}

/**
 * Display the project list
 **/
function ProjectsPro_projects() {
	global $prefix, $db, $pagetitle, $modheader, $cpgtpl, $CPG_SESS, $currentlang, $bgcolor2, $bgcolor3, $MAIN_CFG, $projectspro_base, $projectspro_prefix;
	
	$pagetitle .= ' '._BC_DELIM.' '._PRP_PROJECTLIST;
	$modheader .= '<style type="text/css">@import url(themes/' . $CPG_SESS['theme'] . '/style/ProjectsPro/calendar-win2k-1.css);</style>' . "\n";
	$modheader .= '<script type="text/javascript" src="includes/javascript/calendar.js"></script>' . "\n";
	$modheader .= '<script type="text/javascript" src="includes/javascript/' . $currentlang . '/calendar.js"></script>' . "\n";
	$modheader .= '<script type="text/javascript" src="includes/javascript/calendar-setup.js"></script>' . "\n";
	require_once(CORE_PATH.'nbbcode.php');
	require( 'header.php' );
	
	$status = ProjectsPro_status_get( 0 );
	$priority = ProjectsPro_priority_get();
	$position = ProjectsPro_position_get();
	$percent = array();
	for( $i = 0; $i < 101; $i++ ) {
		$percent[] = $i;
	}

	// Count the reports for each project
	$result_reports = $db->sql_query( 'SELECT p.project_id, count(r.report_id) as reports_count FROM ( ' . $projectspro_prefix.'projects p LEFT JOIN ' . $projectspro_prefix.'reports r ON p.project_id = r.project_id ) GROUP BY p.project_id', false, __FILE__, __LINE__ );
	$reports = array();
	while( list( $project_id, $reports_count ) = $db->sql_fetchrow( $result_reports, SQL_NUM ) ) {
		$reports[$project_id] = $reports_count;
	}
	$db->sql_freeresult( $result_reports );
	
	// Count the requests for each project
	$result_requests = $db->sql_query( 'SELECT p.project_id, count(re.request_id) as requests_count FROM ( ' . $projectspro_prefix.'projects p LEFT JOIN ' . $projectspro_prefix.'requests re ON p.project_id = re.project_id ) GROUP BY p.project_id', false, __FILE__, __LINE__ );
	$requests = array();
	while( list( $project_id, $requests_count ) = $db->sql_fetchrow( $result_requests, SQL_NUM ) ) {
		$requests[$project_id] = $requests_count;
	}
	$db->sql_freeresult( $result_requests );

	$result_projects = $db->sql_query( 'SELECT p.project_id, p.project_name, p.weight, p.featured, s.status_name, pr.priority_name, count(t.task_id) as tasks_count FROM ' . $projectspro_prefix.'status s, ' . $projectspro_prefix.'priorities pr, ( ' . $projectspro_prefix.'projects p LEFT JOIN ' . $projectspro_prefix.'tasks t ON p.project_id = t.project_id ) WHERE p.status_id = s.status_id AND p.priority_id = pr.priority_id GROUP BY p.project_id ORDER BY p.weight ASC, pr.weight DESC, s.weight DESC', false, __FILE__, __LINE__ );
	
	if (can_admin() && $MAIN_CFG[$projectspro_base]['update_monitor']) {
		ProjectsPro_update_monitor();
	}

	$cpgtpl->assign_vars( array(
		'L_PROJECTS' => _PRP_PROJECTS,
		'L_WEIGHT' => _WEIGHT,
		'L_STATUS' => _STATUS,
		'L_PRIORITY' => _PRP_PRIORITY,
		'L_TASKS' => _PRP_TASKS,
		'L_MEMBERS' => _PRP_MEMBERS,
		'L_FUNCTIONS' => _FUNCTIONS,
		'L_NO_PROJECTS' => _PRP_NOPROJECTS,
		'L_EDIT' => _EDIT,
		'L_DELETE' => _DELETE,
		'L_PROJECTS_UP' => _PRP_PROJECTS_UP,
		'L_PROJECTS_TOP' => _PRP_PROJECTS_TOP,
		'L_PROJECTS_DOWN' => _PRP_PROJECTS_DOWN,
		'L_PROJECTS_BOTTOM' => _PRP_PROJECTS_BOTTOM,
		'L_PROJECTS_CHANGE_STATUS' => _PRP_PROJECTSCHANGESTATUS,
		'L_PROJECTS_CHANGE_PRIORITY' => _PRP_PROJECTSCHANGEPRIORITY,
		'L_PROJECTS_CHANGE_FEATURED' => _PRP_PROJECTSCHANGEFEATURED,
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_PROJECT_DESCRIPTION' => _PRP_PROJECTDESCRIPTION,
		'L_PROJECT_FEATURED' => _PRP_FEATUREDBLOCK,
		'L_PROJECT_PRIORITY' => _PRP_PRIORITY,
		'L_PROJECT_PERCENT' => _PRP_STATUSPERCENT,
		'L_INFO_PROJECT_PERCENT' => _PRP_STATUSPERCENT_CALCULATE,
		'L_STATUS' => _PRP_STATUS,
		'L_PROJECT_START_DATE' => _PRP_STARTDATE,
		'L_PROJECT_END_DATE' => _PRP_FINISHDATE,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		'L_PERCENT' => _PRP_PERCENT,
		'L_FEATURED' => _PRP_FEATURED,
		'L_FIND_USERNAME' => _PRP_FINDUSERNAME,
		'L_USERNAME' => _PRP_USERNAME,
		'L_POSITION' => _PRP_POSITION,
		'L_REPORTS' => _PRP_REPORTS,
		'L_REQUESTS' => _PRP_REQUESTS,
		'L_CHOOSE_DATE' => _PRP_CHOOSEDATE,

		'S_BGCOLOR_2' => $bgcolor2,
		'S_PROJECTS_COUNT' => $db->sql_numrows( $result_projects ),
		'S_FORM_OPEN_PROJECT' => open_form( adminlink('&amp;mode=save&amp;project_id=0' ), 'post', _PRP_PROJECTADD ),
		'S_FORM_CLOSE_PROJECT' => close_form(),
		
		'S_PROJECT_NAME' => '',
		'S_PROJECT_NAME_HTML' => htmlprepare(''),
		'S_BBCODE_PROJECTS' => bbcode_table( 'project_description', 'post', 1 ),
		'S_PROJECT_DESCRIPTION' => '',
		'S_PROJECT_FEATURED' => yesno_option( 'featured', 0 ),
		'S_PROJECT_PRIORITY' => select_box( 'priority_id', '', $priority ),
		'S_PROJECT_PERCENT' => select_option( 'project_percent', 0, $percent ),
		'S_STATUS' => select_box( 'status_id', '', $status ),
		'S_DATE_START' => formatDateTime( gmtime(), '%m-%d-%Y' ),
		'S_DATE_END' => '',
		'S_DATE_FORMAT' => '%m-%d-%Y',
		'S_POSITION' => select_box( 'position_id', '', $position ),
		'S_USERNAME' => '',

		'U_FIND_USERNAME' => getlink( 'Forums&amp;file=search&amp;mode=searchuser&amp;popup=1&amp;menu=1' ),
		'U_FIND_USERNAME_FAKE' => adminlink('#', true ),
		)
	);
	
	$bgcolor = $bgcolor3;
	while( list( $project_id, $project_name, $weight, $featured, $status_name, $priority_name, $tasks_count ) = $db->sql_fetchrow( $result_projects, SQL_NUM ) ) {
		$bgcolor = ( $bgcolor == '' ) ? $bgcolor3 : '';
		$cpgtpl->assign_block_vars( 'project', array(
			'B_FEATURED' => $featured,

			'S_BGCOLOR' => $bgcolor,
			'S_PROJECT_NAME' => $project_name,
			'S_PROJECT_NAME_HTML' => htmlprepare($project_name),
			'S_STATUS' => $status_name,
			'S_STATUS_HTML' => htmlprepare($status_name),
			'S_PRIORITY' => $priority_name,
			'S_PRIORITY_HTML' => htmlprepare($priority_name),
			'S_TASKS_COUNT' => $tasks_count,
			'S_REPORTS_COUNT' => $reports[$project_id],
			'S_REQUESTS_COUNT' => $requests[$project_id],

			'U_UP' => 1 < $weight ? adminlink('&amp;mode=up&amp;project_id=' . $project_id ) : '',
			'U_TOP' => 1 < $weight ? adminlink('&amp;mode=top&amp;project_id=' . $project_id ) : '',
			'U_DOWN' => $db->sql_numrows( $result_projects ) > $weight ? adminlink('&amp;mode=down&amp;project_id=' . $project_id ) : '',
			'U_BOTTOM' => $db->sql_numrows( $result_projects ) > $weight ? adminlink('&amp;mode=bottom&amp;project_id=' . $project_id ) : '',
			'U_STATUS' => adminlink('&amp;mode=changestatus&amp;project_id=' . $project_id ),
			'U_PRIORITY' => adminlink('&amp;mode=changepriority&amp;project_id=' . $project_id ),
			'U_FEATURED' => adminlink('&amp;mode=changefeatured&amp;project_id=' . $project_id ),
			'U_TASKS' => adminlink('&amp;file=tasks&amp;project_id=' . $project_id ),
			'U_REPORTS' => adminlink('&amp;file=reports&amp;project_id=' . $project_id ),
			'U_REQUESTS' => adminlink('&amp;file=requests&amp;project_id=' . $project_id ),
			'U_MEMBERS' => adminlink('&amp;file=projects_members&amp;project_id=' . $project_id ),
			'U_EDIT' => adminlink('&amp;mode=edit&amp;project_id=' . $project_id ),
			'U_DELETE' => adminlink('&amp;mode=delete&amp;project_id=' . $project_id ),
			)
		);
	}
	$db->sql_freeresult( $result_projects );

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	if ($MAIN_CFG[$projectspro_base]['update_monitor']) {
		$cpgtpl->set_filenames( array( 'update_monitor' => 'ProjectsPro/admin/update_monitor.html' ) );
		$cpgtpl->display( 'update_monitor' );
	}
	$cpgtpl->set_filenames( array( 'projects' => 'ProjectsPro/admin/projects.html' ) );
	$cpgtpl->display( 'projects' );
	$cpgtpl->set_filenames( array( 'edit' => 'ProjectsPro/admin/projects_edit.html' ) );
	$cpgtpl->display( 'edit' );
	CloseTable();
}

/**
 * Feature/unfeature the project
 **/
function ProjectsPro_projects_change_featured() {
  global $prefix, $db, $CPG_SESS, $projectspro_base, $projectspro_prefix;
  
	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

  // Verify a valid project id
  $project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
  if ( 0 == $project_id ) {
    url_redirect( adminlink());
  }

  // Change the featured status
  list( $featured ) = $db->sql_ufetchrow( 'SELECT featured FROM ' . $projectspro_prefix.'projects WHERE project_id = ' . $project_id, SQL_NUM, __FILE__, __LINE__ );
  if ( is_numeric( $project_id ) ) {
    $db->sql_query( 'UPDATE ' . $projectspro_prefix.'projects SET featured = ' . intval( !$featured ) . ' WHERE project_id = ' . $project_id, false, __FILE__, __LINE__ );
  }
  
  // Forward the user back to the main pages
  url_redirect( adminlink() );
}

/**
 * Change a projects status
 **/
function ProjectsPro_projects_change_status() {
	global $prefix, $db, $CPG_SESS, $projectspro_base, $projectspro_prefix;

	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

	// Verify a valid project id
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	if ( 0 == $project_id ) {
		url_redirect( adminlink() );
	}
	
	// Get the current status from the database
	list( $status_id ) = $db->sql_ufetchrow( 'SELECT status_id FROM ' . $projectspro_prefix.'projects WHERE project_id = ' . $project_id, SQL_NUM, __FILE__, __LINE__ );
	
	// Change the status to the next in the list
	$status = ProjectsPro_status_get( 0 );
	$keys = array_keys( $status );
	$key = array_search( intval( $status_id ), $keys );
	if ( is_numeric( $key ) ) {
		for( $i = $key; $i < count( $keys ); $i++ ) {
			if ( $status_id == $keys[$i] ) {
				if ( $i == ( count( $keys ) - 1 ) ) {
					$status_id = $keys[0];
				}
				else {
					$status_id = $keys[$i+1];
				}
				break;
			}
		}
	} else {
		$status_id = $keys[0];
	}
	$db->sql_query( 'UPDATE ' . $projectspro_prefix.'projects SET status_id = ' . $status_id . ' WHERE project_id = ' . $project_id, false, __FILE__, __LINE__ );
	
	url_redirect( adminlink() );
}

/**
 * Change a projects priority
 **/
function ProjectsPro_projects_change_priority() {
	global $prefix, $db, $CPG_SESS, $projectspro_base, $projectspro_prefix;

	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

	// Verify a valid project id
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	if ( 0 == $project_id ) {
		url_redirect( adminlink() );
	}
	
	// Get the current status from the database
	list( $priority_id ) = $db->sql_ufetchrow( 'SELECT priority_id FROM ' . $projectspro_prefix.'projects WHERE project_id = ' . $project_id, SQL_NUM, __FILE__, __LINE__ );
	
	// Change the status to the next in the list
	$priority = ProjectsPro_priority_get();
	$keys = array_keys( $priority );
	$key = array_search( intval( $priority_id ), $keys );
	for( $i = $key; $i < count( $keys ); $i++ ) {
		if ( $priority_id == $keys[$i] ) {
			if ( $i == ( count( $keys ) - 1 ) ) {
				$priority_id = $keys[0];
			}
			else {
				$priority_id = $keys[$i+1];
			}
			break;
		}
	}
	$db->sql_query( 'UPDATE ' . $projectspro_prefix.'projects SET priority_id = ' . $priority_id . ' WHERE project_id = ' . $project_id, false, __FILE__, __LINE__ );
	
	url_redirect( adminlink() );
}

/**
 * Move projects up
 **/
function ProjectsPro_projects_move( $mode ) {
	global $prefix, $db, $CPG_SESS, $projectspro_base, $projectspro_prefix;

	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

	// Verify a valid project id
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	if ( 0 == $project_id ) {
		url_redirect( adminlink() );
	}

	switch( $mode ) {
		case 'up':
		case 'top':
			$dir = -1;
			break;
		default:
			$dir = 1;
			break;
	}

	// Only move the project if it has somewhere to go
	switch( $mode ) {
		case 'up':
		case 'down':
			// Move the project up or down
			list( $weight ) = $db->sql_ufetchrow( 'SELECT weight FROM ' . $projectspro_prefix.'projects WHERE project_id = ' . $project_id, SQL_NUM, __FILE__, __LINE__ );
			list( $weight_max ) = $db->sql_ufetchrow( 'SELECT weight FROM ' . $projectspro_prefix."projects ORDER BY weight DESC LIMIT 0, 1", SQL_NUM, __FILE__, __LINE__ );
			if ( ( 0 > $dir && 1 < intval( $weight ) ) || ( 0 < $dir && intval( $weight ) < intval( $weight_max ) ) ) {
				// First, move the other project up, and then this project down (or vice versa)
				$result = $db->sql_query( 'UPDATE ' . $projectspro_prefix.'projects SET weight = weight - ' . $dir . " WHERE weight = " . ( intval( $weight ) + $dir ), false, __FILE__, __LINE__ );
				$result = $db->sql_query( 'UPDATE ' . $projectspro_prefix.'projects SET weight = weight + ' . $dir . ' WHERE project_id = ' . $project_id, false, __FILE__, __LINE__ );
			}
			break;
		case 'top':
		case 'bottom':
			// Move the project to the top
			list( $weight ) = $db->sql_ufetchrow( 'SELECT weight FROM ' . $projectspro_prefix.'projects WHERE project_id = ' . $project_id, SQL_NUM, __FILE__, __LINE__ );
			list( $weight_max ) = $db->sql_ufetchrow( 'SELECT weight FROM ' . $projectspro_prefix."projects ORDER BY weight DESC LIMIT 0, 1", SQL_NUM, __FILE__, __LINE__ );
			if ( ( 0 > $dir && 1 < intval( $weight ) ) || ( 0 < $dir && intval( $weight ) < intval( $weight_max ) ) ) {
				// First, move the other projects up or down, then this project
				$result = $db->sql_query( 'UPDATE ' . $projectspro_prefix.'projects SET weight = weight - ' . $dir . " WHERE weight " . ( 0 < $dir ? '>' : '<' ) . ' ' . $weight, false, __FILE__, __LINE__ );
				$result = $db->sql_query( 'UPDATE ' . $projectspro_prefix.'projects SET weight = ' . ( 0 < $dir ? intval( $weight_max ) : '1' ) . ' WHERE project_id = ' . $project_id, false, __FILE__, __LINE__ );
			}
			break;
		default:
			break;
	}
	
	// Forward the user back to home
	url_redirect( adminlink() );
}

/**
 * Delete the project
 **/
function ProjectsPro_projects_delete() {
	global $prefix, $db, $projectspro_prefix;
	
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	
	// User cancelled or an invalid project id
	if ( 0 == $project_id || isset( $_POST['cancel'] ) ) {
		url_redirect( adminlink() );
	}
	
	// User confirmed the delete
	if ( isset( $_POST['confirm'] ) ) {
		// Verify the project_id is valid so we don't do extra work
		list( $weight ) = $db->sql_ufetchrow( 'SELECT weight from ' . $projectspro_prefix.'projects where project_id = ' . $project_id, SQL_NUM, __FILE__, __LINE__ );
		if ( !is_numeric( $weight ) ) {
			url_redirect( adminlink() );
		}

		// Delete the members of the projects' tasks first
		$result_tasks = $db->sql_query( 'SELECT task_id FROM ' . $projectspro_prefix.'tasks WHERE project_id = ' . $project_id, false, __FILE__, __LINE__ );
		$task_ids = array();
		while( list( $task_id ) = $db->sql_fetchrow( $result_tasks, SQL_NUM ) ) {
			$task_ids[] = $task_id;
		}
		$db->sql_freeresult( $result_tasks );
		if ( count( $task_ids ) ) {
			$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'tasks_members WHERE task_id in (' . implode( ',', $task_ids ) . ')', false, __FILE__, __LINE__ );
			$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'tasks_members' , false, __FILE__, __LINE__ );
			$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'tasks WHERE task_id in (' . implode( ',', $task_ids ) . ')', false, __FILE__, __LINE__ );
			$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'tasks' , false, __FILE__, __LINE__ );
		}
		
		// Now delete the members of the project
		$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'projects_members WHERE project_id = ' . $project_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'projects_members' , false, __FILE__, __LINE__ );
		
		// Move the other projects up, then delete the project
		$db->sql_query( 'UPDATE ' . $projectspro_prefix."projects SET weight = weight - 1 WHERE weight > " . $weight, false, __FILE__, __LINE__ );
		$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'projects WHERE project_id = ' . $project_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'projects' , false, __FILE__, __LINE__ );
		
		
		url_redirect( adminlink() );
	}
	
	// Display the confirmation message
	$project = ProjectsPro_project_get( $project_id );
	cpg_delete_msg( adminlink('&amp;mode=delete&amp;project_id=' . $project_id ), sprintf( _ERROR_DELETE_CONF, '<strong>' . htmlprepare($project['project_name']) . '</strong>' ) );
}

/**
 * Edit/Add a project
 **/
function ProjectsPro_projects_edit() {
	global $prefix, $db, $pagetitle, $modheader, $cpgtpl, $CPG_SESS, $currentlang;
	
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	
	// Invalid project id
	if ( 0 == $project_id ) {
		url_redirect( adminlink() );
	}
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_PROJECTEDIT;
	$modheader .= '<style type="text/css">@import url(themes/' . $CPG_SESS['theme'] . '/style/ProjectsPro/calendar-win2k-1.css);</style>' . "\n";
	$modheader .= '<script type="text/javascript" src="includes/javascript/calendar.js"></script>' . "\n";
	$modheader .= '<script type="text/javascript" src="includes/javascript/' . $currentlang . '/calendar.js"></script>' . "\n";
	$modheader .= '<script type="text/javascript" src="includes/javascript/calendar-setup.js"></script>' . "\n";
	require_once(CORE_PATH.'nbbcode.php');
	require( 'header.php' );
	
	$project = ProjectsPro_project_get( $project_id );
	$priority = ProjectsPro_priority_get();
	$status = ProjectsPro_status_get( 0 );
	
	$percent = array();
	for( $i = 0; $i < 101; $i++ ) {
		$percent[] = $i;
	}
	
	$cpgtpl->assign_vars( array(
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_PROJECT_DESCRIPTION' => _PRP_PROJECTDESCRIPTION,
		'L_PROJECT_FEATURED' => _PRP_FEATUREDBLOCK,
		'L_PROJECT_PRIORITY' => _PRP_PRIORITY,
		'L_PROJECT_PERCENT' => _PRP_STATUSPERCENT,
		'L_INFO_PROJECT_PERCENT' => _PRP_STATUSPERCENT_CALCULATE,
		'L_STATUS' => _PRP_STATUS,
		'L_PROJECT_START_DATE' => _PRP_STARTDATE,
		'L_PROJECT_END_DATE' => _PRP_FINISHDATE,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		'L_PERCENT' => _PRP_PERCENT,
		'L_CHOOSE_DATE' => _PRP_CHOOSEDATE,
		
		'S_FORM_OPEN_PROJECT' => open_form( adminlink('&amp;mode=save&amp;project_id=' . $project_id ), 'post', _PRP_PROJECTEDIT ),
		'S_FORM_CLOSE_PROJECT' => close_form(),
		
		'S_PROJECT_NAME' => $project['project_name'],
		'S_PROJECT_NAME_HTML' => htmlprepare( $project['project_name'] ),
		'S_BBCODE_PROJECTS' => bbcode_table( 'project_description', 'post', 1 ),
		'S_PROJECT_DESCRIPTION' => htmlprepare( $project['project_description'] ),
		'S_PROJECT_FEATURED' => yesno_option( 'featured', $project['featured'] ),
		'S_PROJECT_PRIORITY' => select_box( 'priority_id', $project['priority_id'], $priority ),
		'S_PROJECT_PERCENT' => select_option( 'project_percent', $project['project_percent'], $percent ),
		'S_STATUS' => select_box( 'status_id', $project['status_id'], $status ),
		'S_DATE_START' => ( 0 == $project['date_started'] ? '' : L10NTime::strftime('%m-%d-%Y', $project['date_started'], 0, 0) ),
		'S_DATE_END' => ( 0 == $project['date_finished'] ? '' : L10NTime::strftime('%m-%d-%Y', $project['date_finished'], 0, 0) ),
		'S_DATE_FORMAT' => '%m-%d-%Y',

		'U_FIND_USERNAME' => '',
		)
	);
	
	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'projects_edit' => 'ProjectsPro/admin/projects_edit.html' ) );
	$cpgtpl->display( 'projects_edit' );
	CloseTable();
}

/**
 * Save a project
 * A project_id of 0 (zero) indicates a new project
 **/
function ProjectsPro_projects_save() {
	global $prefix, $user_prefix, $db, $projectspro_prefix;
	
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	$project_name = isset( $_POST['project_name'] ) ? Fix_Quotes( $_POST['project_name'] ) : '';
	$project_description = isset( $_POST['project_description'] ) ? Fix_Quotes( $_POST['project_description'] ) : '';
	$featured = isset( $_POST['featured'] ) ? intval( $_POST['featured'] ) : 0;
	$priority_id = isset( $_POST['priority_id'] ) ? intval( $_POST['priority_id'] ) : 0;
	$project_percent = isset( $_POST['project_percent'] ) ? intval( $_POST['project_percent'] ) : 0;
	$status_id = isset( $_POST['status_id'] ) ? intval( $_POST['status_id'] ) : 0;
	$start_date = isset( $_POST['start_date'] ) ? explode( '-', $_POST['start_date'] ) : array();
	$end_date = isset( $_POST['end_date'] ) ? explode( '-', $_POST['end_date'] ) : array();
	$date_started = 0;
	$date_finished = 0;
	if ( 3 == count( $start_date ) ) {
		$date_started = mktime( 0, 0, 1, $start_date[0], $start_date[1], $start_date[2] );
	}
	if ( 3 == count( $end_date ) ) {
		$date_finished = mktime( 0, 0, 1, $end_date[0], $end_date[1], $end_date[2] );
	}
	if ( 100 < $project_percent ) {
		$project_percent = 100;
	} elseif ( 0 > $project_percent ) {
		$project_percent = 0;
	}
	
	if ( 0 < $project_id ) {
		$db->sql_query( 'UPDATE ' . $projectspro_prefix."projects SET project_name = '" . $project_name . "', project_description = '" . $project_description . "', priority_id = " . $priority_id . ', status_id = ' . $status_id . ', project_percent = ' . $project_percent . ', featured = ' . $featured . ', date_started = ' . $date_started . ', date_finished = ' . $date_finished . ' WHERE project_id = ' . $project_id, false, __FILE__, __LINE__ );
	} else {
		list( $weight ) = $db->sql_ufetchrow( 'SELECT MAX(weight) as weight FROM ' . $projectspro_prefix.'projects', SQL_NUM, __FILE__, __LINE__ );
		$db->sql_query( 'INSERT INTO ' . $projectspro_prefix."projects (project_name, project_description, priority_id, status_id, project_percent, weight, featured, date_created, date_started, date_finished) VALUES ('" . $project_name . "', '" . $project_description . "', " . $priority_id . ', ' . $status_id . ', ' . $project_percent . ', ' . ( intval( $weight ) + 1 ) . ', ' . $featured . ', ' . gmtime() . ', ' . $date_started . ', ' . $date_finished . ')', false, __FILE__, __LINE__ );
		$project_id = $db->sql_nextid( 'project_id' );
	}

	// Add the default member
	$username = isset( $_POST['username'] ) ? $_POST['username'] : '';
	$position_id = isset( $_POST['position_id'] ) ? intval( $_POST['position_id'] ) : 0;
	
	if ( '' != $username ) {
		list( $user_id ) = $db->sql_ufetchrow( 'SELECT user_id FROM ' . $user_prefix . "_users WHERE username = '" . Fix_Quotes( $username ) . "'", SQL_NUM, __FILE__, __LINE__ );
		if ( is_numeric( $user_id ) ) {
			// Add the user to the project
			$db->sql_query( 'INSERT INTO ' . $projectspro_prefix.'projects_members (project_id, user_id, position_id) VALUES (' . $project_id . ', ' . $user_id . ', ' . $position_id . ')', false, __FILE__, __LINE__ );
		}
	}

	url_redirect( adminlink() );
}

get_lang('ProjectsPro');
require_once(BASEDIR.'includes/ProjectsPro/admin.php');

$pagetitle = _PRP_ADMINMENU;

$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');

switch ($mode) {
	case 'changefeatured':
		ProjectsPro_projects_change_featured();
		break;
	case 'changestatus':
		ProjectsPro_projects_change_status();
		break;
	case 'changepriority':
		ProjectsPro_projects_change_priority();
		break;
	case 'up':
	case 'down':
	case 'top':
	case 'bottom':
		ProjectsPro_projects_move( $mode );
		break;
	case 'delete':
		ProjectsPro_projects_delete();
		break;
	case 'edit':
		ProjectsPro_projects_edit();
		break;
	case 'save':
		ProjectsPro_projects_save();
		break;
	default:
		ProjectsPro_projects();
		break;
}
