<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Administrate the position list                                    |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 201 $
| $Author: jday29 $
| $Date: 2006-05-22 15:08:18 -0500 (Mon, 22 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'ADMIN_PAGES' ) ) {
	exit;
}
if ( !can_admin( $module_name ) ) {
	die( 'Access Denied' );
}

$projectspro_base = basename(dirname(dirname(__FILE__)));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the position list
 **/
function ProjectsPro_position() {
	global $pagetitle, $cpgtpl;
	global $bgcolor2, $bgcolor3;
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_POSITIONS;
	require_once(CORE_PATH.'nbbcode.php');
	require( 'header.php' );
	
	$cpgtpl->assign_vars( array(
		'L_FUNCTIONS' => _FUNCTIONS,
		'L_EDIT' => _EDIT,
		'L_DELETE' => _DELETE,
		'L_POSITION_NAME' => _PRP_POSITIONNAME,
		'L_POSITION_DESCRIPTION' => _PRP_POSITIONDESCRIPTION,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		
		'S_BGCOLOR_2' => $bgcolor2,
		'S_POSITION_NAME_HTML' => htmlprepare(''),
		'S_POSITION_DESCRIPTION' => '',
		'S_BBCODE_POSITION' => bbcode_table( 'position_description', 'positionedit', 1 ),

		'S_FORM_OPEN_POSITION' => open_form( adminlink('&amp;file=position&amp;mode=save&amp;position_id=0' ), 'positionedit', _PRP_POSITIONADD ),
		'S_FORM_CLOSE_POSITION' => close_form(),
		)
	);

	$bgcolor = $bgcolor3;
	$position = ProjectsPro_position_get();
	foreach( $position as $position_id => $position_name ) {
		$bgcolor = ( $bgcolor == '' ) ? $bgcolor3 : '';
		$cpgtpl->assign_block_vars( 'position', array(
			'S_BGCOLOR' => $bgcolor,
			'S_POSITION_NAME_HTML' => $position_name,

			'U_EDIT' => adminlink('&amp;file=position&amp;mode=edit&amp;position_id=' . $position_id ),
			'U_DELETE' => 1 < count( $position ) ? adminlink('&amp;file=position&amp;mode=delete&amp;position_id=' . $position_id ) : '',
			)
		);
	}

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'position' => 'ProjectsPro/admin/position.html' ) );
	$cpgtpl->display( 'position' );
	$cpgtpl->set_filenames( array( 'position_edit' => 'ProjectsPro/admin/position_edit.html' ) );
	$cpgtpl->display( 'position_edit' );
	CloseTable();
}

/**
 * Edit a position
 **/
function ProjectsPro_position_edit() {
	global $prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_POSITIONEDIT;
	require_once(CORE_PATH.'nbbcode.php');
	require( 'header.php' );
	
	$position_id = isset( $_GET['position_id'] ) ? intval( $_GET['position_id'] ) : 0;
	
	// Invalid position id
	if ( 0 == $position_id ) {
		url_redirect( adminlink('&amp;file=position' ) );
	}

	list( $position_id, $position_name, $position_description ) = $db->sql_ufetchrow( 'SELECT position_id, position_name, position_description FROM ' . $projectspro_prefix.'positions WHERE position_id = ' . $position_id, SQL_NUM, __FILE__, __LINE__ );
	if ( !is_numeric( $position_id ) ) {
		url_redirect( adminlink('&amp;file=position' ) );
	}

	$cpgtpl->assign_vars( array(
		'L_POSITION_NAME' => _PRP_POSITIONNAME,
		'L_POSITION_DESCRIPTION' => _PRP_POSITIONDESCRIPTION,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		
		'S_POSITION_NAME' => $position_name,
		'S_POSITION_NAME_HTML' => htmlprepare( $position_name ),
		'S_POSITION_DESCRIPTION' => htmlprepare( $position_description ),
		'S_BBCODE_POSITION' => bbcode_table( 'position_description', 'positionedit', 1 ),

		'S_FORM_OPEN_POSITION' => open_form( adminlink('&amp;file=position&amp;mode=save&amp;position_id=' . $position_id ), 'positionedit', _PRP_POSITIONEDIT ),
		'S_FORM_CLOSE_POSITION' => close_form(),
		)
	);

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'position_edit' => 'ProjectsPro/admin/position_edit.html' ) );
	$cpgtpl->display( 'position_edit' );
	CloseTable();
}

/**
 * Save the position
 **/
function ProjectsPro_position_save() {
	global $prefix, $db, $projectspro_prefix;
	
	$position_id = isset( $_GET['position_id'] ) ? intval( $_GET['position_id'] ) : 0;
	$position_name = isset( $_POST['position_name'] ) ? Fix_Quotes( $_POST['position_name'] ) : '';
	$position_description = isset( $_POST['position_description'] ) ? Fix_Quotes( $_POST['position_description'] ) : '';
	
	if ( '' == $position_name ) {
		cpg_error( _PRP_INVALIDPOSITIONNAME );
	}
	
	if ( 0 < $position_id ) {
		$db->sql_query( 'UPDATE ' . $projectspro_prefix."positions SET position_name = '" . $position_name . "', position_description = '" . $position_description . "' WHERE position_id = " . $position_id, false, __FILE__, __LINE__ );
	} else {
		$db->sql_query( 'INSERT INTO ' . $projectspro_prefix."positions (position_name, position_description) VALUES ('" . $position_name . "', '" . $position_description . "')", false, __FILE__, __LINE__ );
	}
	
	url_redirect( adminlink('&amp;file=position' ) );	
}

/**
 * Delete the position
 **/
function ProjectsPro_position_delete() {
	global $prefix, $db, $cpgtpl, $projectspro_prefix;
	
	$position_id = isset( $_GET['position_id'] ) ? intval( $_GET['position_id'] ) : 0;
	$new_position_id = isset( $_POST['position_id'] ) ? intval( $_POST['position_id'] ) : 0;
	
	// User cancelled or an invalid position id
	if ( 0 == $position_id || isset( $_POST['cancel'] ) ) {
		url_redirect( adminlink('&amp;file=position' ) );
	}
	
	if ( 1 == $db->sql_count( $projectspro_prefix.'positions' ) ) {
		cpg_error( _PRP_CANNOTDELETEPOSITION );
	}
	
	// User confirmed the delete
	if ( isset( $_POST['confirm'] ) ) {
		if ( 0 == $new_position_id ) {
			url_redirect( adminlink('&amp;file=position&amp;mode=delete&amp;position_id=' . $position_id ) );
		}
		$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'positions WHERE position_id = ' . $position_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'positions' , false, __FILE__, __LINE__ );
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'projects_members SET position_id = ' . $new_position_id . ' WHERE position_id = ' . $position_id, false, __FILE__, __LINE__ );
		
		url_redirect( adminlink('&amp;file=position' ) );
	}
	
	$position = ProjectsPro_position_get();
	$position_name = $position[$position_id];
	unset( $position[$position_id] );
	
	$cpgtpl->assign_vars( array(
		'L_DELETE' => _DELETE,
		'L_CANCEL' => _PRP_CANCEL,
		'L_SWAP_POSITION' => sprintf( _PRP_SWAPPOSITION, $position_name ),
		'L_POSITION_NAME' => _PRP_POSITIONNAME,
		
		'S_FORM_OPEN_POSITION' => open_form( adminlink('&amp;file=position&amp;mode=delete&amp;position_id=' . $position_id ), 'positiondelete', _PRP_POSITIONDELETE ),
		'S_FORM_CLOSE_POSITION' => close_form(),
		
		'S_POSITION_ID' => select_box( 'position_id', '', $position ),
		)
	);
	
	// Display the confirmation message
	require( 'header.php' );
	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'position_delete' => 'ProjectsPro/admin/position_delete.html' ) );
	$cpgtpl->display( 'position_delete' );
	CloseTable();
}

get_lang('ProjectsPro');
require_once(BASEDIR.'includes/ProjectsPro/admin.php');

$pagetitle = _PRP_ADMINMENU;

$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch ($mode) {
	case 'edit':
		ProjectsPro_position_edit();
		break;
	case 'save':
		ProjectsPro_position_save();
		break;
	case 'delete':
		ProjectsPro_position_delete();
		break;
	default:
		ProjectsPro_position();
		break;
}