<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly™ CMS                                                |
| Copyright © 2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum™ Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright © 2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Administrate the priority list                                    |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 201 $
| $Author: jday29 $
| $Date: 2006-05-22 15:08:18 -0500 (Mon, 22 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright © 2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'ADMIN_PAGES' ) ) {
	exit;
}
if ( !can_admin( $module_name ) ) {
	die( 'Access Denied' );
}

$projectspro_base = basename(dirname(dirname(__FILE__)));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the priority list
 **/
function ProjectsPro_priority() {
	global $prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	global $bgcolor2, $bgcolor3;
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_PRIORITYLIST;
	require( 'header.php' );
	
	$result_priority = $db->sql_query( 'SELECT priority_id, priority_name, weight FROM ' . $projectspro_prefix.'priorities ORDER BY weight ASC, priority_name ASC', false, __FILE__, __LINE__ );

	$cpgtpl->assign_vars( array(
		'L_PRIORITY_OPTIONS' => _PRP_PRIORITYOPTIONS,
		'L_PRIORITY_ADD' => _PRP_PRIORITYADD,
		'L_PRIORITIES' => _PRP_PRIORITIES,
		'L_FUNCTIONS' => _FUNCTIONS,
		'L_NO_PRIORITIES' => _PRP_NOPRIORITY,
		'L_WEIGHT' => _WEIGHT,
		'L_EDIT' => _EDIT,
		'L_DELETE' => _DELETE,
		'L_PRIORITY_UP' => _PRP_PRIORITY_UP,
		'L_PRIORITY_TOP' => _PRP_PRIORITY_TOP,
		'L_PRIORITY_DOWN' => _PRP_PRIORITY_DOWN,
		'L_PRIORITY_BOTTOM' => _PRP_PRIORITY_BOTTOM,
		'L_PRIORITY_NAME' => _PRP_PRIORITYNAME,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		
		'S_BGCOLOR_2' => $bgcolor2,
		'S_PRIORITY_NAME' => '',
		'S_PRIORITY_NAME_HTML' => '',
		
		'S_FORM_OPEN_PRIORITY' => open_form( adminlink('&amp;file=priority&amp;mode=save&amp;priority_id=0' ), 'priorityadd', _PRP_PRIORITYADD ),
		'S_FORM_CLOSE_PRIORITY' => close_form(),
		)
	);

	$bgcolor = $bgcolor3;
	while( list( $priority_id, $priority_name, $weight ) = $db->sql_fetchrow( $result_priority, SQL_NUM ) ) {
		$bgcolor = ( $bgcolor == '' ) ? $bgcolor3 : '';
		$cpgtpl->assign_block_vars( 'priority', array(
			'S_BGCOLOR' => $bgcolor,
			'S_PRIORITY_NAME' => $priority_name,
			'S_PRIORITY_NAME_HTML' => htmlprepare($priority_name),

			'U_UP' => 1 < $weight ? adminlink('&amp;file=priority&amp;mode=up&amp;priority_id=' . $priority_id ) : '',
			'U_TOP' => 1 < $weight ? adminlink('&amp;file=priority&amp;mode=top&amp;priority_id=' . $priority_id ) : '',
			'U_DOWN' => $db->sql_numrows( $result_priority ) > $weight ? adminlink('&amp;file=priority&amp;mode=down&amp;priority_id=' . $priority_id ) : '',
			'U_BOTTOM' => $db->sql_numrows( $result_priority ) > $weight ? adminlink('&amp;file=priority&amp;mode=bottom&amp;priority_id=' . $priority_id ) : '',
			'U_EDIT' => adminlink('&amp;file=priority&amp;mode=edit&amp;priority_id=' . $priority_id ),
			'U_DELETE' => 1 < $db->sql_numrows( $result_priority ) ? adminlink('&amp;file=priority&amp;mode=delete&amp;priority_id=' . $priority_id ) : '',
			)
		);
	}
	$db->sql_freeresult( $result_priority );

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'priority' => 'ProjectsPro/admin/priority.html' ) );
	$cpgtpl->display( 'priority' );
	$cpgtpl->set_filenames( array( 'priority_edit' => 'ProjectsPro/admin/priority_edit.html' ) );
	$cpgtpl->display( 'priority_edit' );
	CloseTable();
}

/**
 * Edit a project status
 **/
function ProjectsPro_priority_edit() {
	global $prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_PRIORITYEDIT;

	require( 'header.php' );
	
	$priority_id = isset( $_GET['priority_id'] ) ? intval( $_GET['priority_id'] ) : 0;
	
	// Invalid priority id
	if ( 0 == $priority_id ) {
		url_redirect( adminlink('&amp;file=priority' ) );
	}

	list( $priority_id, $priority_name ) = $db->sql_ufetchrow( 'SELECT priority_id, priority_name FROM ' . $projectspro_prefix.'priorities WHERE priority_id = ' . $priority_id, SQL_NUM, __FILE__, __LINE__ );
	if ( !is_numeric( $priority_id ) ) {
		url_redirect( adminlink('&amp;file=priority' ) );
	}

	$cpgtpl->assign_vars( array(
		'L_PRIORITY_NAME' => _PRP_PRIORITYNAME,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		
		'S_PRIORITY_NAME' => $priority_name,
		'S_PRIORITY_NAME_HTML' => htmlprepare( $priority_name ),

		'S_FORM_OPEN_PRIORITY' => open_form( adminlink('&amp;file=priority&amp;mode=save&amp;priority_id=' . $priority_id ), 'priorityedit', _PRP_PRIORITYEDIT ),
		'S_FORM_CLOSE_PRIORITY' => close_form(),
		)
	);

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'priority_edit' => 'ProjectsPro/admin/priority_edit.html' ) );
	$cpgtpl->display( 'priority_edit' );
	CloseTable();
}

/**
 * Save the priority
 **/
function ProjectsPro_priority_save() {
	global $prefix, $db, $projectspro_prefix;
	
	$priority_id = isset( $_GET['priority_id'] ) ? intval( $_GET['priority_id'] ) : 0;
	$priority_name = isset( $_POST['priority_name'] ) ? Fix_Quotes( $_POST['priority_name'] ) : '';

	if ( '' == $priority_name ) {
		cpg_error( _PRP_INVALIDPRIORITYNAME );
	}
	
	if ( 0 < $priority_id ) {
		$db->sql_query( 'UPDATE ' . $projectspro_prefix."priorities SET priority_name = '" . $priority_name . "' WHERE priority_id = " . $priority_id, false, __FILE__, __LINE__ );
	} else {
		list( $weight ) = $db->sql_ufetchrow( 'SELECT MAX(weight) as weight FROM ' . $projectspro_prefix.'priorities', SQL_NUM, __FILE__, __LINE__ );
		$db->sql_query( 'INSERT INTO ' . $projectspro_prefix."priorities (priority_name, weight) VALUES ('" . $priority_name . "', " . ( $weight + 1 ) . ')', false, __FILE__, __LINE__ );
	}
	
	url_redirect( adminlink('&amp;file=priority' ) );	
}

/**
 * Delete the priority
 **/
function ProjectsPro_priority_delete() {
	global $prefix, $db, $cpgtpl, $projectspro_prefix;
	
	$priority_id = isset( $_GET['priority_id'] ) ? intval( $_GET['priority_id'] ) : 0;
	$new_priority_id = isset( $_POST['priority_id'] ) ? intval( $_POST['priority_id'] ) : 0;
	
	// User cancelled or an invalid priority id
	if ( 0 == $priority_id || isset( $_POST['cancel'] ) ) {
		url_redirect( adminlink('&amp;file=priority' ) );
	}
	
	if ( 1 == $db->sql_count( $projectspro_prefix.'priorities' ) ) {
		cpg_error( _PRP_CANNOTDELETEPRIORITY );
	}
	
	// User confirmed the delete
	if ( isset( $_POST['confirm'] ) ) {
		if ( 0 == $new_priority_id ) {
			url_redirect( adminlink('&amp;file=priority&amp;mode=delete&amp;priority_id=' . $priority_id ) );
		}
		
		// Verify the priority_id is valid so we don't do extra work
		list( $weight ) = $db->sql_ufetchrow( 'SELECT weight from ' . $projectspro_prefix.'priorities where priority_id = ' . $priority_id, SQL_NUM, __FILE__, __LINE__ );
		if ( !is_numeric( $weight ) ) {
			url_redirect( adminlink('&amp;file=priority' ) );
		}
		
		// Move the other priorities up, then delete the priority
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'priorities SET weight = weight - 1 WHERE weight > ' . $weight, false, __FILE__, __LINE__ );
		$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'priorities WHERE priority_id = ' . $priority_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'priorities' , false, __FILE__, __LINE__ );
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'projects SET priority_id = ' . $new_priority_id . ' WHERE priority_id = ' . $priority_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'tasks SET priority_id = ' . $new_priority_id . ' WHERE priority_id = ' . $priority_id, false, __FILE__, __LINE__ );
		
		url_redirect( adminlink('&amp;file=priority' ) );
	}
	
	$priority = ProjectsPro_priority_get();
	$priority_name = $priority[$priority_id];
	unset( $priority[$priority_id] );
	
	$cpgtpl->assign_vars( array(
		'L_DELETE' => _DELETE,
		'L_CANCEL' => _PRP_CANCEL,
		'L_SWAP_PRIORITY' => sprintf( _PRP_PRIORITYSWAP, $priority_name ),
		'L_PRIORITY_NAME' => _PRP_PRIORITYNAME,
		
		'S_FORM_OPEN_PRIORITY' => open_form( adminlink('&amp;file=priority&amp;mode=delete&amp;priority_id=' . $priority_id ), 'prioritydelete', _PRP_PRIORITYDELETE ),
		'S_FORM_CLOSE_PRIORITY' => close_form(),
		
		'S_PRIORITY' => select_box( 'priority_id', '', $priority ),
		)
	);
	
	// Display the confirmation message
	require( 'header.php' );
	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'priority_delete' => 'ProjectsPro/admin/priority_delete.html' ) );
	$cpgtpl->display( 'priority_delete' );
	CloseTable();
}

/**
 * Move priority up
 **/
function ProjectsPro_priority_move( $mode ) {
	global $prefix, $db, $CPG_SESS, $projectspro_base, $projectspro_prefix;

	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

	// Verify a valid priority id
	$priority_id = isset( $_GET['priority_id'] ) ? intval( $_GET['priority_id'] ) : 0;
	if ( 0 == $priority_id ) {
		url_redirect( adminlink('&amp;file=priority' ) );
	}

	switch( $mode ) {
		case 'up':
		case 'top':
			$dir = -1;
			break;
		default:
			$dir = 1;
			break;
	}

	// Only move the priority if it has somewhere to go
	switch( $mode ) {
		case 'up':
		case 'down':
			// Move the project up or down
			list( $weight ) = $db->sql_ufetchrow( 'SELECT weight FROM ' . $projectspro_prefix.'priorities WHERE priority_id = ' . $priority_id, SQL_NUM, __FILE__, __LINE__ );
			list( $weight_max ) = $db->sql_ufetchrow( 'SELECT weight FROM ' . $projectspro_prefix."priorities ORDER BY weight DESC LIMIT 0, 1", SQL_NUM, __FILE__, __LINE__ );
			if ( ( 0 > $dir && 1 < intval( $weight ) ) || ( 0 < $dir && intval( $weight ) < intval( $weight_max ) ) ) {
				// First, move the other priorities up, and then this priority down (or vice versa)
				$result = $db->sql_query( 'UPDATE ' . $projectspro_prefix.'priorities SET weight = weight - ' . $dir . " WHERE weight = " . ( intval( $weight ) + $dir ), false, __FILE__, __LINE__ );
				$result = $db->sql_query( 'UPDATE ' . $projectspro_prefix.'priorities SET weight = weight + ' . $dir . ' WHERE priority_id = ' . $priority_id, false, __FILE__, __LINE__ );
			}
			break;
		case 'top':
		case 'bottom':
			// Move the priority to the top
			list( $weight ) = $db->sql_ufetchrow( 'SELECT weight FROM ' . $projectspro_prefix.'priorities WHERE priority_id = ' . $priority_id, SQL_NUM, __FILE__, __LINE__ );
			list( $weight_max ) = $db->sql_ufetchrow( 'SELECT weight FROM ' . $projectspro_prefix."priorities ORDER BY weight DESC LIMIT 0, 1", SQL_NUM, __FILE__, __LINE__ );
			if ( ( 0 > $dir && 1 < intval( $weight ) ) || ( 0 < $dir && intval( $weight ) < intval( $weight_max ) ) ) {
				// First, move the other priorities up or down, then this priority
				$result = $db->sql_query( 'UPDATE ' . $projectspro_prefix.'priorities SET weight = weight - ' . $dir . " WHERE weight " . ( 0 < $dir ? '>' : '<' ) . ' ' . $weight, false, __FILE__, __LINE__ );
				$result = $db->sql_query( 'UPDATE ' . $projectspro_prefix.'priorities SET weight = ' . ( 0 < $dir ? intval( $weight_max ) : '1' ) . ' WHERE priority_id = ' . $priority_id, false, __FILE__, __LINE__ );
			}
			break;
		default:
			break;
	}
	
	// Forward the user back to home
	url_redirect( adminlink('&amp;file=priority' ) );
}



get_lang('ProjectsPro');
require_once(BASEDIR.'includes/ProjectsPro/admin.php');

$pagetitle = _PRP_ADMINMENU;

$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch ($mode) {
	case 'edit':
		ProjectsPro_priority_edit();
		break;
	case 'save':
		ProjectsPro_priority_save();
		break;
	case 'delete':
		ProjectsPro_priority_delete();
		break;
	case 'up':
	case 'down':
	case 'top':
	case 'bottom':
		ProjectsPro_priority_move( $mode );
		break;
	default:
		ProjectsPro_priority();
		break;
}