<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly™ CMS                                                |
| Copyright © 2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum™ Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright © 2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Administrate the project members                                  |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 201 $
| $Author: jday29 $
| $Date: 2006-05-22 15:08:18 -0500 (Mon, 22 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright © 2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'ADMIN_PAGES' ) ) {
	exit;
}
if ( !can_admin( $module_name ) ) {
	die( 'Access Denied' );
}

$projectspro_base = basename(dirname(dirname(__FILE__)));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the list of members
 **/
function ProjectsPro_projects_members() {
	global $prefix, $user_prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	global $bgcolor2, $bgcolor3;
	
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	
	// Invalid project id
	if ( 0 == $project_id ) {
		url_redirect( adminlink() );
	}
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_MEMBERLIST;
	require( 'header.php' );
	
	$result_members = $db->sql_query( 'SELECT pm.user_id, pm.position_id, u.username FROM ' . $projectspro_prefix.'projects_members pm, ' . $user_prefix . '_users u WHERE pm.user_id = u.user_id AND pm.project_id = ' . $project_id, false, __FILE__, __LINE__ );
	$position = ProjectsPro_position_get();
	$bgcolor = $bgcolor3;

	// Add the general information to the template
	$cpgtpl->assign_vars( array(
		'L_PROJECTS_MEMBERS' => _PRP_MEMBERSPROJECT,
		'L_FUNCTIONS' => _FUNCTIONS,
		'L_EDIT' => _EDIT,
		'L_DELETE' => _DELETE,
		'L_NO_MEMBERS' => _PRP_NOMEMBERSPROJECT,
		'L_PROJECTS_MEMBERS_CHANGE_POSITION' => _PRP_MEMBERSPROJECTSCHANGEPOSITION,
		'L_FIND_USERNAME' => _PRP_FINDUSERNAME,
		'L_USERNAME' => _PRP_USERNAME,
		'L_POSITION' => _PRP_POSITION,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		
		'S_BGCOLOR_2' => $bgcolor2,
		'S_PROJECTS_MEMBERS_COUNT' => $db->sql_numrows( $result_members ),
		'S_POSITION' => select_box( 'position_id', '', $position ),
		'S_USERNAME' => '',
		
		'S_FORM_OPEN_PROJECTS_MEMBERS' => open_form( adminlink('&amp;file=projects_members&amp;mode=save&amp;project_id=' . $project_id . '&amp;user_id=0' ), 'post', _PRP_MEMBERADD ),
		'S_FORM_CLOSE_PROJECTS_MEMBERS' => close_form(),

		'U_FIND_USERNAME' => getlink( 'Forums&amp;file=search&amp;mode=searchuser&amp;popup=1&amp;menu=1' ),
		'U_FIND_USERNAME_FAKE' => adminlink('&amp;file=projects_members&amp;project_id=' . $project_id . '#', true ),
		)
	);

	// Add the member information to the template
	while( list( $user_id, $position_id, $username ) = $db->sql_fetchrow( $result_members, SQL_NUM ) ) {
		$bgcolor = ( $bgcolor == '' ) ? $bgcolor3 : '';
		$cpgtpl->assign_block_vars( 'member', array(
			'S_BGCOLOR' => $bgcolor,
			'S_USERNAME' => $username,
			'S_POSITION_HTML' => isset( $position[$position_id] ) ? $position[$position_id] : current( $position ),

			'U_POSITION' => adminlink('&amp;file=projects_members&amp;mode=changeposition&amp;project_id=' . $project_id . '&amp;user_id=' . $user_id ),
			'U_EDIT' => adminlink('&amp;file=projects_members&amp;mode=edit&amp;project_id=' . $project_id . '&amp;user_id=' . $user_id ),
			'U_DELETE' => adminlink('&amp;file=projects_members&amp;mode=delete&amp;project_id=' . $project_id . '&amp;user_id=' . $user_id ),
			)
		);
	}
	$db->sql_freeresult( $result_members );

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'projects_members' => 'ProjectsPro/admin/projects_members.html' ) );
	$cpgtpl->display( 'projects_members' );
	$cpgtpl->set_filenames( array( 'projects_members_edit' => 'ProjectsPro/admin/projects_members_edit.html' ) );
	$cpgtpl->display( 'projects_members_edit' );
	CloseTable();
}

/**
 * Edit a project member
 **/
function ProjectsPro_projects_members_edit() {
	global $prefix, $user_prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	$user_id = isset( $_GET['user_id'] ) ? intval( $_GET['user_id'] ) : 0;
	
	// Invalid project id or user id
	if ( 0 == $project_id ) {
		url_redirect( adminlink() );
	} elseif ( 0 == $user_id ) {
		url_redirect( adminlink('&amp;file=projects_members&amp;project_id=' . $project_id ) );
	}
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_MEMBEREDIT;
	require( 'header.php' );
	
	$position = ProjectsPro_position_get();
	list( $username, $position_id ) = $db->sql_ufetchrow( 'SELECT u.username, pm.position_id FROM ' . $projectspro_prefix.'projects_members pm, ' . $user_prefix . '_users u WHERE pm.user_id = u.user_id AND pm.project_id = ' . $project_id . ' AND pm.user_id =' . $user_id, SQL_NUM, __FILE__, __LINE__ );

	// Add the general information to the template
	$cpgtpl->assign_vars( array(
		'L_POSITION' => _PRP_POSITION,
		'L_FIND_USERNAME' => _PRP_FINDUSERNAME,
		'L_USERNAME' => _PRP_USERNAME,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		
		'S_POSITION' => select_box( 'position_id', $position_id, $position ),
		'S_USERNAME' => $username,
		
		'S_FORM_OPEN_PROJECTS_MEMBERS' => open_form( adminlink('&amp;file=projects_members&amp;mode=save&amp;project_id=' . $project_id . '&amp;user_id=' . $user_id ), 'post', _PRP_MEMBEREDIT ),
		'S_FORM_CLOSE_PROJECTS_MEMBERS' => close_form(),

		'U_FIND_USERNAME' => getlink( 'Forums&amp;file=search&amp;mode=searchuser&amp;popup=1&amp;menu=1' ),
		'U_FIND_USERNAME_FAKE' => adminlink('&amp;file=projects_members&amp;project_id=' . $project_id . '#', true ),
		)
	);

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'projects_members_edit' => 'ProjectsPro/admin/projects_members_edit.html' ) );
	$cpgtpl->display( 'projects_members_edit' );
	CloseTable();
}

/**
 * Save the member to the project
 **/
function ProjectsPro_projects_members_save() {
	global $prefix, $user_prefix, $db, $projectspro_prefix;
	
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	$user_id = isset( $_GET['user_id'] ) ? intval( $_GET['user_id'] ) : 0;
	$username = isset( $_POST['username'] ) ? $_POST['username'] : '';
	$position_id = isset( $_POST['position_id'] ) ? intval( $_POST['position_id'] ) : 0;
	
	// Invalid project id
	if ( 0 == $project_id ) {
		url_redirect( adminlink() );
	}
	
	if ( 0 == $user_id ) {
		list( $user_id ) = $db->sql_ufetchrow( 'SELECT user_id FROM ' . $user_prefix . "_users WHERE username = '" . Fix_Quotes( $username ) . "'", SQL_NUM, __FILE__, __LINE__ );
		if ( !is_numeric( $user_id ) ) {
			url_redirect( adminlink('&amp;file=projects_members&amp;project_id=' . $project_id ) );
		}
	}

	if ( 0 < $db->sql_count( $projectspro_prefix.'projects_members', 'project_id = ' . $project_id . ' AND user_id = ' . $user_id ) ) {
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'projects_members SET position_id = ' . $position_id . ' WHERE project_id = ' . $project_id . ' AND user_id = ' . $user_id, false, __FILE__, __LINE__ );
	} else {
		$db->sql_query( 'INSERT INTO ' . $projectspro_prefix.'projects_members (project_id, user_id, position_id) VALUES (' . $project_id . ', ' . $user_id . ', ' . $position_id . ')', false, __FILE__, __LINE__ );
	}
	
	url_redirect( adminlink('&amp;file=projects_members&amp;project_id=' . $project_id ) );	
}

/**
 * Delete the project
 **/
function ProjectsPro_projects_members_delete() {
	global $prefix, $user_prefix, $db, $projectspro_prefix;
	
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	$user_id = isset( $_GET['user_id'] ) ? intval( $_GET['user_id'] ) : 0;
	
	// User cancelled or an invalid project id
	if ( 0 == $project_id ) {
		url_redirect( adminlink() );
	} elseif ( 0 == $user_id || isset( $_POST['cancel'] ) ) {
		url_redirect( adminlink('&amp;file=projects_members&amp;project_id=' . $project_id ) );
	}
	
	// User confirmed the delete
	if ( isset( $_POST['confirm'] ) ) {
		// Delete the member from the tasks
		$result_tasks = $db->sql_query( 'SELECT task_id FROM ' . $projectspro_prefix.'tasks WHERE project_id = ' . $project_id, false, __FILE__, __LINE__ );
		$tasks = array();
		while( list( $task_id ) = $db->sql_fetchrow( $result_tasks, SQL_NUM ) ) {
			$tasks[] = $task_id;
		}
		$db->sql_freeresult( $result_tasks );
		
		if ( count( $tasks ) ) {
			$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'tasks_members WHERE task_id IN (' . implode( ',', $tasks ) . ') AND user_id = ' . $user_id, false, __FILE__, __LINE__ );
			$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'tasks_members' , false, __FILE__, __LINE__ );
		}
		
		// Delete the member from the project
		$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'projects_members WHERE project_id = ' . $project_id . ' AND user_id = ' . $user_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'projects_members' , false, __FILE__, __LINE__ );

		url_redirect( adminlink('&amp;file=projects_members&amp;project_id=' . $project_id ) );
	}
	
	// Display the confirmation message
	$project = ProjectsPro_project_get( $project_id );
	list( $username ) = $db->sql_ufetchrow( 'SELECT u.username FROM ' . $projectspro_prefix.'projects_members pm, ' . $user_prefix . '_users u WHERE pm.user_id = u.user_id AND pm.user_id = ' . $user_id, SQL_NUM, __FILE__, __LINE__ );
	cpg_delete_msg( adminlink('&amp;file=projects_members&amp;mode=delete&amp;project_id=' . $project_id . '&amp;user_id=' . $user_id ), sprintf( _PRP_MEMBERDELETECONFIRM, '<strong>' . $username . '</strong>' ) );
}

/**
 * Change a project members position
 **/
function ProjectsPro_projects_members_change_position() {
	global $prefix, $db, $projectspro_prefix;

	// Verify a valid project id
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	$user_id = isset( $_GET['user_id'] ) ? intval( $_GET['user_id'] ) : 0;
	if ( 0 == $project_id ) {
		url_redirect( adminlink() );
	} elseif ( 0 == $user_id ) {
		url_redirect( adminlink('&amp;file=projects_members&amp;project_id=' . $project_id ) );
	}
	
	// Get the current position id from the database
	list( $position_id ) = $db->sql_ufetchrow( 'SELECT position_id FROM ' . $projectspro_prefix.'projects_members WHERE project_id = ' . $project_id . ' AND user_id = ' . $user_id, SQL_NUM, __FILE__, __LINE__ );
	
	// Change the position to the next in the list
	$position = ProjectsPro_position_get();
	$keys = array_keys( $position );
	$key = array_search( intval( $position_id ), $keys );
	for( $i = $key; $i < count( $keys ); $i++ ) {
		if ( $position_id == $keys[$i] ) {
			if ( $i == ( count( $keys ) - 1 ) ) {
				$position_id = $keys[0];
			}
			else {
				$position_id = $keys[$i+1];
			}
			break;
		}
	}
	$db->sql_query( 'UPDATE ' . $projectspro_prefix.'projects_members SET position_id = ' . $position_id . ' WHERE project_id = ' . $project_id . ' AND user_id = ' . $user_id, false, __FILE__, __LINE__ );
	
	url_redirect( adminlink('&amp;file=projects_members&amp;project_id=' . $project_id ) );
}

get_lang('ProjectsPro');
require_once(BASEDIR.'includes/ProjectsPro/admin.php');

$pagetitle = _PRP_ADMINMENU;

$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch ($mode) {
	case 'edit':
		ProjectsPro_projects_members_edit();
		break;
	case 'save':
		ProjectsPro_projects_members_save();
		break;
	case 'delete':
		ProjectsPro_projects_members_delete();
		break;
	case 'changeposition':
		ProjectsPro_projects_members_change_position();
		break;
	default:
		ProjectsPro_projects_members();
		break;
}