<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Administrate the bug reports                                      |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 214 $
| $Author: jday29 $
| $Date: 2006-06-01 17:35:46 -0500 (Thu, 01 Jun 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'ADMIN_PAGES' ) ) {
	exit;
}
if ( !can_admin( $module_name ) ) {
	die( 'Access Denied' );
}

$projectspro_base = basename(dirname(dirname(__FILE__)));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the report list
 **/
function ProjectsPro_reports() {
	global $prefix, $user_prefix, $db, $pagetitle, $cpgtpl, $MAIN_CFG, $projectspro_prefix, $projectspro_base;
	global $bgcolor2, $bgcolor3;
	
	$pagetitle .= ' '._BC_DELIM.' '._PRP_REPORTLIST;
	require( 'header.php' );
	
	$report_project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	
	$result_reports = $db->sql_query( 'SELECT r.report_id, r.project_id, p.project_name, t.name, r.status_id, s.status_name, r.summary, u.user_id, u.username, COUNT(rm.user_id) AS user_count FROM ' . $projectspro_prefix.'projects p, ' . $projectspro_prefix.'types t, ' . $projectspro_prefix.'status s, ' . $user_prefix . '_users u, ( ' . $projectspro_prefix.'reports r LEFT JOIN '.$projectspro_prefix.'reports_members rm ON r.report_id = rm.report_id ) WHERE r.project_id = p.project_id AND r.type_id = t.type_id AND r.status_id = s.status_id AND r.user_id = u.user_id ' . ( 0 < $report_project_id ? 'AND p.project_id = ' . $report_project_id : '' ) . ' GROUP BY r.report_id ORDER BY r.date_created DESC', false, __FILE__, __LINE__ );
	
	$cpgtpl->assign_vars( array(
		'B_EDIT' => false,

		'L_REPORTS' => _PRP_REPORTS,
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_TYPE' => _TYPE,
		'L_STATUS' => _PRP_STATUS,
		'L_SUBMITTED_BY' => _PRP_SUBMITTEDBY,
		'L_FUNCTIONS' => _FUNCTIONS,
		'L_NO_REPORTS' => _PRP_NOREPORTS,
		'L_MEMBERS' => _PRP_MEMBERS,
		'L_EDIT' => _EDIT,
		'L_DELETE' => _DELETE,
		'L_MAKE_TASK' => _PRP_MAKETASK,
		'L_REPORT_CHANGE_PROJECT' => _PRP_REPORTCHANGEPROJECT,
		'L_REPORT_CHANGE_STATUS' => _PRP_REPORTSCHANGESTATUS,
		'L_REPORT_CHANGE_TYPE' => _PRP_REPORTCHANGETYPE,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		
		'S_REPORT_COUNT' => $db->sql_numrows( $result_reports ),
		
		'S_BGCOLOR_2' => $bgcolor2,
		)
	);
	
	$bgcolor = $bgcolor3;
	while( list( $report_id, $project_id, $project_name, $type_name, $status_id, $status_name, $summary, $user_id, $username, $user_count) = $db->sql_fetchrow( $result_reports, SQL_NUM ) ) {
		$bgcolor = ( $bgcolor == '' ) ? $bgcolor3 : '';
		$cpgtpl->assign_block_vars( 'report', array(
			'S_BGCOLOR' => $bgcolor,
			'S_SUMMARY' => $summary,
			'S_SUMMARY_HTML' => htmlprepare($summary),
			'S_PROJECT_NAME' => $project_name,
			'S_PROJECT_NAME_HTML' => htmlprepare($project_name),
			'S_TYPE_NAME' => $type_name,
			'S_TYPE_NAME_HTML' => htmlprepare($type_name),
			'S_STATUS_NAME' => $status_name,
			'S_STATUS_NAME_HTML' => htmlprepare($status_name),
			'S_USERNAME' => $username,
			'S_USER_COUNT' => $user_count,

			'U_PROJECT' => adminlink( '&amp;file=reports&amp;mode=changeproject&amp;report_id=' . $report_id . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ),
			'U_STATUS' => adminlink('&amp;file=reports&amp;mode=changestatus&amp;report_id=' . $report_id . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ),
			'U_TYPE' => adminlink('&amp;file=reports&amp;mode=changetype&amp;report_id=' . $report_id . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ),
			'U_MEMBERS' => adminlink('&amp;file=reports_members&amp;report_id=' . $report_id . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ),
			'U_EDIT' => adminlink('&amp;file=reports&amp;mode=edit&amp;report_id=' . $report_id . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ),
			'U_DELETE' => adminlink('&amp;file=reports&amp;mode=delete&amp;report_id=' . $report_id . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ),
			'U_MAKE_TASK' => ( $status_id == $MAIN_CFG[$projectspro_base]['status_id_report_promoted'] ) ? '' : adminlink('&amp;file=reports&amp;mode=make_task&amp;report_id=' . $report_id . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ),
			'U_USER' => getlink( 'Your_Account&amp;profile=' . $user_id ),
			)
		);
	}
	$db->sql_freeresult( $result_reports );

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'reports' => 'ProjectsPro/admin/reports.html' ) );
	$cpgtpl->display( 'reports' );
	CloseTable();
}

/**
 * Promote a report to a task
 **/
function ProjectsPro_reports_make_task() {
	global $prefix, $db, $MAIN_CFG, $CPG_SESS, $projectspro_base, $projectspro_prefix;

	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

	// Validate the report id
	$report_id = isset( $_GET['report_id'] ) ? intval( $_GET['report_id'] ) : 0;
	$report_project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	if ( 0 == $report_id ) {
		url_redirect( adminlink('&amp;file=reports' . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ) );
	}

	$status = ProjectsPro_status_get( 0 );
	$status_keys = array_keys( $status );
	$priority = ProjectsPro_priority_get();
	$priority_keys = array_keys( $priority );

	list( $project_id, $summary, $description, $reproduce, $expected, $actual, $date_created, $date_started, $date_finished, $user_id, $notify_comment ) = $db->sql_ufetchrow( 'SELECT project_id, summary, description, reproduce, expected, actual, date_created, date_started, date_finished, user_id, notify_comment FROM ' . $projectspro_prefix.'reports WHERE report_id = ' . $report_id, SQL_NUM, __FILE__, __LINE__ );
	$db->sql_query( 'INSERT INTO ' . $projectspro_prefix.'tasks (project_id, task_name, task_description, priority_id, status_id, task_percent, date_created, date_started, date_finished, user_id, notify_comment) VALUES (' . $project_id . ", '" . Fix_Quotes($summary) . "', '" . Fix_Quotes( sprintf(_PRP_REPORTPROMOTED, getlink('&amp;file=report&amp;report_id='.$report_id, true, true)) . ( $description ? "\n\n[b]" . _PRP_REPORTDESCRIPTION . ":[/b]\n" . $description : '' ) . ( $reproduce ? "\n\n[b]" . _PRP_REPORTREPRODUCE . ":[/b]\n" . $reproduce : '' ) . ( $expected ? "\n\n[b]" . _PRP_REPORTEXPECTED . ":[/b]\n" . $expected : '' ) . ( $actual ? "\n\n[b]" . _PRP_REPORTACTUAL . ":[/b]\n" . $actual : '' ) ) . "', " . $MAIN_CFG[$projectspro_base]['priority_id_task_new'] . ', ' . $MAIN_CFG[$projectspro_base]['status_id_task_new'] . ', 0, ' . $date_created . ', ' . $date_started . ', ' . $date_finished . ', '.$user_id.', '.$notify_comment.')', false, __FILE__, __LINE__ );
	$task_id = $db->sql_nextid( 'task_id' );
	
	// Update the old report
	$db->sql_query( 'UPDATE ' . $projectspro_prefix.'reports SET task_id = ' . $task_id . ', status_id = ' . $MAIN_CFG[$projectspro_base]['status_id_report_promoted'] . ', notify_comment = 0 WHERE report_id = ' . $report_id, false, __FILE__, __LINE__ );

	url_redirect( adminlink('&amp;file=tasks' . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ) );
}

/**
 * Change a reports project
 **/
function ProjectsPro_reports_change_project() {
	global $prefix, $db, $CPG_SESS, $projectspro_base, $projectspro_prefix;

	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

	// Verify a valid report id
	$report_id = isset( $_GET['report_id'] ) ? intval( $_GET['report_id'] ) : 0;
	$report_project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	
	if ( 0 == $report_id ) {
		url_redirect( adminlink('&amp;file=reports' . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ) );
	}
	
	// Get the current project id from the database
	list( $project_id ) = $db->sql_ufetchrow( 'SELECT project_id FROM ' . $projectspro_prefix.'reports WHERE report_id = ' . $report_id, SQL_NUM, __FILE__, __LINE__ );
	
	// Change the project to the next in the list
	$project = ProjectsPro_projects_get();
	$keys = array_keys( $project );
	$key = array_search( intval( $project_id ), $keys );
	for( $i = $key; $i < count( $keys ); $i++ ) {
		if ( $project_id == $keys[$i] ) {
			if ( $i == ( count( $keys ) - 1 ) ) {
				$project_id = $keys[0];
			}
			else {
				$project_id = $keys[$i+1];
			}
			break;
		}
	}
	$db->sql_query( 'UPDATE ' . $projectspro_prefix.'reports SET project_id = ' . $project_id . ' WHERE report_id = ' . $report_id, false, __FILE__, __LINE__ );
	
	url_redirect( adminlink('&amp;file=reports' . ( 0 < $report_project_id ? '&amp;project_id=' . $project_id : '' ) ) );
}

/**
 * Change a reports status
 **/
function ProjectsPro_reports_change_status() {
	global $prefix, $db, $CPG_SESS, $projectspro_base, $projectspro_prefix;

	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

	// Verify a valid report id
	$report_id = isset( $_GET['report_id'] ) ? intval( $_GET['report_id'] ) : 0;
	$report_project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	if ( 0 == $report_id ) {
		url_redirect( adminlink('&amp;file=reports' . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ) );
	}
	
	// Get the current status from the database
	list( $status_id ) = $db->sql_ufetchrow( 'SELECT status_id FROM ' . $projectspro_prefix.'reports WHERE report_id = ' . $report_id, SQL_NUM, __FILE__, __LINE__ );
	
	// Change the status to the next in the list
	$status = ProjectsPro_status_get( 2 );
	$keys = array_keys( $status );
	$key = array_search( intval( $status_id ), $keys );
	if ( is_numeric( $key ) ) {
		for( $i = $key; $i < count( $keys ); $i++ ) {
			if ( $status_id == $keys[$i] ) {
				if ( $i == ( count( $keys ) - 1 ) ) {
					$status_id = $keys[0];
				}
				else {
					$status_id = $keys[$i+1];
				}
				break;
			}
		}
	} else {
		$status_id = $keys[0];
	}
	$db->sql_query( 'UPDATE ' . $projectspro_prefix.'reports SET status_id = ' . $status_id . ' WHERE report_id = ' . $report_id, false, __FILE__, __LINE__ );
	
	url_redirect( adminlink('&amp;file=reports' . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ) );
}

/**
 * Change a reports type
 **/
function ProjectsPro_reports_change_type() {
	global $prefix, $db, $projectspro_base, $CPG_SESS, $projectspro_prefix;

	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

	// Verify a valid report id
	$report_id = isset( $_GET['report_id'] ) ? intval( $_GET['report_id'] ) : 0;
	$report_project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	if ( 0 == $report_id ) {
		url_redirect( adminlink('&amp;file=reports' . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ) );
	}
	
	// Get the current type from the database
	list( $type_id ) = $db->sql_ufetchrow( 'SELECT type_id FROM ' . $projectspro_prefix.'reports WHERE report_id = ' . $report_id, SQL_NUM, __FILE__, __LINE__ );
	
	// Change the type to the next in the list
	$type = ProjectsPro_types_get( 2 );
	$keys = array_keys( $type );
	$key = array_search( intval( $type_id ), $keys );
	for( $i = $key; $i < count( $keys ); $i++ ) {
		if ( $type_id == $keys[$i] ) {
			if ( $i == ( count( $keys ) - 1 ) ) {
				$type_id = $keys[0];
			}
			else {
				$type_id = $keys[$i+1];
			}
			break;
		}
	}
	$db->sql_query( 'UPDATE ' . $projectspro_prefix.'reports SET type_id = ' . $type_id . ' WHERE report_id = ' . $report_id, false, __FILE__, __LINE__ );
	
	url_redirect( adminlink('&amp;file=reports' . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ) );
}

/**
 * Delete the report
 **/
function ProjectsPro_reports_delete() {
	global $prefix, $db, $projectspro_prefix;
	
	$report_id = isset( $_GET['report_id'] ) ? intval( $_GET['report_id'] ) : 0;
	$report_project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	
	// User cancelled or an invalid report id
	if ( 0 == $report_id || isset( $_POST['cancel'] ) ) {
		url_redirect( adminlink('&amp;file=reports' . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ) );
	}
	
	// User confirmed the delete
	if ( isset( $_POST['confirm'] ) ) {
		// Delete the report comments
		$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'comments WHERE join_id = ' . $report_id . ' AND join_type = 2', false, __FILE__, __LINE__ );
		$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix .'comments' , false, __FILE__, __LINE__ );
		
		// Delete the report
		$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'reports WHERE report_id = ' . $report_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'reports' , false, __FILE__, __LINE__ );

		url_redirect( adminlink('&amp;file=reports' . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ) );
	}
	
	// Display the confirmation message
	list( $summary ) = $db->sql_ufetchrow( 'SELECT summary FROM ' . $projectspro_prefix.'reports WHERE report_id = ' . $report_id, SQL_NUM, __FILE__, __LINE__ );
	cpg_delete_msg( adminlink('&amp;file=reports&amp;mode=delete&amp;report_id=' . $report_id . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ), sprintf( _ERROR_DELETE_CONF, '<strong>' . htmlprepare($summary) . '</strong>' ) );
}

/**
 * Edit/Add a report
 **/
function ProjectsPro_reports_edit() {
	global $prefix, $db, $pagetitle, $modheader, $cpgtpl, $CPG_SESS, $currentlang, $projectspro_prefix;
	
	$report_id = isset( $_GET['report_id'] ) ? intval( $_GET['report_id'] ) : 0;
	$report_project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	
	// Invalid report id
	if ( 0 == $report_id ) {
		url_redirect( adminlink('&amp;file=reports' . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ) );
	}
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_REPORTEDIT;
	$modheader .= '<style type="text/css">@import url(themes/' . $CPG_SESS['theme'] . '/style/ProjectsPro/calendar-win2k-1.css);</style>' . "\n";
	$modheader .= '<script type="text/javascript" src="includes/javascript/calendar.js"></script>' . "\n";
	$modheader .= '<script type="text/javascript" src="includes/javascript/' . $currentlang . '/calendar.js"></script>' . "\n";
	$modheader .= '<script type="text/javascript" src="includes/javascript/calendar-setup.js"></script>' . "\n";
	require_once(CORE_PATH.'nbbcode.php');
	require( 'header.php' );
	
	$project = ProjectsPro_projects_get();
	$status = ProjectsPro_status_get( 2 );
	$type = ProjectsPro_types_get( 2 );
	
	$report = $db->sql_ufetchrow( 'SELECT project_id, summary, type_id, status_id, description, reproduce, expected, actual, date_started, date_finished FROM ' . $projectspro_prefix.'reports WHERE report_id = ' . $report_id, SQL_ASSOC, __FILE__, __LINE__ );
	$cpgtpl->assign_vars( array(
		'B_EDIT' => is_user() ? true : false,
		
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_SUMMARY' => _PRP_REPORTSUMMARY,
		'L_TYPE' => _TYPE,
		'L_STATUS' => _PRP_STATUS,
		'L_DESCRIPTION' => _PRP_REPORTDESCRIPTION,
		'L_REPRODUCE' => _PRP_REPORTREPRODUCE,
		'L_EXPECTED' => _PRP_REPORTEXPECTED,
		'L_ACTUAL' => _PRP_REPORTACTUAL,
		'L_START_DATE' => _PRP_STARTDATE,
		'L_END_DATE' => _PRP_FINISHDATE,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		'L_COMMENT_ADD' =>_PRP_REPORTCOMMENTADD,
		'L_CHOOSE_DATE' => _PRP_CHOOSEDATE,

		'S_FORM_OPEN_REPORTS' => open_form( adminlink('&amp;file=reports&amp;mode=save&amp;report_id=' . $report_id . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ), 'post', _PRP_REPORTEDIT ),
		'S_FORM_CLOSE_REPORTS' => close_form(),
		
		'S_PROJECT_ID' => select_box( 'project_id', $report['project_id'], $project ),
		'S_SUMMARY' => $report['summary'],
		'S_SUMMARY_HTML' => htmlprepare( $report['summary'] ),
		'S_TYPE_ID' => select_box( 'type_id', $report['type_id'], $type ),
		'S_STATUS_ID' => select_box( 'status_id', $report['status_id'], $status ),
		'S_DESCRIPTION' => htmlprepare( $report['description'] ),
		'S_REPRODUCE' => htmlprepare( $report['reproduce'] ),
		'S_EXPECTED' => htmlprepare( $report['expected'] ),
		'S_ACTUAL' => htmlprepare( $report['actual'] ),
		'S_DATE_START' => ( 0 == $report['date_started'] ? '' : L10NTime::strftime('%m-%d-%Y', $report['date_started'], 0, 0) ),
		'S_DATE_END' => ( 0 == $report['date_finished'] ? '' : L10NTime::strftime('%m-%d-%Y', $report['date_finished'], 0, 0) ),
		'S_DATE_FORMAT' => '%m-%d-%Y',

		'S_BBCODE_DESCRIPTION' => bbcode_table( 'description', 'post', 1 ),
		'S_BBCODE_REPRODUCE' => bbcode_table( 'reproduce', 'post', 1 ),
		'S_BBCODE_EXPECTED' => bbcode_table( 'expected', 'post', 1 ),
		'S_BBCODE_ACTUAL' => bbcode_table( 'actual', 'post', 1 ),
		'S_BBCODE_COMMENT' => bbcode_table( 'comment', 'post', 1 ),
		)
	);
	
	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'reports_edit' => 'ProjectsPro/admin/reports_edit.html' ) );
	$cpgtpl->display( 'reports_edit' );
	CloseTable();
}

/**
 * Save a report
 * A report_id of 0 (zero) indicates a new report
 **/
function ProjectsPro_reports_save() {
	global $prefix, $db, $projectspro_prefix;
	
	$report_id = isset( $_GET['report_id'] ) ? intval( $_GET['report_id'] ) : 0;
	$report_project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;

	if ( 0 == $report_id ) {
		url_redirect( adminlink('&amp;file=reports' . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ) );
	}
	
	$project_id = isset( $_POST['project_id'] ) ? Fix_Quotes( $_POST['project_id'] ) : '';
	$summary = isset( $_POST['summary'] ) ? Fix_Quotes( $_POST['summary'] ) : '';
	$type_id = isset( $_POST['type_id'] ) ? intval( $_POST['type_id'] ) : 0;
	$status_id = isset( $_POST['status_id'] ) ? intval( $_POST['status_id'] ) : 0;
	$description = isset( $_POST['description'] ) ? Fix_Quotes( $_POST['description'] ) : '';
	$reproduce = isset( $_POST['reproduce'] ) ? Fix_Quotes( $_POST['reproduce'] ) : '';
	$expected = isset( $_POST['expected'] ) ? Fix_Quotes( $_POST['expected'] ) : '';
	$actual = isset( $_POST['actual'] ) ? Fix_Quotes( $_POST['actual'] ) : '';
	$comment = isset( $_POST['comment'] ) ? Fix_Quotes( $_POST['comment'] ) : '';
	$start_date = isset( $_POST['start_date'] ) ? explode( '-', $_POST['start_date'] ) : array();
	$end_date = isset( $_POST['end_date'] ) ? explode( '-', $_POST['end_date'] ) : array();
	$date_started = 0;
	$date_finished = 0;
	if ( 3 == count( $start_date ) ) {
		$date_started = mktime( 0, 0, 1, $start_date[0], $start_date[1], $start_date[2] );
	}
	if ( 3 == count( $end_date ) ) {
		$date_finished = mktime( 0, 0, 1, $end_date[0], $end_date[1], $end_date[2] );
	}
	
	if ( 0 < $report_id ) {
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'reports SET project_id = ' . $project_id . ", summary = '" . $summary . "', type_id = " . $type_id . ', status_id = ' . $status_id . ", description = '" . $description . "', reproduce = '" . $reproduce . "', expected = '" . $expected . "', actual = '" . $actual . "', date_started = " . $date_started . ', date_finished = ' . $date_finished . ' WHERE report_id = ' . $report_id, false, __FILE__, __LINE__ );
	}

	if ( '' != $comment ) {
		$db->sql_query( 'INSERT INTO ' . $projectspro_prefix.'comments (join_id, join_type, user_id, ip, description, date_created) VALUES (' . $report_id . ', 2, ' . is_user() . ", '" . $userinfo['user_ip'] . "', '" . $comment . "', " . gmtime() . ')', false, __FILE__, __LINE__ );
	}

	url_redirect( adminlink('&amp;file=reports' . ( 0 < $report_project_id ? '&amp;project_id=' . $report_project_id : '' ) ) );
}












get_lang('ProjectsPro');
require_once(BASEDIR.'includes/ProjectsPro/admin.php');

$pagetitle = _PRP_ADMINMENU;

$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch ($mode) {
	case 'changetype':
		ProjectsPro_reports_change_type();
		break;
	case 'changestatus':
		ProjectsPro_reports_change_status();
		break;
	case 'changeproject':
		ProjectsPro_reports_change_project();
		break;
	case 'delete':
		ProjectsPro_reports_delete();
		break;
	case 'edit':
		ProjectsPro_reports_edit();
		break;
	case 'save':
		ProjectsPro_reports_save();
		break;
	case 'make_task':
		ProjectsPro_reports_make_task();
		break;
	default:
		ProjectsPro_reports();
		break;
}
