<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Administrate the statuses                                         |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 201 $
| $Author: jday29 $
| $Date: 2006-05-22 15:08:18 -0500 (Mon, 22 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright ?2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'ADMIN_PAGES' ) ) {
	exit;
}
if ( !can_admin( $module_name ) ) {
	die( 'Access Denied' );
}

$projectspro_base = basename(dirname(dirname(__FILE__)));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the status list
 **/
function ProjectsPro_status() {
	global $prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	global $bgcolor2, $bgcolor3;
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_STATUSLIST;
	require_once(CORE_PATH.'nbbcode.php');
	require( 'header.php' );
	
	$types = ProjectsPro_type_get();
	unset( $types[1] );
	
	$cpgtpl->assign_vars( array(
		'L_STATUSES' => _PRP_STATUSES,
		'L_FUNCTIONS' => _FUNCTIONS,
		'L_EDIT' => _EDIT,
		'L_DELETE' => _DELETE,
		'L_STATUS_NAME' => _PRP_STATUSNAME,
		'L_STATUS_DESCRIPTION' => _PRP_STATUSDESCRIPTION,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		'L_WEIGHT' => _WEIGHT,
		'L_TYPE' => _TYPE,
		'L_CHANGE_TYPE' => _PRP_STATUSCHANGETYPE,
		'L_DISPLAYED' => _PRP_STATUSDISPLAYED,
		'L_CHANGE_DISPLAY' => _PRP_STATUSCHANGEDISPLAY,
		'L_DISPLAY_PROJECT' => _PRP_STATUSDISPLAYPROJECT,
		'L_STATUS_UP' => _PRP_STATUS_UP,
		'L_STATUS_DOWN' => _PRP_STATUS_DOWN,
		'L_STATUS_TOP' => _PRP_STATUS_TOP,
		'L_STATUS_BOTTOM' => _PRP_STATUS_BOTTOM,
		
		'S_BGCOLOR_2' => $bgcolor2,
		'S_STATUS_NAME' => '',
		'S_STATUS_NAME_HTML' => '',
		'S_STATUS_DESCRIPTION' => '',
		'S_TYPE' => select_box( 'type', 0, $types ),
		'S_BBCODE_STATUS' => bbcode_table( 'status_description', 'statusedit', 1 ),
		'S_DISPLAY' => yesno_option('display', 1),

		'S_FORM_OPEN_STATUS' => open_form( adminlink('&amp;file=status&amp;mode=save&amp;status_id=0' ), 'statusedit', _PRP_STATUSADD ),
		'S_FORM_CLOSE_STATUS' => close_form(),
		)
	);

	$bgcolor = $bgcolor3;
	$result_status = $db->sql_query( 'SELECT status_id, status_name, weight, type, display FROM ' . $projectspro_prefix.'status ORDER BY weight, status_name ASC', false, __FILE__, __LINE__ );
	while( list( $status_id, $status_name, $weight, $type, $display ) = $db->sql_fetchrow( $result_status ) ) {
		$bgcolor = ( $bgcolor == '' ) ? $bgcolor3 : '';
		$cpgtpl->assign_block_vars( 'status', array(
			'S_BGCOLOR' => $bgcolor,
			'S_STATUS_NAME' => $status_name,
			'S_STATUS_NAME_HTML' => htmlprepare($status_name),
			'S_TYPE' => $types[$type],
			'S_TYPE_HTML' => htmlprepare($types[$type]),
			'S_DISPLAY' => $display,

			'U_UP' => 1 < $weight ? adminlink('&amp;file=status&amp;mode=up&amp;status_id=' . $status_id ) : '',
			'U_TOP' => 1 < $weight ? adminlink('&amp;file=status&amp;mode=top&amp;status_id=' . $status_id ) : '',
			'U_DOWN' => $db->sql_numrows( $result_status ) > $weight ? adminlink('&amp;file=status&amp;mode=down&amp;status_id=' . $status_id ) : '',
			'U_BOTTOM' => $db->sql_numrows( $result_status ) > $weight ? adminlink('&amp;file=status&amp;mode=bottom&amp;status_id=' . $status_id ) : '',
			'U_TYPE' => adminlink('&amp;file=status&amp;mode=changetype&amp;status_id=' . $status_id ),
			'U_EDIT' => adminlink('&amp;file=status&amp;mode=edit&amp;status_id=' . $status_id ),
			'U_DELETE' => 1 < $db->sql_numrows( $result_status ) ? adminlink('&amp;file=status&amp;mode=delete&amp;status_id=' . $status_id ) : '',
			'U_DISPLAY' => adminlink('&amp;file=status&amp;mode=changedisplay&amp;status_id='.$status_id),
			)
		);
	}
	$db->sql_freeresult( $result_status );

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'status' => 'ProjectsPro/admin/status.html' ) );
	$cpgtpl->display( 'status' );
	$cpgtpl->set_filenames( array( 'status_edit' => 'ProjectsPro/admin/status_edit.html' ) );
	$cpgtpl->display( 'status_edit' );
	CloseTable();
}

/**
 * Change the status type
 * 0 = project
 * 1 = task
 * 2 = report
 * 3 = request
 **/
function ProjectsPro_status_change_type() {
  global $prefix, $db, $CPG_SESS, $projectspro_base, $projectspro_prefix;
  
	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

  // Verify a valid status id
  $status_id = isset( $_GET['status_id'] ) ? intval( $_GET['status_id'] ) : 0;
  if ( 0 == $status_id ) {
    url_redirect( adminlink('&amp;file=status' ) );
  }

  // Change the status type
  list( $type ) = $db->sql_ufetchrow( 'SELECT type FROM ' . $projectspro_prefix.'status WHERE status_id = ' . $status_id, SQL_NUM, __FILE__, __LINE__ );
  if ( is_numeric( $type ) ) {
		$types = ProjectsPro_type_get();
		unset( $types[1] );
		$keys = array_keys( $types );
		$key = array_search( $type, $keys );
		for( $i = $key; $i < count( $keys ); $i++ ) {
			if ( $type == $keys[$i] ) {
				if ( $i == ( count( $keys ) - 1 ) ) {
					$type = $keys[0];
				}
				else {
					$type = $keys[$i+1];
				}
				break;
			}
		}
    $db->sql_query( 'UPDATE ' . $projectspro_prefix.'status SET type = ' . $type . ' WHERE status_id = ' . $status_id, false, __FILE__, __LINE__ );
  }
  
  // Forward the user back to the main pages
  url_redirect( adminlink('&amp;file=status' ) );
}

/**
 * Change the display status
 **/
function ProjectsPro_status_change_display() {
  global $prefix, $db, $projectspro_base, $CPG_SESS, $projectspro_prefix;
  
	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

  // Verify a valid status id
  $status_id = isset( $_GET['status_id'] ) ? intval( $_GET['status_id'] ) : 0;
  if ( 0 == $status_id ) {
    url_redirect( adminlink('&amp;file=status' ) );
  }

  // Change the status type
  list($display) = $db->sql_ufetchrow('SELECT display FROM '.$projectspro_prefix.'status WHERE status_id = '.$status_id, SQL_NUM, __FILE__, __LINE__);
	$db->sql_query('UPDATE '.$projectspro_prefix.'status SET display = '.($display ? 0 : 1).' WHERE status_id = '.$status_id, false, __FILE__, __LINE__);
  
  // Forward the user back to the main pages
  url_redirect(adminlink('&amp;file=status'));
}

/**
 * Edit a status
 **/
function ProjectsPro_status_edit() {
	global $prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_STATUSEDIT;
	require_once(CORE_PATH.'nbbcode.php');
	require( 'header.php' );
	
	$status_id = isset( $_GET['status_id'] ) ? intval( $_GET['status_id'] ) : 0;
	
	// Invalid status id
	if ( 0 == $status_id ) {
		url_redirect( adminlink('&amp;file=status' ) );
	}

	list( $status_id, $status_name, $status_description, $type, $display ) = $db->sql_ufetchrow( 'SELECT status_id, status_name, status_description, type, display FROM ' . $projectspro_prefix.'status WHERE status_id = ' . $status_id, SQL_NUM, __FILE__, __LINE__ );
	if ( !is_numeric( $status_id ) ) {
		url_redirect( adminlink('&amp;file=status' ) );
	}

	$types = ProjectsPro_type_get();
	unset( $types[1] );
	$cpgtpl->assign_vars( array(
		'L_STATUS_NAME' => _PRP_STATUSNAME,
		'L_STATUS_DESCRIPTION' => _PRP_STATUSDESCRIPTION,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		'L_TYPE' => _TYPE,
		'L_DISPLAY_PROJECT' => _PRP_STATUSDISPLAYPROJECT,
		
		'S_STATUS_NAME' => $status_name,
		'S_STATUS_NAME_HTML' => htmlprepare( $status_name ),
		'S_STATUS_DESCRIPTION' => htmlprepare( $status_description ),
		'S_TYPE' => select_box( 'type', $type, $types ),
		'S_BBCODE_STATUS' => bbcode_table( 'status_description', 'statusedit', 1 ),
		'S_DISPLAY' => yesno_option('display', $display),

		'S_FORM_OPEN_STATUS' => open_form( adminlink('&amp;file=status&amp;mode=save&amp;status_id=' . $status_id ), 'statusedit', _PRP_STATUSEDIT ),
		'S_FORM_CLOSE_STATUS' => close_form(),
		)
	);

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'status_edit' => 'ProjectsPro/admin/status_edit.html' ) );
	$cpgtpl->display( 'status_edit' );
	CloseTable();
}

/**
 * Save the status
 **/
function ProjectsPro_status_save() {
	global $prefix, $db, $projectspro_prefix;
	
	$status_id = isset( $_GET['status_id'] ) ? intval( $_GET['status_id'] ) : 0;
	$status_name = isset( $_POST['status_name'] ) ? Fix_Quotes( $_POST['status_name'] ) : '';
	$status_description = isset( $_POST['status_description'] ) ? Fix_Quotes( $_POST['status_description'] ) : '';
	$type = isset( $_POST['type'] ) ? intval( $_POST['type'] ) : 0;
	$display = isset($_POST['display']) ? intval($_POST['display']) : 0;
	
	if ( '' == $status_name ) {
		cpg_error( _PRP_STATUSINVALIDNAME );
	}
	
	if ( 0 < $status_id ) {
		$db->sql_query( 'UPDATE ' . $projectspro_prefix."status SET status_name = '" . $status_name . "', status_description = '" . $status_description . "', type=" . $type . ', display = '.$display.' WHERE status_id = ' . $status_id, false, __FILE__, __LINE__ );
	} else {
		list( $weight ) = $db->sql_ufetchrow( 'SELECT MAX(weight) as weight FROM ' . $projectspro_prefix.'status', SQL_NUM, __FILE__, __LINE__ );
		$db->sql_query( 'INSERT INTO ' . $projectspro_prefix."status (status_name, status_description, weight, type, display) VALUES ('" . $status_name . "', '" . $status_description . "', " . ( $weight + 1 ) . ', ' . $type . ', '.$display.')', false, __FILE__, __LINE__ );
	}
	
	url_redirect( adminlink('&amp;file=status' ) );	
}

/**
 * Delete the 
 **/
function ProjectsPro_status_delete() {
	global $prefix, $db, $cpgtpl, $projectspro_prefix;
	
	$status_id = isset( $_GET['status_id'] ) ? intval( $_GET['status_id'] ) : 0;
	$new_status_id = isset( $_POST['status_id'] ) ? intval( $_POST['status_id'] ) : 0;
	
	// User cancelled or an invalid status id
	if ( 0 == $status_id || isset( $_POST['cancel'] ) ) {
		url_redirect( adminlink('&amp;file=status' ) );
	}
	
	list( $type ) = $db->sql_ufetchrow( 'SELECT type FROM ' . $projectspro_prefix.'status WHERE status_id = ' . $status_id, SQL_NUM, __FILE__, __LINE__ );
	if ( 1 == $db->sql_count( $projectspro_prefix.'status', 'type = ' . $type ) ) {
		cpg_error( _PRP_STATUSCANNOTDELETE );
	}
	
	// User confirmed the delete
	if ( isset( $_POST['confirm'] ) ) {
		if ( 0 == $new_status_id ) {
			url_redirect( adminlink('&amp;file=status&amp;mode=delete&amp;status_id=' . $status_id ) );
		}

		// Verify the status_id is valid so we don't do extra work
		list( $weight ) = $db->sql_ufetchrow( 'SELECT weight from ' . $projectspro_prefix.'status where status_id = ' . $status_id, SQL_NUM, __FILE__, __LINE__ );
		if ( !is_numeric( $weight ) ) {
			url_redirect( adminlink('&amp;file=status' ) );
		}

		// Move the other statuses up, then delete the status
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'status SET weight = weight - 1 WHERE weight > ' . $weight, false, __FILE__, __LINE__ );
		$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'status WHERE status_id = ' . $status_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'status' , false, __FILE__, __LINE__ );
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'projects SET status_id = ' . $new_status_id . ' WHERE status_id = ' . $status_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'tasks SET status_id = ' . $new_status_id . ' WHERE status_id = ' . $status_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'reports SET status_id = ' . $new_status_id . ' WHERE status_id = ' . $status_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'requests SET status_id = ' . $new_status_id . ' WHERE status_id = ' . $status_id, false, __FILE__, __LINE__ );
		
		url_redirect( adminlink('&amp;file=status' ) );
	}
	
	$status = ProjectsPro_status_get( $type );
	$status_name = $status[$status_id];
	unset( $status[$status_id] );
	
	$cpgtpl->assign_vars( array(
		'L_DELETE' => _DELETE,
		'L_CANCEL' => _PRP_CANCEL,
		'L_SWAP_STATUS' => sprintf( _PRP_STATUSSWAP, $status_name ),
		'L_STATUS_NAME' => _PRP_STATUSNAME,
		
		'S_FORM_OPEN_STATUS' => open_form( adminlink('&amp;file=status&amp;mode=delete&amp;status_id=' . $status_id ), 'statusdelete', _PRP_STATUSDELETE ),
		'S_FORM_CLOSE_STATUS' => close_form(),
		
		'S_STATUS' => select_box( 'status_id', '', $status ),
		)
	);
	
	// Display the confirmation message
	require( 'header.php' );
	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'status_delete' => 'ProjectsPro/admin/status_delete.html' ) );
	$cpgtpl->display( 'status_delete' );
	CloseTable();
}

/**
 * Move status up
 **/
function ProjectsPro_status_move( $mode ) {
	global $prefix, $db, $projectspro_base, $CPG_SESS, $projectspro_prefix;

	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

	// Verify a valid status id
	$status_id = isset( $_GET['status_id'] ) ? intval( $_GET['status_id'] ) : 0;
	if ( 0 == $status_id ) {
		url_redirect( adminlink('&amp;file=status' ) );
	}

	switch( $mode ) {
		case 'up':
		case 'top':
			$dir = -1;
			break;
		default:
			$dir = 1;
			break;
	}

	// Only move the status if it has somewhere to go
	switch( $mode ) {
		case 'up':
		case 'down':
			// Move the status up or down
			list( $weight ) = $db->sql_ufetchrow( 'SELECT weight FROM ' . $projectspro_prefix.'status WHERE status_id = ' . $status_id, SQL_NUM, __FILE__, __LINE__ );
			list( $weight_max ) = $db->sql_ufetchrow( 'SELECT weight FROM ' . $projectspro_prefix."status ORDER BY weight DESC LIMIT 0, 1", SQL_NUM, __FILE__, __LINE__ );
			if ( ( 0 > $dir && 1 < intval( $weight ) ) || ( 0 < $dir && intval( $weight ) < intval( $weight_max ) ) ) {
				// First, move the other status up, and then this status down (or vice versa)
				$result = $db->sql_query( 'UPDATE ' . $projectspro_prefix.'status SET weight = weight - ' . $dir . " WHERE weight = " . ( intval( $weight ) + $dir ), false, __FILE__, __LINE__ );
				$result = $db->sql_query( 'UPDATE ' . $projectspro_prefix.'status SET weight = weight + ' . $dir . ' WHERE status_id = ' . $status_id, false, __FILE__, __LINE__ );
			}
			break;
		case 'top':
		case 'bottom':
			// Move the status to the top
			list( $weight ) = $db->sql_ufetchrow( 'SELECT weight FROM ' . $projectspro_prefix.'status WHERE status_id = ' . $status_id, SQL_NUM, __FILE__, __LINE__ );
			list( $weight_max ) = $db->sql_ufetchrow( 'SELECT weight FROM ' . $projectspro_prefix."status ORDER BY weight DESC LIMIT 0, 1", SQL_NUM, __FILE__, __LINE__ );
			if ( ( 0 > $dir && 1 < intval( $weight ) ) || ( 0 < $dir && intval( $weight ) < intval( $weight_max ) ) ) {
				// First, move the other status up or down, then this status
				$result = $db->sql_query( 'UPDATE ' . $projectspro_prefix.'status SET weight = weight - ' . $dir . " WHERE weight " . ( 0 < $dir ? '>' : '<' ) . ' ' . $weight, false, __FILE__, __LINE__ );
				$result = $db->sql_query( 'UPDATE ' . $projectspro_prefix.'status SET weight = ' . ( 0 < $dir ? intval( $weight_max ) : '1' ) . ' WHERE status_id = ' . $status_id, false, __FILE__, __LINE__ );
			}
			break;
		default:
			break;
	}
	
	// Forward the user back to home
	url_redirect( adminlink('&amp;file=status' ) );
}


get_lang('ProjectsPro');
require_once(BASEDIR.'includes/ProjectsPro/admin.php');

$pagetitle = _PRP_ADMINMENU;

$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch ($mode) {
	case 'changetype':
		ProjectsPro_status_change_type();
		break;
	case 'changedisplay':
		ProjectsPro_status_change_display();
		break;
	case 'edit':
		ProjectsPro_status_edit();
		break;
	case 'save':
		ProjectsPro_status_save();
		break;
	case 'delete':
		ProjectsPro_status_delete();
		break;
	case 'up':
	case 'down':
	case 'top':
	case 'bottom':
		ProjectsPro_status_move( $mode );
		break;
	default:
		ProjectsPro_status();
		break;
}