<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly™ CMS                                                |
| Copyright © 2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum™ Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright © 2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Administrate the task members                                     |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 201 $
| $Author: jday29 $
| $Date: 2006-05-22 15:08:18 -0500 (Mon, 22 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright © 2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'ADMIN_PAGES' ) ) {
	exit;
}
if ( !can_admin( $module_name ) ) {
	die( 'Access Denied' );
}

$projectspro_base = basename(dirname(dirname(__FILE__)));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the list of members
 **/
function ProjectsPro_tasks_members() {
	global $prefix, $user_prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	global $bgcolor2, $bgcolor3;
	
	$task_id = isset( $_GET['task_id'] ) ? intval( $_GET['task_id'] ) : 0;
	$task_project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	
	// Invalid task id
	if ( 0 == $task_id ) {
		url_redirect( adminlink('&amp;file=tasks' . ( 0 < $task_project_id ? '&amp;project_id=' . $task_project_id : '' ) ) );
	}
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_MEMBERLIST;
	require( 'header.php' );
	
	list( $project_id ) = $db->sql_ufetchrow( 'SELECT project_id FROM ' . $projectspro_prefix.'tasks WHERE task_id = ' . $task_id, SQL_NUM, __FILE__, __LINE__ );
	$result_members = $db->sql_query( 'SELECT u.user_id, u.username, po.position_name FROM ' . $projectspro_prefix.'projects_members pm, ' . $projectspro_prefix.'positions po, ' . $user_prefix . '_users u WHERE pm.position_id = po.position_id AND pm.user_id = u.user_id AND pm.project_id = ' . $project_id, false, __FILE__, __LINE__ );
	$members = array();
	while( $row_member = $db->sql_fetchrow( $result_members, SQL_ASSOC ) ) {
		$members[$row_member['user_id']] = $row_member;
	}
	$db->sql_freeresult( $result_members );

	$bgcolor = $bgcolor3;
	$result_members = $db->sql_query( 'SELECT tm.user_id, po.position_name, u.username FROM ' . $projectspro_prefix.'projects_members pm, ' . $projectspro_prefix.'tasks_members tm, ' . $projectspro_prefix.'positions po, ' . $user_prefix . '_users u WHERE pm.user_id = tm.user_id AND pm.position_id = po.position_id AND tm.user_id = u.user_id AND pm.project_id = ' . $project_id . ' AND tm.task_id = ' . $task_id, false, __FILE__, __LINE__ );
	// Add the member information to the template
	while( list( $user_id, $position_name, $username ) = $db->sql_fetchrow( $result_members, SQL_NUM ) ) {
		$bgcolor = ( $bgcolor == '' ) ? $bgcolor3 : '';
		if ( isset( $members[$user_id] ) ) {
			unset( $members[$user_id] );
		}
		$cpgtpl->assign_block_vars( 'member', array(
			'S_BGCOLOR' => $bgcolor,
			'S_USERNAME' => $username,
			'S_POSITION' => $position_name,
			'S_POSITION_HTML' => htmlprepare($position_name),

			'U_DELETE' => adminlink('&amp;file=tasks_members&amp;mode=delete&amp;task_id=' . $task_id . '&amp;user_id=' . $user_id . ( 0 < $task_project_id ? '&amp;project_id=' . $task_project_id : '' ) ),
			)
		);
	}
	
	// Add the potential members to the template
	foreach( $members as $user_id => $member ) {
		$cpgtpl->assign_block_vars( 'member_available', array(
			'S_USER_ID' => $user_id,
			'S_USERNAME' => $member['username'],
			'S_POSITION_NAME' => $member['position_name'],
			'S_POSITION_NAME_HTML' => htmlprepare($member['position_name']),
			)
		);
	}

	// Add the general information to the template
	$cpgtpl->assign_vars( array(
		'L_TASKS_MEMBERS' => _PRP_TASKMEMBERS,
		'L_FUNCTIONS' => _FUNCTIONS,
		'L_DELETE' => _DELETE,
		'L_POSITION' => _PRP_POSITION,
		'L_NO_MEMBERS' => _PRP_NOMEMBERSTASK,
		'L_TASKS_MEMBERS_CHANGE_POSITION' => _PRP_TASKSMEMBERSCHANGEPOSITION,
		'L_USERNAME_POSITION' => _PRP_USERNAME . ' - ' . _PRP_POSITION,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		'L_MEMBER_ADD_TO_PROJECT_FIRST' => count( $members ) ? '' : _PRP_MEMBERADDTOPROJECTFIRST,
		
		'S_BGCOLOR_2' => $bgcolor2,
		'S_TASKS_MEMBERS_COUNT' => $db->sql_numrows( $result_members ),
		
		'S_FORM_OPEN_TASKS_MEMBERS' => open_form( adminlink('&amp;file=tasks_members&amp;mode=save&amp;task_id=' . $task_id . '&amp;user_id=0' . ( 0 < $task_project_id ? '&amp;project_id=' . $task_project_id : '' ) ), 'post', _PRP_MEMBERADD ),
		'S_FORM_CLOSE_TASKS_MEMBERS' => close_form(),
		)
	);

	$db->sql_freeresult( $result_members );

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'tasks_members' => 'ProjectsPro/admin/tasks_members.html' ) );
	$cpgtpl->display( 'tasks_members' );
	$cpgtpl->set_filenames( array( 'tasks_members_edit' => 'ProjectsPro/admin/tasks_members_edit.html' ) );
	$cpgtpl->display( 'tasks_members_edit' );
	CloseTable();
}

/**
 * Save the member to the task
 **/
function ProjectsPro_tasks_members_save() {
	global $prefix, $user_prefix, $db, $cpgtpl, $MAIN_CFG, $projectspro_prefix, $projectspro_base;
	
	$task_id = isset( $_GET['task_id'] ) ? intval( $_GET['task_id'] ) : 0;
	$task_project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	$user_id = isset( $_POST['user_id'] ) ? $_POST['user_id'] : array();
	$position_id = isset( $_POST['position_id'] ) ? intval( $_POST['position_id'] ) : 0;
	
	require_once(CORE_PATH.'nbbcode.php');
	
	// Invalid task id
	if ( 0 == $task_id ) {
		url_redirect( adminlink('&amp;file=tasks' . ( 0 < $task_project_id ? '&amp;project_id=' . $task_project_id : '' ) ) );
	} elseif ( 0 == count( $user_id ) ) {
		url_redirect( adminlink('&amp;file=tasks' . ( 0 < $task_project_id ? '&amp;project_id=' . $task_project_id : '' ) ) );
	}

	$task = ProjectsPro_task_get( $task_id );
	$priority = ProjectsPro_priority_get();
	$project = ProjectsPro_projects_get();
	
	$user_ids = array_keys( $user_id );
	$result_users = $db->sql_query( 'SELECT user_id, user_email FROM ' . $user_prefix . '_users WHERE user_id in (' . implode( ', ', $user_ids ) . ')' );
	while( $row_user = $db->sql_fetchrow( $result_users, SQL_ASSOC ) ) {
		$users[$row_user['user_id']] = $row_user['user_email'];
	}
	$db->sql_freeresult( $result_users );

	// Add all of the members to the task
	foreach( $user_id as $key => $value ) {
		$db->sql_query( 'INSERT INTO ' . $projectspro_prefix.'tasks_members (task_id, user_id) VALUES (' . $task_id . ', ' . intval( $key ) . ')', false, __FILE__, __LINE__ );
		
		if ( $MAIN_CFG[$projectspro_base]['notify_task_member'] ) {
			$cpgtpl->assign_vars( array(
				'L_PROJECT_NAME' => _PRP_PROJECTNAME,
				'L_TASK_NAME' => _PRP_TASKNAME,
				'L_TASK_DESCRIPTION' => _PRP_TASKDESCRIPTION,
				'L_PRIORITY' => _PRP_PRIORITY,
				'L_ASSIGNED_TO_TASK' => _PRP_TASKASSIGNEDTOTASK,
				'L_TASK' => _PRP_TASK,
	
				'S_TASK_ID' => $task_id,
				'S_PROJECT_NAME' => $project[$task['project_id']],
				'S_PROJECT_NAME_HTML' => htmlprepare($project[$task['project_id']]),
				'S_TASK_NAME' => $task['task_name'],
				'S_TASK_NAME_HTML' => htmlprepare( $task['task_name'] ),
				'S_TASK_DESCRIPTION' => decode_bb_all( $task['task_description'], 1, false),
				'S_TASK_PRIORITY' => $priority[$task['priority_id']],
				'S_TASK_PRIORITY_HTML' => htmlprepare($priority[$task['priority_id']]),
				
				'U_TASK' => getlink('&amp;file=task&amp;task_id=' . $task_id, true, true ),
				'U_PROJECT' => getlink('&amp;file=project&amp;project_id=' . $task['project_id'], true, true ),
				)
			);
	
			ob_start();
			$cpgtpl->set_filenames( array( 'tasks_members_email' => 'ProjectsPro/admin/tasks_members_email.html' ) );
			$cpgtpl->display( 'tasks_members_email' );
			$message = ob_get_clean();
			
			send_mail( $mailer_message, $message, 1, _PRP_TASKASSIGNEDTOTASK, $users[intval( $key )] );
		}
	}
	
	url_redirect( adminlink('&amp;file=tasks_members&amp;task_id=' . $task_id . ( 0 < $task_project_id ? '&amp;project_id=' . $task_project_id : '' ) ) );	
}

/**
 * Delete the task
 **/
function ProjectsPro_tasks_members_delete() {
	global $prefix, $user_prefix, $db, $projectspro_prefix;
	
	$task_id = isset( $_GET['task_id'] ) ? intval( $_GET['task_id'] ) : 0;
	$user_id = isset( $_GET['user_id'] ) ? intval( $_GET['user_id'] ) : 0;
	$task_project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	
	// User cancelled or an invalid task id
	if ( 0 == $task_id ) {
		url_redirect( adminlink('&amp;file=tasks' . ( 0 < $task_project_id ? '&amp;project_id=' . $task_project_id : '' ) ) );
	} elseif ( 0 == $user_id || isset( $_POST['cancel'] ) ) {
		url_redirect( adminlink('&amp;file=tasks_members&amp;task_id=' . $task_id . ( 0 < $task_project_id ? '&amp;project_id=' . $task_project_id : '' ) ) );
	}
	
	// User confirmed the delete
	if ( isset( $_POST['confirm'] ) ) {
		$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'tasks_members WHERE task_id = ' . $task_id . ' AND user_id = ' . $user_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'tasks_members' , false, __FILE__, __LINE__ );
		
		url_redirect( adminlink('&amp;file=tasks_members&amp;task_id=' . $task_id . ( 0 < $task_project_id ? '&amp;project_id=' . $task_project_id : '' ) ) );
	}
	
	// Display the confirmation message
	$task = ProjectsPro_task_get( $task_id );
	list( $username ) = $db->sql_ufetchrow( 'SELECT u.username FROM ' . $projectspro_prefix.'tasks_members pm, ' . $user_prefix . '_users u WHERE pm.user_id = u.user_id AND pm.user_id = ' . $user_id, SQL_NUM, __FILE__, __LINE__ );
	cpg_delete_msg( adminlink('&amp;file=tasks_members&amp;mode=delete&amp;task_id=' . $task_id . '&amp;user_id=' . $user_id . ( 0 < $task_project_id ? '&amp;project_id=' . $task_project_id : '' ) ), sprintf( _PRP_MEMBERDELETECONFIRM, '<strong>' . $username . '</strong>' ) );
}

get_lang('ProjectsPro');
require_once(BASEDIR.'includes/ProjectsPro/admin.php');

$pagetitle = _PRP_ADMINMENU;

$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch ($mode) {
	case 'save':
		ProjectsPro_tasks_members_save();
		break;
	case 'delete':
		ProjectsPro_tasks_members_delete();
		break;
	default:
		ProjectsPro_tasks_members();
		break;
}