<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Administrate the types list                                       |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 201 $
| $Author: jday29 $
| $Date: 2006-05-22 15:08:18 -0500 (Mon, 22 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright ?2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'ADMIN_PAGES' ) ) {
	exit;
}
if ( !can_admin( $module_name ) ) {
	die( 'Access Denied' );
}

$projectspro_base = basename(dirname(dirname(__FILE__)));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the report types list
 **/
function ProjectsPro_types() {
	global $prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	global $bgcolor2, $bgcolor3;
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_TYPESLIST;
	require( 'header.php' );
	
	$types = ProjectsPro_type_get();
	unset( $types[0] ); // do not allow project
	unset( $types[1] ); // do not allow task

	// Add the general information to the template
	$cpgtpl->assign_vars( array(
		'L_NAME' => _PRP_TYPENAME,
		'L_FUNCTIONS' => _FUNCTIONS,
		'L_EDIT' => _EDIT,
		'L_DELETE' => _DELETE,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		'L_TYPE' => _TYPE,
		'L_CHANGE_TYPE' => _PRP_STATUSCHANGETYPE,
		
		'S_BGCOLOR_2' => $bgcolor2,
		'S_NAME' => '',
		'S_NAME_HTML' => htmlprepare(''),
		'S_TYPE' => select_box( 'type', 0, $types ),

		'S_FORM_OPEN_TYPES' => open_form( adminlink('&amp;file=types&amp;mode=save&amp;type_id=0' ), 'typesedit', _PRP_TYPEADD ),
		'S_FORM_CLOSE_TYPES' => close_form(),
		)
	);

	// Add the types to the template
	$bgcolor = $bgcolor3;
	$result_types = $db->sql_query( 'SELECT type_id, name, type FROM ' . $projectspro_prefix.'types ORDER BY type, name ASC', false, __FILE__, __LINE__ );
	while( list( $type_id, $name, $type ) = $db->sql_fetchrow( $result_types ) ) {
		$bgcolor = ( $bgcolor == '' ) ? $bgcolor3 : '';
		$cpgtpl->assign_block_vars( 'type', array(
			'S_BGCOLOR' => $bgcolor,
			'S_NAME' => $name,
			'S_NAME_HTML' => htmlprepare($name),
			'S_TYPE_HTML' => $types[$type],

			'U_CHANGE_TYPE' => adminlink('&amp;file=types&amp;mode=changetype&amp;type_id=' . $type_id ),
			'U_EDIT' => adminlink('&amp;file=types&amp;mode=edit&amp;type_id=' . $type_id ),
			'U_DELETE' => 1 < $db->sql_numrows( $result_types ) ? adminlink('&amp;file=types&amp;mode=delete&amp;type_id=' . $type_id ) : '',
			)
		);
	}
	$db->sql_freeresult( $result_types );

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'types' => 'ProjectsPro/admin/types.html' ) );
	$cpgtpl->display( 'types' );
	$cpgtpl->set_filenames( array( 'types_edit' => 'ProjectsPro/admin/types_edit.html' ) );
	$cpgtpl->display( 'types_edit' );
	CloseTable();
}

/**
 * Change the type type
 * 0 = project
 * 1 = task
 * 2 = report
 * 3 = request
 **/
function ProjectsPro_types_change_type() {
	global $prefix, $db, $projectspro_base, $CPG_SESS, $projectspro_prefix;
	
	if ($projectspro_base != $CPG_SESS['admin']['page']) {
		cpg_error(_ERROR_BAD_LINK, _SEC_ERROR);
	}

	// Verify a valid type id
	$type_id = isset( $_GET['type_id'] ) ? intval( $_GET['type_id'] ) : 0;
	if ( 0 == $type_id ) {
		url_redirect( adminlink('&amp;file=types' ) );
	}

	// Change the type type
	list( $type ) = $db->sql_ufetchrow( 'SELECT type FROM ' . $projectspro_prefix.'types WHERE type_id = ' . $type_id, SQL_NUM, __FILE__, __LINE__ );
	if ( is_numeric( $type ) ) {
		$types = ProjectsPro_type_get();
		unset( $types[0] ); // do not allow project
		unset( $types[1] ); // do not allow task
		$type += 1;
		if ( $type >= ( count( $types ) + 2 ) ) {
			$type = 2;
		}
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'types SET type = ' . $type . ' WHERE type_id = ' . $type_id, false, __FILE__, __LINE__ );
	}
	
	// Forward the user back to the main pages
	url_redirect( adminlink('&amp;file=types' ) );
}

/**
 * Edit a report type
 **/
function ProjectsPro_types_edit() {
	global $prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_TYPEEDIT;
	require( 'header.php' );
	
	$type_id = isset( $_GET['type_id'] ) ? intval( $_GET['type_id'] ) : 0;
	
	// Invalid type id
	if ( 0 == $type_id ) {
		url_redirect( adminlink('&amp;file=types' ) );
	}

	list( $type_id, $name, $type ) = $db->sql_ufetchrow( 'SELECT type_id, name, type FROM ' . $projectspro_prefix.'types WHERE type_id = ' . $type_id, SQL_NUM, __FILE__, __LINE__ );
	if ( !is_numeric( $type_id ) ) {
		url_redirect( adminlink('&amp;file=types' ) );
	}

	$types = ProjectsPro_type_get();
	unset( $types[0] ); // do not allow project
	unset( $types[1] ); // do not allow task

	$cpgtpl->assign_vars( array(
		'L_NAME' => _PRP_TYPENAME,
		'L_TYPE' => _PRP_TYPE,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		
		'S_NAME' => $name,
		'S_NAME_HTML' => htmlprepare( $name ),
		'S_TYPE' => select_box( 'type', $type, $types ),

		'S_FORM_OPEN_TYPES' => open_form( adminlink('&amp;file=types&amp;mode=save&amp;type_id=' . $type_id), 'typesedit', _PRP_TYPEEDIT ),
		'S_FORM_CLOSE_TYPES' => close_form(),
		)
	);

	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'types_edit' => 'ProjectsPro/admin/types_edit.html' ) );
	$cpgtpl->display( 'types_edit' );
	CloseTable();
}

/**
 * Save the report type
 **/
function ProjectsPro_types_save() {
	global $prefix, $db, $projectspro_prefix;
	
	$type_id = isset( $_GET['type_id'] ) ? intval( $_GET['type_id'] ) : 0;
	$name = isset( $_POST['name'] ) ? Fix_Quotes( $_POST['name'] ) : '';
	$type = isset( $_POST['type'] ) ? intval( $_POST['type'] ) : 0;
	
	if ( '' == $name ) {
		cpg_error( _PRP_TYPEINVALIDNAME );
	}
	
	if ( 0 < $type_id ) {
		$db->sql_query( 'UPDATE ' . $projectspro_prefix."types SET name = '" . $name . "', type = " . $type . ' WHERE type_id = ' . $type_id, false, __FILE__, __LINE__ );
	} else {
		$db->sql_query( 'INSERT INTO ' . $projectspro_prefix."types (name, type) VALUES ('" . $name . "', " . $type . ')', false, __FILE__, __LINE__ );
	}
	
	url_redirect( adminlink('&amp;file=types' ) );	
}

/**
 * Delete the report type
 **/
function ProjectsPro_types_delete() {
	global $prefix, $db, $cpgtpl, $projectspro_prefix;
	
	$type_id = isset( $_GET['type_id'] ) ? intval( $_GET['type_id'] ) : 0;
	$new_type_id = isset( $_POST['type_id'] ) ? intval( $_POST['type_id'] ) : 0;
	
	// User cancelled or an invalid type id
	if ( 0 == $type_id || isset( $_POST['cancel'] ) ) {
		url_redirect( adminlink('&amp;file=types' ) );
	}
	
	list( $type ) = $db->sql_ufetchrow( 'SELECT type FROM ' . $projectspro_prefix.'types WHERE type_id = ' . $type_id, SQL_NUM, __FILE__, __LINE__ );
	if ( 1 == $db->sql_count( $projectspro_prefix.'types', 'type = ' . $type ) ) {
		cpg_error( _PRP_TYPECANNOTDELETE );
	}
	
	// User confirmed the delete
	if ( isset( $_POST['confirm'] ) ) {
		if ( 0 == $new_type_id ) {
			url_redirect( adminlink('&amp;file=types&amp;mode=delete&amp;type_id=' . $type_id ) );
		}

		$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'types WHERE type_id = ' . $type_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'types' , false, __FILE__, __LINE__ );
		$db->sql_query( 'UPDATE ' . $projectspro_prefix.'reports SET type_id = ' . $new_type_id . ' WHERE type_id = ' . $type_id, false, __FILE__, __LINE__ );
		
		url_redirect( adminlink('&amp;file=types' ) );
	}
	
	$types = ProjectsPro_types_get( $type );
	$name = $types[$type_id];
	unset( $types[$type_id] );
	
	$cpgtpl->assign_vars( array(
		'L_DELETE' => _DELETE,
		'L_CANCEL' => _PRP_CANCEL,
		'L_SWAP_TYPE' => sprintf( _PRP_TYPESWAP, $name ),
		'L_NAME' => _PRP_TYPENAME,
		
		'S_FORM_OPEN_TYPES' => open_form( adminlink('&amp;file=types&amp;mode=delete&amp;type_id=' . $type_id ), 'typesdelete', _PRP_TYPEDELETE ),
		'S_FORM_CLOSE_TYPES' => close_form(),
		
		'S_TYPE' => select_box( 'type_id', '', $types ),
		)
	);
	
	// Display the confirmation message
	require( 'header.php' );
	GraphicAdmin( '_AMENU9' );
	OpenTable();
	ProjectsPro_header();
	$cpgtpl->set_filenames( array( 'types_delete' => 'ProjectsPro/admin/types_delete.html' ) );
	$cpgtpl->display( 'types_delete' );
	CloseTable();
}


get_lang('ProjectsPro');
require_once(BASEDIR.'includes/ProjectsPro/admin.php');

$pagetitle = _PRP_ADMINMENU;

$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch ($mode) {
	case 'changetype':
		ProjectsPro_types_change_type();
		break;
	case 'edit':
		ProjectsPro_types_edit();
		break;
	case 'save':
		ProjectsPro_types_save();
		break;
	case 'delete':
		ProjectsPro_types_delete();
		break;
	default:
		ProjectsPro_types();
		break;
}