<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Main index for ProjectsPro.  This file will display the list of   |
| projects and the status information of each                       |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 204 $
| $Author: jday29 $
| $Date: 2006-05-24 19:11:40 -0500 (Wed, 24 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'CPG_NUKE' ) ) {
	exit;
}

$projectspro_base = basename(dirname(__FILE__));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the projets list
 **/
function ProjectsPro_projects() {
	global $prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix, $MAIN_CFG, $projectspro_base, $userinfo, $CPG_SESS;
	
	require_once(CORE_PATH.'nbbcode.php');
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_PROJECTLIST;
	$project_times = array();

	// Count the members for each project
	$result_users = $db->sql_query( 'SELECT p.project_id, count(pm.user_id) as user_count FROM ( ' . $projectspro_prefix . 'projects p LEFT JOIN ' . $projectspro_prefix . 'projects_members pm ON p.project_id = pm.project_id ) GROUP BY p.project_id', false, __FILE__, __LINE__ );
	$users = array();
	while( list( $project_id, $user_count ) = $db->sql_fetchrow( $result_users, SQL_NUM ) ) {
		$users[$project_id] = $user_count;
	}
	$db->sql_freeresult( $result_users );
	
	if ($MAIN_CFG[$projectspro_base]['report_enable']) {
		// Count the reports for each project
		$result_reports = $db->sql_query( 'SELECT p.project_id, count(r.report_id) as reports_count, MAX(r.date_created) AS reports_date_created, MAX(c.date_created) as reports_comment_date_created FROM ( ( '.$projectspro_prefix.'projects p LEFT JOIN '.$projectspro_prefix.'reports r ON p.project_id = r.project_id ) LEFT JOIN '.$projectspro_prefix.'comments c ON r.report_id = c.join_id AND c.join_type = 2 ) GROUP BY p.project_id', false, __FILE__, __LINE__ );
		$reports = array();
		while( list( $project_id, $reports_count, $reports_date_created, $reports_comments_date_created ) = $db->sql_fetchrow( $result_reports, SQL_NUM ) ) {
			if (!isset($project_times[$project_id]) || $project_times[$project_id] < $reports_date_created || $project_times[$project_id] < $reports_comments_date_created) {
				if ( !isset($project_times[$project_id]) || ($project_times[$project_id] < $reports_date_created) ) {
					$project_times[$project_id] = $reports_date_created;
				}
				if ($project_times[$project_id] < $reports_comments_date_created) {
					$project_times[$project_id] = $reports_comments_date_created;
				}
			}
			$reports[$project_id] = $reports_count;
		}
		$db->sql_freeresult( $result_reports );
	}
	
	if ($MAIN_CFG[$projectspro_base]['request_enable']) {
		// Count the requests for each project
		$result_requests = $db->sql_query( 'SELECT p.project_id, count(re.request_id) as requests_count, MAX(re.date_created) AS requests_date_created, MAX(c.date_created) AS requests_comment_date_created FROM ( ( '.$projectspro_prefix.'projects p LEFT JOIN '.$projectspro_prefix.'requests re ON p.project_id = re.project_id ) LEFT JOIN '.$projectspro_prefix.'comments c ON re.request_id = c.join_id AND c.join_type = 3 ) GROUP BY p.project_id', false, __FILE__, __LINE__ );
		$requests = array();
		while( list( $project_id, $requests_count, $requests_date_created, $requests_comments_date_created ) = $db->sql_fetchrow( $result_requests, SQL_NUM ) ) {
			if (!isset($project_times[$project_id]) || $project_times[$project_id] < $requests_date_created || $project_times[$project_id] < $requests_comments_date_created) {
				if ( !isset($project_times[$project_id]) || ($project_times[$project_id] < $requests_date_created) ) {
					$project_times[$project_id] = $requests_date_created;
				}
				if ($project_times[$project_id] < $requests_comments_date_created) {
					$project_times[$project_id] = $requests_comments_date_created;
				}
			}
			$requests[$project_id] = $requests_count;
		}
		$db->sql_freeresult( $result_requests );
	}
	
	// Count the tasks for each project
	$result_tasks = $db->sql_query( 'SELECT p.project_id, MAX(t.date_finished) AS date_finished, SUM(t.task_percent) AS tasks_percent, count(t.task_id) as tasks_count, MAX(t.date_created) AS tasks_date_created, MAX(c.date_created) AS tasks_comments_date_created FROM ( ( '.$projectspro_prefix.'projects p LEFT JOIN '.$projectspro_prefix.'tasks t ON p.project_id = t.project_id ) LEFT JOIN '.$projectspro_prefix.'comments c ON t.task_id = c.join_id AND c.join_type = 1 ) GROUP BY p.project_id', false, __FILE__, __LINE__ );
	$tasks = array();
	$tasks_percent = array();
	$tasks_activity = array();
	while( list( $project_id, $date_finished, $task_percent, $tasks_count, $tasks_date_created, $tasks_comments_date_created ) = $db->sql_fetchrow( $result_tasks, SQL_NUM ) ) {
		if (!isset($project_times[$project_id]) || $project_times[$project_id] < $tasks_date_created || $project_times[$project_id] < $tasks_comments_date_created) {
			if (!isset($project_times[$project_id]) || ($project_times[$project_id] < $tasks_date_created) ) {
				$project_times[$project_id] = $tasks_date_created;
			}
			if ($project_times[$project_id] < $tasks_comments_date_created) {
				$project_times[$project_id] = $tasks_comments_date_created;
			}
		}
		$tasks[$project_id] = $tasks_count;
		$tasks_percent[$project_id] = ( 0 == $tasks_count ) ? 0 : floor( $task_percent / $tasks_count );
		$tasks_activity[$project_id] = $date_finished;
	}
	$db->sql_freeresult( $result_tasks );
	
	$cpgtpl->assign_vars( array(
		'B_REPORT_ENABLE' => $MAIN_CFG[$projectspro_base]['report_enable'],
		'B_REQUEST_ENABLE' => $MAIN_CFG[$projectspro_base]['request_enable'],
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_TASKS' => _PRP_TASKS,
		'L_STATUS' => _PRP_STATUS,
		'L_PRIORITY' => _PRP_PRIORITY,
		'L_MEMBERS' => _PRP_MEMBERS,
		'L_REPORTS' => _PRP_REPORTS,
		'L_REQUESTS' => _PRP_REQUESTS,
		'L_PROGRESS' => _PRP_PROGRESS,
		'L_PERCENT' => _PRP_PERCENT . ' ' . _PRP_COMPLETED,
		'L_VIEW_ALL' => _PRP_VIEWALL,
		'L_DATE_START' => _PRP_STARTDATE,
		'L_DATE_FINISH' => _PRP_FINISHDATE,
		'L_SCHEDULED_COMPLETE_DATE' => _PRP_SCHEDULEDCOMPLETIONDATE,
		'L_DATE_ACTIVITY' => _PRP_ACTIVITYDATE,
		
		'U_VIEW_ALL' => getlink('&amp;file=projects_all' ),
		)
	);
	
	$result_projects = $db->sql_query( 'SELECT p.project_id, p.project_name, p.project_description, p.project_percent, p.date_started, p.date_finished, pr.priority_name, s.status_name FROM '.$projectspro_prefix.'projects p, ' . $projectspro_prefix.'priorities pr, '.$projectspro_prefix.'status s WHERE p.priority_id = pr.priority_id AND p.status_id = s.status_id GROUP BY p.project_id ORDER BY p.weight ASC, pr.weight DESC, s.weight DESC', false, __FILE__, __LINE__ );
	while( list( $project_id, $project_name, $project_description, $project_percent, $date_started, $date_finished, $priority_name, $status_name ) = $db->sql_fetchrow( $result_projects, SQL_NUM ) ) {
		$project_time = $userinfo['user_lastvisit'];
		if (isset($CPG_SESS[$projectspro_base]['track_task'][$project_id])) {
		  foreach ($CPG_SESS[$projectspro_base]['track_task'][$project_id] as $task) {
				if ($task > $project_time) {
					$project_time = $task;
				}
		  }
		}
		if ($MAIN_CFG[$projectspro_base]['report_enable'] && isset($CPG_SESS[$projectspro_base]['track_report'][$project_id])) {
		  foreach ($CPG_SESS[$projectspro_base]['track_report'][$project_id] as $report) {
				if ($report > $project_time) {
					$project_time = $report;
				}
		  }
		}
		if ($MAIN_CFG[$projectspro_base]['request_enable'] && isset($CPG_SESS[$projectspro_base]['track_request'][$project_id])) {
		  foreach ($CPG_SESS[$projectspro_base]['track_request'][$project_id] as $request) {
				if ($request > $project_time) {
					$project_time = $request;
				}
		  }
		}
		$cpgtpl->assign_block_vars( 'project', array(
			'B_NEW' => ( (isset($project_times[$project_id]) && ($project_times[$project_id] > $project_time)) ? 1 : 0 ),
			'S_PROJECT_NAME' => $project_name,
			'S_PROJECT_NAME_HTML' => htmlprepare( $project_name ),
			'S_PROJECT_DESCRIPTION' => decode_bb_all($project_description, 1, false),
			'S_TASK_COUNT' => $tasks[$project_id],
			'S_STATUS' => $status_name,
			'S_STATUS_HTML' => htmlprepare($status_name),
			'S_PRIORITY' => $priority_name,
			'S_PRIORITY_HTML' => htmlprepare($priority_name),
			'S_DATE_STARTED' => ( 0 < $date_started ? L10NTime::strftime( _DATESTRING3, $date_started, 0, 0 ) : '' ),
			'S_DATE_FINISHED' => ( 0 < $date_finished ? L10NTime::strftime( _DATESTRING3, $date_finished, 0, 0 ) : '' ),
			'S_DATE_ACTIVITY' => ( 0 < $tasks_activity[$project_id] ? L10NTime::strftime( _DATESTRING3, $tasks_activity[$project_id] , 0, 0 ) : '' ),
			'S_USER_COUNT' => $users[$project_id],
			'S_REPORTS_COUNT' => ($MAIN_CFG[$projectspro_base]['report_enable'] ? $reports[$project_id] : 0),
			'S_REQUESTS_COUNT' => ($MAIN_CFG[$projectspro_base]['request_enable'] ? $requests[$project_id] : 0),
			'S_PERCENT_DONE' => 0 == $project_percent ? $tasks_percent[$project_id] : $project_percent,
			'S_PERCENT_TODO' => 99 < $project_percent ? 0 : ( 100 - ( 0 == $project_percent ? $tasks_percent[$project_id] : $project_percent ) ),

			'U_PROJECT' => getlink('&amp;file=project&amp;project_id=' . $project_id ),
			)
		);
	}
	$db->sql_freeresult( $result_projects );
	
	require( 'header.php' );
	OpenTable();
	$cpgtpl->set_filenames( array( 'index' => 'ProjectsPro/index.html' ) );
	$cpgtpl->display( 'index' );
	CloseTable();
}


$pagetitle .= $module_title;
get_lang('ProjectsPro');
$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch( $mode ) {
	default:
		ProjectsPro_projects();
		break;
}