<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Display the specific project information                          |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 204 $
| $Author: jday29 $
| $Date: 2006-05-24 19:11:40 -0500 (Wed, 24 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'CPG_NUKE' ) ) {
	exit;
}

$projectspro_base = basename(dirname(__FILE__));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the projets list
 **/
function ProjectsPro_project() {
	global $prefix, $user_prefix, $db, $pagetitle, $cpgtpl, $MAIN_CFG, $projectspro_base, $projectspro_prefix, $CPG_SESS, $userinfo;

	require_once(CORE_PATH.'nbbcode.php');
	
	// Validate the project id
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	if ( 0 == $project_id ) {
		url_redirect( getlink() );
	}

	// Add the list of members to the template
	$result_users = $db->sql_query( 'SELECT pm.user_id, u.username, po.position_name FROM ' . $projectspro_prefix.'projects_members pm, ' . $user_prefix . '_users u, ' . $projectspro_prefix. 'positions po WHERE pm.user_id = u.user_id AND pm.position_id = po.position_id AND pm.project_id = ' . $project_id, false, __FILE__, __LINE__ );
	while( list( $user_id, $username, $position_name ) = $db->sql_fetchrow( $result_users, SQL_NUM ) ) {
		$cpgtpl->assign_block_vars( 'member', array(
			'S_USERNAME' => $username,
			'S_POSITION_NAME' => $position_name,
			'S_POSITION_NAME_HTML' => htmlprepare( $position_name ),
			
			'U_PROFILE' => getlink( 'Your_Account&amp;profile=' . $user_id ),
			)
		);
	}
	
	// Add the list of tasks to the template
	$result_tasks = $db->sql_query( 'SELECT t.task_id, t.task_name, t.task_percent, t.date_created, s.status_name, pr.priority_name, count(c.comment_id) AS comments_count, MAX(c.date_created) AS task_comment_date_created FROM ' . $projectspro_prefix . 'status s, ' . $projectspro_prefix . 'priorities pr, ( ' . $projectspro_prefix . 'tasks t LEFT JOIN ' . $projectspro_prefix.'comments c ON t.task_id = c.join_id AND c.join_type = 1 ) WHERE t.status_id = s.status_id AND t.priority_id = pr.priority_id AND t.project_id = ' . $project_id . ' GROUP BY t.task_id ORDER BY pr.weight DESC, s.weight DESC, t.task_name ASC', false, __FILE__, __LINE__ );
	$tasks_percent_total = 0;
	while( list( $task_id, $task_name, $task_percent, $date_created, $status_name, $priority_name, $comments_count, $task_comment_date_created ) = $db->sql_fetchrow( $result_tasks, SQL_NUM ) ) {
		$tasks_percent_total += $task_percent;
		$task_time = $userinfo['user_lastvisit'];
		if (isset($CPG_SESS[$projectspro_base]['track_task'][$project_id][$task_id]) && $CPG_SESS[$projectspro_base]['track_task'][$project_id][$task_id] > $task_time) {
			$task_time = $CPG_SESS[$projectspro_base]['track_task'][$project_id][$task_id];
		}
		if ($task_time < $date_created) {
			$task_time = $date_created;
		}
		$cpgtpl->assign_block_vars( 'task', array(
			'B_NEW' => ($task_time < $date_created || $task_time < $task_comment_date_created),
			'S_TASK_NAME' => $task_name,
			'S_TASK_NAME_HTML' => htmlprepare( $task_name ),
			'S_STATUS' => $status_name,
			'S_STATUS_HTML' => htmlprepare($status_name),
			'S_PRIORITY' => $priority_name,
			'S_PRIORITY_HTML' => htmlprepare($priority_name),
			'S_COMMENTS_COUNT' => $comments_count,
			'S_PERCENT_DONE' => 0 == $task_percent ? 0 : $task_percent,
			'S_PERCENT_TODO' => 99 < $task_percent ? 0 : ( 100 - $task_percent ),

			'U_TASK' => getlink('&amp;file=task&amp;task_id=' . $task_id )
			)
		);
	}
	
	if ($MAIN_CFG[$projectspro_base]['report_enable']) {
		// Add the list of reports to the template
		$result_reports = $db->sql_query( 'SELECT r.report_id, r.date_created, rt.name, s.status_name, r.summary, u.username, u.user_id, count(c.comment_id) AS comments_count, MAX(c.date_created) AS report_comment_date_created FROM ' . $projectspro_prefix.'types rt, ' . $projectspro_prefix.'status s, ' . $user_prefix . '_users u, ( ' . $projectspro_prefix . 'reports r LEFT JOIN ' . $projectspro_prefix.'comments c ON r.report_id = c.join_id AND c.join_type = 2 ) WHERE r.type_id = rt.type_id AND r.status_id = s.status_id AND r.user_id = u.user_id AND r.project_id = ' . $project_id . ' AND s.display = 1 GROUP BY r.report_id ORDER BY r.date_created DESC', false, __FILE__, __LINE__ );
		while( list( $report_id, $date_created, $name, $status_name, $summary, $username, $user_id, $comments_count, $report_comment_date_created ) = $db->sql_fetchrow( $result_reports, SQL_NUM ) ) {
			$report_time = $userinfo['user_lastvisit'];
			if (isset($CPG_SESS[$projectspro_base]['track_report'][$project_id][$report_id]) && $CPG_SESS[$projectspro_base]['track_report'][$project_id][$report_id] > $report_time) {
				$report_time = $CPG_SESS[$projectspro_base]['track_report'][$project_id][$report_id];
			}
			$cpgtpl->assign_block_vars( 'report', array(
				'B_NEW' => ($report_time < $date_created || $report_time < $report_comment_date_created),
				'S_SUMMARY' => $summary,
				'S_SUMMARY_HTML' => htmlprepare($summary),
				'S_STATUS_NAME' => $status_name,
				'S_STATUS_NAME_HTML' => htmlprepare($status_name),
				'S_TYPE' => $name,
				'S_TYPE_HTML' => htmlprepare($name),
				'S_USERNAME' => $username,
				'S_COMMENTS_COUNT' => $comments_count,
				
				'U_REPORT' => getlink('&amp;file=report&amp;report_id=' . $report_id ),
				'U_PROFILE' => getlink( 'Your_Account&amp;profile=' . $user_id ),
				)
			);
		}
	}

	if ($MAIN_CFG[$projectspro_base]['request_enable']) {
		// Add the list of requests to the template
		$result_requests = $db->sql_query( 'SELECT re.request_id, re.date_created, t.name, s.status_name, re.summary, u.username, u.user_id, count(c.comment_id) AS comments_count, MAX(c.date_created) AS request_comment_date_created FROM ' . $projectspro_prefix.'types t, ' . $projectspro_prefix.'status s, ' . $user_prefix . '_users u, ( ' . $projectspro_prefix.'requests re LEFT JOIN ' . $projectspro_prefix.'comments c ON re.request_id = c.join_id AND c.join_type = 3 ) WHERE re.type_id = t.type_id AND re.status_id = s.status_id AND re.user_id = u.user_id AND re.project_id = ' . $project_id . ' AND s.display = 1 GROUP BY re.request_id ORDER BY re.date_created DESC', false, __FILE__, __LINE__ );
		while( list( $request_id, $date_created, $name, $status_name, $summary, $username, $user_id, $comments_count, $request_comment_date_created ) = $db->sql_fetchrow( $result_requests, SQL_NUM ) ) {
			$request_time = $userinfo['user_lastvisit'];
			if (isset($CPG_SESS[$projectspro_base]['track_request'][$project_id][$request_id]) && $CPG_SESS[$projectspro_base]['track_request'][$project_id][$request_id] > $request_time) {
				$request_time = $CPG_SESS[$projectspro_base]['track_request'][$project_id][$request_id];
			}
			$cpgtpl->assign_block_vars( 'request', array(
				'B_NEW' => ($request_time < $date_created || $request_time < $request_comment_date_created),
				'S_SUMMARY' => $summary,
				'S_SUMMARY_HTML' => htmlprepare($summary),
				'S_STATUS_NAME' => $status_name,
				'S_STATUS_NAME_HTML' => htmlprepare($status_name),
				'S_TYPE' => $name,
				'S_TYPE_HTML' => htmlprepare($name),
				'S_USERNAME' => $username,
				'S_COMMENTS_COUNT' => $comments_count,
				
				
				'U_REQUEST' => getlink('&amp;file=request&amp;request_id=' . $request_id ),
				'U_PROFILE' => getlink( 'Your_Account&amp;profile=' . $user_id ),
				)
			);
		}
	}

	// Add the project information and the rest of the stuff to the template
	list( $project_name, $project_description, $project_percent, $date_started, $date_finished, $status_name, $priority_name ) = $db->sql_ufetchrow( 'SELECT p.project_name, p.project_description, p.project_percent, p.date_started, p.date_finished, s.status_name, pr.priority_name FROM ' . $projectspro_prefix.'projects p, ' . $projectspro_prefix.'status s, ' . $projectspro_prefix.'priorities pr WHERE p.status_id = s.status_id AND p.priority_id = pr.priority_id AND p.project_id = ' . $project_id, SQL_NUM, __FILE__, __LINE__ );
	$cpgtpl->assign_vars( array(
		'B_REPORT_ENABLE' => $MAIN_CFG[$projectspro_base]['report_enable'],
		'B_REQUEST_ENABLE' => $MAIN_CFG[$projectspro_base]['request_enable'],
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_PROJECT_DESCRIPTION' => _PRP_PROJECTDESCRIPTION,
		'L_PROJECT_DETAILS' => _PRP_PROJECTDETAILS,
		'L_STATUS' => _PRP_STATUS,
		'L_PRIORITY' => _PRP_PRIORITY,
		'L_PROGRESS' => _PRP_PROGRESS,
		'L_PERCENT' => _PRP_PERCENT . ' ' . _PRP_COMPLETED,
		'L_DATE_START' => _PRP_STARTDATE,
		'L_DATE_FINISH' => _PRP_FINISHDATE,
		'L_PROJECT_MEMBERS' => _PRP_MEMBERSPROJECT,
		'L_POSITION' => _PRP_POSITION,
		'L_TASKS' => _PRP_TASKS,
		'L_MEMBERS' => _PRP_MEMBERS,
		'L_NO_MEMBERS_PROJECT' => _PRP_NOMEMBERSPROJECT,
		'L_NO_TASKS' => _PRP_NOTASKS,
		'L_MEMBER' => _PRP_MEMBER,
		'L_POSITION' => _PRP_POSITION,
		'L_TASK_NAME' => _PRP_TASKNAME,
		'L_VIEW_PROJECT_TASK_DETAIL' => _PRP_VIEWPROJECTTASKDETAIL,
		'L_REPORTS' => _PRP_REPORTS,
		'L_SUBMITTED_BY' => _PRP_SUBMITTEDBY,
		'L_TYPE' => _PRP_TYPE,
		'L_NO_REPORTS' => _PRP_NOREPORTS,
		'L_REPORT_SUMMARY' => _PRP_REPORTSUMMARY,
		'L_SUBMIT_REPORT' => _PRP_REPORTSUBMIT,
		'L_NO_REQUESTS' => _PRP_NOREQUESTS,
		'L_REQUESTS' => _PRP_REQUESTS,
		'L_REQUEST_SUMMARY' => _PRP_REQUESTSUMMARY,
		'L_SUBMIT_REQUEST' => _PRP_REQUESTSUBMIT,
		'L_COMMENTS' => _PRP_COMMENTS,
		'L_EDIT' => _EDIT,
		'L_DELETE' => _DELETE,
		'L_MEMBERS' => _PRP_MEMBERS,
		'L_VIEW_PROJECT_REPORTS' => _PRP_VIEWPROJECTREPORTS,
		'L_VIEW_PROJECT_REQUESTS' => _PRP_VIEWPROJECTREQUESTS,
				
		'S_PROJECT_NAME' => $project_name,
		'S_PROJECT_NAME_HTML' => htmlprepare( $project_name ),
		'S_PROJECT_DESCRIPTION' => decode_bb_all($project_description, 1, false),
		'S_STATUS' => $status_name,
		'S_STATUS_HTML' => htmlprepare( $status_name ),
		'S_PRIORITY' => $priority_name,
		'S_PRIORITY_HTML' => htmlprepare( $priority_name ),
		'S_DATE_STARTED' => 0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA,
		'S_DATE_STARTED_HTML' => htmlprepare(0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA),
		'S_DATE_FINISHED' => 0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA,
		'S_DATE_FINISHED_HTML' => htmlprepare(0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA),
		'S_PERCENT_DONE' => 0 == $project_percent ? ( 0 == $db->sql_numrows( $result_tasks ) ? 0 : floor( $tasks_percent_total / $db->sql_numrows( $result_tasks ) ) ) : $project_percent,
		'S_PERCENT_TODO' => 99 < $project_percent ? 0 : ( 100 - ( 0 == $project_percent ? ( 0 == $db->sql_numrows( $result_tasks ) ? 0 : floor( $tasks_percent_total / $db->sql_numrows( $result_tasks ) ) ) : $project_percent ) ),
		'S_USER_COUNT' => $db->sql_numrows( $result_users ),
		'S_TASK_COUNT' => $db->sql_numrows( $result_tasks ),
		'S_REPORT_COUNT' => ($MAIN_CFG[$projectspro_base]['report_enable'] ? $db->sql_numrows($result_reports) : 0),
		'S_REQUEST_COUNT' => ($MAIN_CFG[$projectspro_base]['request_enable'] ? $db->sql_numrows($result_requests) : 0),
		
		'U_PROJECT' => getlink( '&amp;file=project&amp;project_id=' . $project_id ),
		'U_POSITION' => getlink( '&amp;file=position' ),
		'U_VIEW_PROJECT_TASK_DETAIL' => getlink('&amp;file=project_detail&amp;project_id=' . $project_id ),
		'U_REPORT_SUBMIT' => ( $MAIN_CFG[$projectspro_base]['report_enable'] && ($MAIN_CFG[$projectspro_base]['report_allow_anonymous'] || is_user()) ) ? getlink('&amp;file=report_submit&amp;project_id=' . $project_id ) : '',
		'U_REQUEST_SUBMIT' => ( $MAIN_CFG[$projectspro_base]['request_enable'] && ($MAIN_CFG[$projectspro_base]['request_allow_anonymous'] || is_user()) ) ? getlink('&amp;file=request_submit&amp;project_id=' . $project_id ) : '',
		'U_EDIT' => can_admin( $projectspro_base ) ? adminlink('&amp;mode=edit&amp;project_id=' . $project_id ) : '',
		'U_DELETE' => can_admin( $projectspro_base ) ? adminlink('&amp;mode=delete&amp;project_id=' . $project_id ) : '',
		'U_MEMBERS' => can_admin( $projectspro_base ) ? adminlink('&amp;file=projects_members&amp;project_id=' . $project_id ) : '',
		'U_VIEW_PROJECT_REPORTS' => ($MAIN_CFG[$projectspro_base]['report_enable'] ? getlink('&amp;file=reports_all&amp;project_id='.$project_id) : ''),
		'U_VIEW_PROJECT_REQUESTS' => ($MAIN_CFG[$projectspro_base]['request_enable'] ? getlink('&amp;file=requests_all&amp;project_id='.$project_id) : ''),
		)
	);
	
	$db->sql_freeresult( $result_users );
	$db->sql_freeresult( $result_tasks );
	if ($MAIN_CFG[$projectspro_base]['report_enable']) {
		$db->sql_freeresult( $result_reports );
	}
	if ($MAIN_CFG[$projectspro_base]['request_enable']) {
		$db->sql_freeresult( $result_requests );
	}

	$pagetitle .= ' ' . _BC_DELIM . ' ' . $project_name;
	
	require( 'header.php' );
	OpenTable();
	$cpgtpl->set_filenames( array( 'project' => 'ProjectsPro/project.html' ) );
	$cpgtpl->display( 'project' );
	CloseTable();
}

$pagetitle .= $module_title;
get_lang('ProjectsPro');
$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch( $mode ) {
	default:
		ProjectsPro_project();
		break;
}