<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Display the detailed project and task information                 |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 201 $
| $Author: jday29 $
| $Date: 2006-05-22 15:08:18 -0500 (Mon, 22 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'CPG_NUKE' ) ) {
	exit;
}

$projectspro_base = basename(dirname(__FILE__));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the projets list
 **/
function ProjectsPro_project_detail() {
	global $prefix, $user_prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	
	require_once(CORE_PATH.'nbbcode.php');
	
	// Validate the project id
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	if ( 0 == $project_id ) {
		url_redirect( getlink() );
	}

	// Add the project users to the template
	$result_users_project = $db->sql_query( 'SELECT pm.user_id, u.username, po.position_name FROM ' . $projectspro_prefix.'projects_members pm, ' . $user_prefix . '_users u, ' . $projectspro_prefix.'positions po WHERE pm.user_id = u.user_id AND pm.position_id = po.position_id AND pm.project_id = ' . $project_id, false, __FILE__, __LINE__ );
	while( list( $user_id, $username, $position_name ) = $db->sql_fetchrow( $result_users_project, SQL_NUM ) ) {
		$cpgtpl->assign_block_vars( 'member', array(
			'S_USERNAME' => $username,
			'S_POSITION_NAME' => $position_name,
			'S_POSITION_NAME_HTML' => htmlprepare( $position_name ),
			
			'U_PROFILE' => getlink( 'Your_Account&amp;profile=' . $user_id ),
			)
		);
	}
	
	// Add the tasks to the template
	$result_users_tasks = $db->sql_query( 'SELECT tm.task_id, tm.user_id, u.username, po.position_name FROM ' . $projectspro_prefix.'projects_members pm, ' . $projectspro_prefix.'tasks t, ' . $projectspro_prefix.'tasks_members tm, ' . $user_prefix . '_users u, ' . $projectspro_prefix.'positions po WHERE pm.project_id = t.project_id AND t.task_id = tm.task_id AND pm.user_id = tm.user_id AND tm.user_id = u.user_id AND pm.position_id = po.position_id AND pm.project_id = ' . $project_id, false, __FILE__, __LINE__ );
	$users_tasks = array();
	while( $row_user_task = $db->sql_fetchrow( $result_users_tasks, SQL_ASSOC ) ) {
		$users_tasks[$row_user_task['task_id']][] = $row_user_task;
	}
	$db->sql_freeresult( $result_users_tasks );
	$result_tasks = $db->sql_query( 'SELECT t.task_id, t.task_name, t.task_description, t.task_percent, s.status_name, pr.priority_name, t.date_started, t.date_finished FROM ' . $projectspro_prefix.'tasks t, ' . $projectspro_prefix.'status s, ' . $projectspro_prefix.'priorities pr WHERE t.status_id = s.status_id AND t.priority_id = pr.priority_id AND t.project_id = ' . $project_id . ' GROUP BY t.task_id ORDER BY pr.weight DESC, s.weight DESC, t.task_name ASC', false, __FILE__, __LINE__ );
	$tasks_percent_total = 0;
	while( list( $task_id, $task_name, $task_description, $task_percent, $status_name, $priority_name, $date_started, $date_finished ) = $db->sql_fetchrow( $result_tasks, SQL_NUM ) ) {
		$tasks_percent_total += $task_percent;
		$cpgtpl->assign_block_vars( 'task', array(
			'S_TASK_NAME' => $task_name,
			'S_TASK_NAME_HTML' => htmlprepare( $task_name ),
			'S_TASK_DESCRIPTION' => $task_description ? decode_bb_all( $task_description, 1, false) : _PRP_NA,
			'S_STATUS' => $status_name,
			'S_STATUS_HTML' => htmlprepare($status_name),
			'S_PRIORITY' => $priority_name,
			'S_PRIORITY_HTML' => htmlprepare($priority_name),
			'S_DATE_STARTED' => 0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA,
			'S_DATE_STARTED_HTML' => htmlprepare(0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA),
			'S_DATE_FINISHED' => 0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA,
			'S_DATE_FINISHED_HTML' => htmlprepare(0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA),
			'S_PERCENT_DONE' => 0 == $task_percent ? 0 : $task_percent,
			'S_PERCENT_TODO' => 99 < $task_percent ? 0 : ( 100 - $task_percent ),
			'S_USER_COUNT' => isset( $users_tasks[$task_id] ),
			
			'U_TASK' => getlink('&amp;file=task&amp;task_id=' . $task_id ),
			)
		);
		if ( isset( $users_tasks[$task_id] ) ) {
			foreach( $users_tasks[$task_id] as $user ) {
				$cpgtpl->assign_block_vars( 'task.member', array(
					'S_USERNAME' => $user['username'],
					'S_POSITION_NAME' => $user['position_name'],
					'S_POSITION_NAME_HTML' => htmlprepare( $user['position_name'] ),
					
					'U_PROFILE' => getlink( 'Your_Account&amp;profile=' . $user['user_id'] ),
					)
				);
			}
		}
	}

	list( $project_name, $project_description, $project_percent, $date_started, $date_finished, $status_name, $priority_name ) = $db->sql_ufetchrow( 'SELECT p.project_name, p.project_description, p.project_percent, p.date_started, p.date_finished, s.status_name, pr.priority_name FROM ' . $projectspro_prefix.'projects p, ' . $projectspro_prefix.'status s, ' . $projectspro_prefix.'priorities pr WHERE p.status_id = s.status_id AND p.priority_id = pr.priority_id AND p.project_id = ' . $project_id, SQL_NUM, __FILE__, __LINE__ );
	$cpgtpl->assign_vars( array(
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_PROJECT_DESCRIPTION' => _PRP_PROJECTDESCRIPTION,
		'L_PROJECT_DETAILS' => _PRP_PROJECTDETAILS,
		'L_STATUS' => _PRP_STATUS,
		'L_PRIORITY' => _PRP_PRIORITY,
		'L_PROGRESS' => _PRP_PROGRESS,
		'L_PERCENT' => _PRP_PERCENT . ' ' . _PRP_COMPLETED,
		'L_DATE_START' => _PRP_STARTDATE,
		'L_DATE_FINISH' => _PRP_FINISHDATE,
		'L_PROJECT_MEMBERS' => _PRP_MEMBERSPROJECT,
		'L_POSITION' => _PRP_POSITION,
		'L_TASKS' => _PRP_TASKS,
		'L_MEMBERS' => _PRP_MEMBERS,
		'L_NO_MEMBERS_PROJECT' => _PRP_NOMEMBERSPROJECT,
		'L_NO_TASKS' => _PRP_NOTASKS,
		'L_MEMBER' => _PRP_MEMBER,
		'L_POSITION' => _PRP_POSITION,
		'L_TASK_NAME' => _PRP_TASKNAME,
		'L_NO_TASK_MEMBERS' => _PRP_NOMEMBERSTASK,
		'L_TASK_NAME' => _PRP_TASKNAME,
		'L_TASK_DESCRIPTION' => _PRP_TASKDESCRIPTION,
		'L_TASK_MEMBERS' => _PRP_TASKMEMBERS,
		'L_TASK_DETAILS' => _PRP_TASKDETAILS,
				
		'S_PROJECT_NAME' => $project_name,
		'S_PROJECT_NAME_HTML' => htmlprepare( $project_name ),
		'S_PROJECT_DESCRIPTION' => $project_description ? decode_bb_all($project_description, 1, false) : _PRP_NA,
		'S_STATUS' => $status_name,
		'S_STATUS_HTML' => htmlprepare($status_name),
		'S_PRIORITY' => $priority_name,
		'S_PRIORITY_HTML' => htmlprepare($priority_name),
		'S_DATE_STARTED' => 0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA,
		'S_DATE_STARTED_HTML' => htmlprepare(0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA),
		'S_DATE_FINISHED' => 0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA,
		'S_DATE_FINISHED_HTML' => htmlprepare(0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA),
		'S_PERCENT_DONE' => 0 == $project_percent ? ( 0 == $db->sql_numrows( $result_tasks ) ? 0 : floor( $tasks_percent_total / $db->sql_numrows( $result_tasks ) ) ) : $project_percent,
		'S_PERCENT_TODO' => 99 < $project_percent ? 0 : ( 100 - ( 0 == $project_percent ? ( 0 == $db->sql_numrows( $result_tasks ) ? 0 : floor( $tasks_percent_total / $db->sql_numrows( $result_tasks ) ) ) : $project_percent ) ),
		'S_USER_COUNT' => $db->sql_numrows( $result_users_project ),
		'S_TASK_COUNT' => $db->sql_numrows( $result_tasks ),
		
		'U_POSITION' => getlink('&amp;file=position' ),
		'U_PROJECT' => getlink('&amp;file=project&amp;project_id=' . $project_id ),
		)
	);
	
	$db->sql_freeresult( $result_users_project );
	$db->sql_freeresult( $result_tasks );

	$pagetitle .= ' ' . _BC_DELIM . ' ' . $project_name;
	
	require( 'header.php' );
	OpenTable();
	$cpgtpl->set_filenames( array( 'project_detail' => 'ProjectsPro/project_detail.html' ) );
	$cpgtpl->display( 'project_detail' );
	CloseTable();
}

$pagetitle .= $module_title;
get_lang('ProjectsPro');
$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch( $mode ) {
	default:
		ProjectsPro_project_detail();
		break;
}