<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Display a list of all the projects                                |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 201 $
| $Author: jday29 $
| $Date: 2006-05-22 15:08:18 -0500 (Mon, 22 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'CPG_NUKE' ) ) {
	exit;
}

$projectspro_base = basename(dirname(__FILE__));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display all of the projects and their tasks
 **/
function ProjectsPro_projects_all() {
	global $prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	
	require_once(CORE_PATH.'nbbcode.php');
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_ALLPROJECTSTASKS;
	
	$result_tasks = $db->sql_query( 'SELECT t.project_id, t.task_id, t.task_name, s.status_name, pr.priority_name, t.task_percent, count(tm.user_id) as user_count FROM ' . $projectspro_prefix.'status s, ' . $projectspro_prefix.'priorities pr, ( ' . $projectspro_prefix.'tasks t LEFT JOIN ' . $projectspro_prefix.'tasks_members tm ON t.task_id = tm.task_id ) WHERE t.status_id = s.status_id AND t.priority_id = pr.priority_id GROUP BY t.task_id ORDER BY pr.weight DESC, s.weight DESC, t.task_name ASC', false, __FILE__, __LINE__ );
	$tasks = array();
	$tasks_percent_total = array();
	while( $row_tasks = $db->sql_fetchrow( $result_tasks, SQL_ASSOC ) ) {
		if ( !isset( $tasks_percent_total[$row_tasks['project_id']] ) ) {
			$tasks_percent_total[$row_tasks['project_id']] = 0;
		}
		$tasks_percent_total[$row_tasks['project_id']] += $row_tasks['task_percent'];
		$tasks[$row_tasks['project_id']][] = $row_tasks;
	}
	$db->sql_freeresult( $result_tasks );

	$result_projects = $db->sql_query( 'SELECT p.project_id, p.project_name, s.status_name, pr.priority_name, p.project_percent, count(pm.user_id) as user_count FROM ' . $projectspro_prefix.'status s, ' . $projectspro_prefix.'priorities pr, ( ' . $projectspro_prefix.'projects p LEFT JOIN ' . $projectspro_prefix.'projects_members pm ON p.project_id = pm.project_id ) WHERE p.status_id = s.status_id AND p.priority_id = pr.priority_id GROUP BY p.project_id ORDER BY p.weight ASC, pr.weight DESC, s.weight DESC', false, __FILE__, __LINE__ );

	$cpgtpl->assign_vars( array(
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_PROJECT_DETAILS' => _PRP_PROJECTDETAILS,
		'L_STATUS' => _PRP_STATUS,
		'L_PRIORITY' => _PRP_PRIORITY,
		'L_PROGRESS' => _PRP_PROGRESS,
		'L_PERCENT' => _PRP_PERCENT . ' ' . _PRP_COMPLETED,
		'L_MEMBERS' => _PRP_MEMBERS,
		'L_TASK_DETAILS' => _PRP_TASKDETAILS,
		'L_NO_TASKS' => _PRP_NOTASKS,
		'L_TASK_NAME' => _PRP_TASKNAME,
		)
	);
	
	while( list( $project_id, $project_name, $status_name, $priority_name, $project_percent, $user_count ) = $db->sql_fetchrow( $result_projects, SQL_NUM ) ) {
		$cpgtpl->assign_block_vars( 'project', array(
			'S_PROJECT_NAME' => $project_name,
			'S_PROJECT_NAME_HTML' => htmlprepare($project_name),
			'S_STATUS' => $status_name,
			'S_STATUS_HTML' => htmlprepare($status_name),
			'S_PRIORITY' => $priority_name,
			'S_PRIORITY_HTML' => htmlprepare($priority_name),
			'S_USER_COUNT' => $user_count,
			'S_PERCENT_DONE' => 0 == $project_percent ? ( 0 == count( $tasks[$project_id] ) ? 0 : floor( $tasks_percent_total[$project_id] / count( $tasks[$project_id] ) ) ) : $project_percent,
			'S_PERCENT_TODO' => 99 < $project_percent ? 0 : ( 100 - ( 0 == $project_percent ? ( 0 == count( $tasks[$project_id] ) ? 0 : floor( $tasks_percent_total[$project_id] / count( $tasks[$project_id] ) ) ) : $project_percent ) ),
			'S_TASK_COUNT' => isset( $tasks[$project_id] ) ? count( $tasks[$project_id] ) : 0,
			
			'U_PROJECT' => getlink( '&amp;file=project&amp;project_id=' . $project_id ),
			)
		);
		
		if ( isset( $tasks[$project_id] ) ) {
			foreach( $tasks[$project_id] as $project_id => $task ) {
				$cpgtpl->assign_block_vars( 'project.task', array(
					'S_TASK_NAME' => $task['task_name'],
					'S_TASK_NAME_HTML' => htmlprepare($task['task_name']),
					'S_STATUS' => $task['status_name'],
					'S_STATUS_HTML' => htmlprepare($task['status_name']),
					'S_PRIORITY' => $task['priority_name'],
					'S_PRIORITY_HTML' => htmlprepare($task['priority_name']),
					'S_USER_COUNT' => $task['user_count'],
					'S_PERCENT_DONE' => 0 == $task['task_percent'] ? 0 : $task['task_percent'],
					'S_PERCENT_TODO' => 99 < $task['task_percent'] ? 0 : ( 100 - $task['task_percent'] ),
					
					'U_TASK' => getlink('&amp;file=task&amp;task_id=' . $task['task_id'] ),
					)
				);
			}
		}
	}
	$db->sql_freeresult( $result_projects );

	require( 'header.php' );
	OpenTable();
	$cpgtpl->set_filenames( array( 'projects_all' => 'ProjectsPro/projects_all.html' ) );
	$cpgtpl->display( 'projects_all' );
	CloseTable();
}

$pagetitle .= $module_title;
get_lang('ProjectsPro');
$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch( $mode ) {
	default:
		ProjectsPro_projects_all();
		break;
}