<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Displays the list of bug reports for a project                    |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 248 $
| $Author: jday29 $
| $Date: 2006-09-15 09:33:45 -0500 (Fri, 15 Sep 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if (!defined('CPG_NUKE')) {
	exit;
}

$projectspro_base = basename(dirname(__FILE__));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Turn comment notifications on or off
 **/
function ProjectsPro_report_notify_comment() {
	global $db, $prefix, $projectspro_prefix;
	
	$report_id = isset($_GET['report_id']) ? intval($_GET['report_id']) : 0;
	if (0 == $report_id || !is_user()) {
		url_redirect(getlink());
	}
	
	list($user_id, $notify_comment) = $db->sql_ufetchrow('SELECT user_id, notify_comment FROM '.$projectspro_prefix.'reports WHERE report_id = '.$report_id, SQL_NUM);
	if (is_user() != $user_id) {
		url_redirect(getlink());
	}
	$db->sql_query('UPDATE '.$projectspro_prefix.'reports SET notify_comment = '.($notify_comment ? 0 : 1).' WHERE report_id = '.$report_id);
	
	url_redirect(getlink('&amp;file=report&amp;report_id='.$report_id));
}

/**
 * Display the report
 **/
function ProjectsPro_report() {
	global $prefix, $user_prefix, $db, $pagetitle, $cpgtpl, $MAIN_CFG, $projectspro_base, $projectspro_prefix, $CPG_SESS, $userinfo;
	
	require_once(CORE_PATH.'nbbcode.php');
	
	$report_id = isset($_GET['report_id']) ? intval($_GET['report_id']) : 0;
	if (0 == $report_id) {
		url_redirect(getlink());
	}

	list($project_id, $project_name, $summary, $description, $reproduce, $expected, $actual, $status_name, $name, $date_created, $date_started, $date_finished, $task_id, $notify_comment, $user_id, $username) = $db->sql_ufetchrow('SELECT r.project_id, p.project_name, r.summary, r.description, r.reproduce, r.expected, r.actual, s.status_name, rt.name, r.date_created, r.date_started, r.date_finished, r.task_id, r.notify_comment, u.user_id, u.username FROM ' . $projectspro_prefix.'reports r, ' . $projectspro_prefix.'projects p, ' . $projectspro_prefix.'status s, ' . $projectspro_prefix.'types rt, ' . $user_prefix . '_users u WHERE r.project_id = p.project_id AND r.status_id = s.status_id AND r.type_id = rt.type_id AND r.user_id = u.user_id AND r.report_id = ' . $report_id . ' LIMIT 0, 1', SQL_NUM, __FILE__, __LINE__);
	if (!is_numeric($project_id)) {
		url_redirect(getlink());
	}
	
	// Select the report members
	$result_users = $db->sql_query( 'SELECT rm.user_id, u.username, po.position_name FROM ' . $projectspro_prefix.'projects_members pm, ' . $projectspro_prefix.'reports_members rm, ' . $user_prefix . '_users u, ' . $projectspro_prefix.'positions po WHERE pm.user_id = rm.user_id AND pm.position_id = po.position_id AND rm.user_id = u.user_id AND pm.project_id = ' . $project_id . ' AND rm.report_id = ' . $report_id, false, __FILE__, __LINE__ );
	$comment_allowed = false;
	while( list( $user_id, $username, $position_name ) = $db->sql_fetchrow( $result_users, SQL_NUM ) ) {
		$cpgtpl->assign_block_vars( 'member', array(
			'S_USERNAME' => $username,
			'S_POSITION_NAME' => $position_name,
			'S_POSITION_NAME_HTML' => htmlprepare($position_name),
			
			'U_PROFILE' => getlink( 'Your_Account&amp;profile=' . $user_id ),
			)
		);
		if ( is_user() == $user_id ) {
			$comment_allowed = true;
		}
	}
	
	// Create the comments list
	$result_comments = $db->sql_query('SELECT c.comment_id, c.user_id, u.username, c.description, c.date_created FROM ' . $projectspro_prefix.'comments c, ' . $user_prefix . '_users u WHERE c.user_id = u.user_id AND c.join_type = 2 AND c.join_id = ' . $report_id . ' ORDER BY c.date_created ASC', false, __FILE__, __LINE__);
	while(list($comment_id, $user_id, $comment_username, $comment_description, $comment_date_created) = $db->sql_fetchrow($result_comments, SQL_NUM)) {
		$cpgtpl->assign_block_vars('comment', array(
			'S_USERNAME' => $comment_username,
			'S_COMMENT_ID' => $comment_id,
			'S_DESCRIPTION' => decode_bb_all($dcomment_escription, 1, false),
			'S_DATE_CREATED' => 0 < $comment_date_created ? formatDateTime($comment_date_created, _DATESTRING) : _PRP_NA,
			'S_DATE_CREATED_HTML' => htmlprepare(0 < $comment_date_created ? formatDateTime($comment_date_created, _DATESTRING) : _PRP_NA),
			
			'U_PROFILE' => getlink('Your_Account&amp;profile=' . $user_id),
			'U_EDIT' => (can_admin($projectspro_base) || (is_user() == $user_id && 1 < $user_id)) ? getlink('&amp;file=report_comment&amp;report_id=' . $report_id . '&amp;comment_id=' . $comment_id) : '',
			'U_DELETE' => (can_admin($projectspro_base) || (is_user() == $user_id && 1 < $user_id)) ? getlink('&amp;file=report_comment&amp;mode=delete&amp;report_id=' . $report_id . '&amp;comment_id=' . $comment_id) : '',
			)
		);
	}
	
	$CPG_SESS[$projectspro_base]['track_report'][$project_id][$report_id] = gmtime();
	
	$cpgtpl->assign_vars(array(
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_REPORT_SUMMARY' => _PRP_REPORTSUMMARY,
		'L_REPORT_DESCRIPTION' => _PRP_REPORTDESCRIPTION,
		'L_REPORT_REPRODUCE' => _PRP_REPORTREPRODUCE,
		'L_REPORT_EXPECTED' => _PRP_REPORTEXPECTED,
		'L_REPORT_ACTUAL' => _PRP_REPORTACTUAL,
		'L_STATUS' => _PRP_STATUS,
		'L_DATE_CREATED' => _PRP_CREATEDATE,
		'L_DATE_START' => _PRP_STARTDATE,
		'L_DATE_FINISH' => _PRP_FINISHDATE,
		'L_SUBMITTED_BY' => _PRP_SUBMITTEDBY,
		'L_TYPE' => _PRP_TYPE,
		'L_REPORT_DETAILS' => _PRP_REPORTDETAILS,
		'L_REPORT_SUMMARY' => _PRP_REPORTSUMMARY,
		'L_REPORT_COMMENTS' => _PRP_REPORTCOMMENTS,
		'L_POSITION' => _PRP_POSITION,
		'L_REPORT_MEMBERS' => _PRP_REPORTMEMBERS,
		'L_MEMBER' => _PRP_MEMBER,
		'L_NO_REPORT_MEMBERS' => _PRP_NOMEMBERSREPORT,
		'L_NO_REPORT_COMMENTS' => _PRP_NOREPORTCOMMENTS,
		'L_COMMENT_ADD' => _PRP_REPORTCOMMENTADD,
		'L_EDIT' => _EDIT,
		'L_DELETE' => _DELETE,
		'L_TASK' => _PRP_TASK,
		'L_PROMOTED_TO_TASK' => $task_id ? sprintf(_PRP_REPORTPROMOTEDTOTASK, getlink('&amp;file=task&amp;task_id=' . $task_id)) : '',
		'L_NOTIFY_COMMENT' => (is_user()==$user_id ? ($notify_comment ? _PRP_REPORTNOTIFYCOMMENTTURNOFF : _PRP_REPORTNOTIFYCOMMENTTURNON) : ''),

		'S_PROJECT_NAME' => $project_name,
		'S_PROJECT_NAME_HTML' => htmlprepare($project_name),
		'S_REPORT_SUMMARY' => $summary,
		'S_REPORT_SUMMARY_HTML' => htmlprepare($summary),
		'S_REPORT_DESCRIPTION' => decode_bb_all($description, 1, false),
		'S_REPORT_REPRODUCE' => decode_bb_all($reproduce, 1, false),
		'S_REPORT_EXPECTED' => decode_bb_all($expected, 1, false),
		'S_REPORT_ACTUAL' => decode_bb_all($actual, 1, false),
		'S_STATUS_NAME' => $status_name,
		'S_STATUS_NAME_HTML' => htmlprepare($status_name),
		'S_TYPE' => $name,
		'S_TYPE_HTML' => htmlprepare($name),
		'S_DATE_CREATED' => L10NTime::strftime(_DATESTRING, $date_created, 0, 0),
		'S_DATE_CREATED_HTML' => htmlprepare(L10NTime::strftime(_DATESTRING, $date_created, 0, 0)),
		'S_DATE_STARTED' => 0 < $date_started ? L10NTime::strftime(_DATESTRING, $date_started, 0, 0) : _PRP_NA,
		'S_DATE_STARTED_HTML' => htmlprepare(0 < $date_started ? L10NTime::strftime(_DATESTRING, $date_started, 0, 0) : _PRP_NA),
		'S_DATE_FINISHED' => 0 < $date_finished ? L10NTime::strftime(_DATESTRING, $date_finished, 0, 0) : _PRP_NA,
		'S_DATE_FINISHED_HTML' => htmlprepare(0 < $date_finished ? L10NTime::strftime(_DATESTRING, $date_finished, 0, 0) : _PRP_NA),
		'S_USER_COUNT' => $db->sql_numrows( $result_users ),
		'S_USERNAME' => $username,
		'S_COMMENT_COUNT' => $db->sql_numrows($result_comments),
		
		'U_PROJECT' => getlink('&amp;file=project&amp;project_id=' . $project_id),
		'U_REPORT' => getlink('&amp;file=report&amp;report_id=' . $report_id),
		'U_POSITION' => getlink('&amp;file=position' ),
		'U_PROFILE' => getlink('Your_Account&amp;profile=' . $user_id),
		'U_COMMENT_ADD' => ($MAIN_CFG[$projectspro_base]['report_comment_allow_anonymous'] || is_user()) ? getlink('&amp;file=report_comment&amp;report_id=' . $report_id) : '',
		'U_EDIT' => can_admin($projectspro_base) ? adminlink('&amp;file=reports&amp;mode=edit&amp;report_id=' . $report_id) : '',
		'U_DELETE' => can_admin($projectspro_base) ? adminlink('&amp;file=reports&amp;mode=delete&amp;report_id=' . $report_id) : '',
		'U_NOTIFY_COMMENT' => (is_user()==$user_id ? getlink('&amp;file=report&amp;mode=notify_comment&amp;report_id='.$report_id) : ''),
		)
	);
	
	$db->sql_freeresult($result_comments);
	$db->sql_freeresult($result_users);
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . $project_name . ' ' . _BC_DELIM . ' ' . $summary;
	
	require('header.php');
	OpenTable();
	$cpgtpl->set_filenames(array('report' => 'ProjectsPro/report.html'));
	$cpgtpl->display('report');
	CloseTable();
}

if (!$MAIN_CFG[$projectspro_base]['report_enable']) {
	url_redirect(getlink());
}

$pagetitle .= $module_title;
get_lang('ProjectsPro');
$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch($mode) {
	case 'notify_comment':
		ProjectsPro_report_notify_comment();
		break;
	default:
		ProjectsPro_report();
		break;
}