<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Allows a user to submit a comment on a bug report                 |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 204 $
| $Author: jday29 $
| $Date: 2006-05-24 19:11:40 -0500 (Wed, 24 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'CPG_NUKE' ) ) {
	exit;
}

$projectspro_base = basename(dirname(__FILE__));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the add comment form
 **/
function ProjectsPro_report_comment() {
	global $prefix, $user_prefix, $db, $cpgtpl, $pagetitle, $projectspro_prefix, $projectspro_base;
	
	$report_id = isset( $_GET['report_id'] ) ? intval( $_GET['report_id'] ) : 0;
	$comment_id = isset( $_GET['comment_id'] ) ? intval( $_GET['comment_id'] ) : 0;
	if ( 0 == $report_id ) {
		url_redirect( getlink() );
	}
	
	require_once(CORE_PATH.'nbbcode.php');
	
	if ( 0 < $comment_id ) {
		// Edit a comment
		list( $comment_description, $user_id ) = $db->sql_ufetchrow( 'SELECT description, user_id FROM ' . $projectspro_prefix.'comments WHERE comment_id = ' . $comment_id, SQL_NUM, __FILE__, __LINE__ );
		if ( !can_admin( $projectspro_base ) && ( 1 == $user_id || is_user() != $user_id ) ) {
			url_redirect( getlink('&amp;file=report&amp;report_id=' . $report_id ) );
		}
	} else {
		$comment_description = '';
	}

	list( $project_id, $project_name, $summary, $description, $reproduce, $expected, $actual, $status_name, $name, $date_started, $date_finished, $user_id, $username ) = $db->sql_ufetchrow( 'SELECT r.project_id, p.project_name, r.summary, r.description, r.reproduce, r.expected, r.actual, s.status_name, rt.name, r.date_started, r.date_finished, u.user_id, u.username FROM ' . $projectspro_prefix.'reports r, ' . $projectspro_prefix.'projects p, ' . $projectspro_prefix.'status s, ' . $projectspro_prefix.'types rt, ' . $user_prefix . '_users u WHERE r.project_id = p.project_id AND r.status_id = s.status_id AND r.type_id = rt.type_id AND r.user_id = u.user_id AND r.report_id = ' . $report_id . ' LIMIT 0, 1', SQL_NUM, __FILE__, __LINE__ );
	
	$cpgtpl->assign_vars( array(
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_REPORT_SUMMARY' => _PRP_REPORTSUMMARY,
		'L_REPORT_DESCRIPTION' => _PRP_REPORTDESCRIPTION,
		'L_REPORT_REPRODUCE' => _PRP_REPORTREPRODUCE,
		'L_REPORT_EXPECTED' => _PRP_REPORTEXPECTED,
		'L_REPORT_ACTUAL' => _PRP_REPORTACTUAL,
		'L_STATUS' => _PRP_STATUS,
		'L_DATE_START' => _PRP_STARTDATE,
		'L_DATE_FINISH' => _PRP_FINISHDATE,
		'L_SUBMITTED_BY' => _PRP_SUBMITTEDBY,
		'L_TYPE' => _PRP_TYPE,
		'L_REPORT_DETAILS' => _PRP_REPORTDETAILS,
		'L_REPORT_SUMMARY' => _PRP_REPORTSUMMARY,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		'L_COMMENT' => ( 0 < $comment_id ? _PRP_REPORTCOMMENTEDIT : _PRP_REPORTCOMMENTADD ),
		
		'S_BBCODE_DESCRIPTION' => bbcode_table( 'description', 'report_comment', 1 ),
		'S_FORM_OPEN_REPORT_COMMENT' => open_form( getlink('&amp;file=report_comment&amp;mode=save' . ( 0 < $comment_id ? '&amp;comment_id=' . $comment_id : '' ) . '&amp;report_id=' . $report_id ), 'report_comment', ( 0 < $comment_id ? _PRP_REPORTCOMMENTEDIT : _PRP_REPORTCOMMENTADD ) ),
		'S_FORM_CLOSE_REPORT_COMMENT' => close_form(),

		'S_PROJECT_NAME' => $project_name,
		'S_PROJECT_NAME_HTML' => htmlprepare($project_name),
		'S_REPORT_SUMMARY' => $summary,
		'S_REPORT_SUMMARY_HTML' => htmlprepare($summary),
		'S_REPORT_DESCRIPTION' => decode_bb_all( $description, 1, false),
		'S_REPORT_REPRODUCE' => decode_bb_all( $reproduce, 1, false),
		'S_REPORT_EXPECTED' => decode_bb_all( $expected, 1, false),
		'S_REPORT_ACTUAL' => decode_bb_all( $actual, 1, false),
		'S_STATUS_NAME' => $status_name,
		'S_STATUS_NAME_HTML' => htmlprepare($status_name),
		'S_TYPE' => $name,
		'S_TYPE_HTML' => htmlprepare($name),
		'S_DATE_STARTED' => 0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA,
		'S_DATE_STARTED_HTML' => htmlprepare(0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA),
		'S_DATE_FINISHED' => 0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA,
		'S_DATE_FINISHED_HTML' => htmlprepare(0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA),
		'S_USERNAME' => $username,
		'S_DESCRIPTION' => htmlprepare( $comment_description ),
		
		'U_PROJECT' => getlink( '&amp;file=project&amp;project_id=' . $project_id ),
		'U_PROFILE' => getlink( 'Your_Account&amp;profile=' . $user_id ),
		'U_REPORT' => getlink('&amp;file=report&amp;report_id=' . $report_id ),
		)
	);
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . $project_name . ' ' . _BC_DELIM . ' ' . $summary . ' ' . _BC_DELIM . ' ' . ( 0 < $comment_id ? _PRP_REPORTCOMMENTEDIT : _PRP_REPORTCOMMENTADD );
	
	require( 'header.php' );
	OpenTable();
	$cpgtpl->set_filenames( array( 'report_comment' => 'ProjectsPro/report_comment.html' ) );
	$cpgtpl->display( 'report_comment' );
	CloseTable();
}

/**
 * Save a report comment
 **/
function ProjectsPro_report_comment_save() {
	global $prefix, $user_prefix, $db, $userinfo, $cpgtpl, $projectspro_prefix, $projectspro_base, $CPG_SESS;
	
	$report_id = isset( $_GET['report_id'] ) ? intval( $_GET['report_id'] ) : 0;
	$description = isset( $_POST['description'] ) ? $_POST['description'] : '';
	$comment_id = isset( $_GET['comment_id'] ) ? intval( $_GET['comment_id'] ) : 0;
	
	// Validate the report id
	if ( 0 == $report_id ) {
		url_redirect( getlink() );
	} elseif ( '' == $description ) {
		cpg_error( _PRP_REPORTCOMMENTINVALID );
	}

	if ( 0 < $comment_id ) {
		// Edit a comment
		list( $user_id ) = $db->sql_ufetchrow( 'SELECT user_id FROM ' . $projectspro_prefix.'comments WHERE comment_id = ' . $comment_id, SQL_NUM, __FILE__, __LINE__ );
		if ( !can_admin( $projectspro_base ) && ( 1 == $user_id || is_user() != $user_id ) ) {
			url_redirect( getlink('&amp;file=report&amp;report_id=' . $report_id ) );
		}
	}

	// Save the report comment
	if ( 0 < $comment_id ) {
		$db->sql_query( 'UPDATE ' . $projectspro_prefix . "comments SET description = '" . Fix_Quotes($description) . "' WHERE comment_id = " . $comment_id, false, __FILE__, __LINE__ );
	} else {
		$db->sql_query( 'INSERT INTO ' . $projectspro_prefix.'comments (join_id, join_type, user_id, ip, description, date_created) VALUES (' . $report_id . ', 2, ' . $userinfo['user_id'] . ", '" . $userinfo['user_ip'] . "', '" . Fix_Quotes($description) . "', " . gmtime() . ')', false, __FILE__, __LINE__ );
	}
	
	# Notify the user on administrator comments (reports do not have members)
	list($project_id, $project_name, $user_id, $notify_comment, $user_email) = $db->sql_ufetchrow('SELECT p.project_id, p.project_name, r.user_id, r.notify_comment, u.user_email FROM '.$projectspro_prefix.'projects p, ( '.$projectspro_prefix.'reports r LEFT JOIN '.$user_prefix.'_users u ON r.user_id = u.user_id ) WHERE p.project_id = r.project_id AND r.report_id = '.$report_id, SQL_NUM);
	$CPG_SESS[$projectspro_base]['track_report'][$project_id][$report_id] = gmtime();
	if (can_admin($projectspro_base) && is_user()) {
		if ($notify_comment && $userinfo['user_id']!=$user_id && 1<$user_id) {
			require_once(CORE_PATH.'nbbcode.php');
			$cpgtpl->assign_vars(array(
				'L_REPORT_COMMENT_SUBMITTED' => _PRP_REPORTADMINCOMMENTSUBMITTED,
				'L_PROJECT_NAME' => _PRP_PROJECTNAME,
				'L_DESCRIPTION' => _PRP_REPORTDESCRIPTION,
				'L_SUBMITTED_BY' => _PRP_SUBMITTEDBY,
				'L_REPORT' => _PRP_REPORT,
				
				'S_SUBMITTED_BY' => $userinfo['username'],
				'S_PROJECT_NAME' => $project_name,
				'S_PROJECT_NAME_HTML' => htmlprepare($project_name),
				'S_DESCRIPTION' => decode_bb_all($description, 1, false),
				'S_REPORT_ID' => $report_id,
				
				'U_REPORT' => getlink('&amp;file=report&amp;report_id='.$report_id, true, true),
				'U_SUBMITTED_BY' => getlink('Your_Account&amp;profile='.$userinfo['user_id'], true, true),
				)
			);
			
			ob_start();
			$cpgtpl->set_filenames(array('report_comment_email' => 'ProjectsPro/report_comment_email.html'));
			$cpgtpl->display('report_comment_email');
			$message = ob_get_clean();

			send_mail( $mailer_message, $message, 1, _PRP_REPORTADMINCOMMENTSUBMITTED, $user_email );
		}
	}

	cpg_error( _PRP_REPORTCOMMENTSUBMITTED, _TB_INFO, getlink('&amp;file=report&amp;report_id=' . $report_id ) );
}

/**
 * Delete a comment
 **/
function ProjectsPro_report_comment_delete() {
	global $prefix, $db, $userinfo, $projectspro_prefix, $projectspro_base;
	
	$report_id = isset( $_GET['report_id'] ) ? intval( $_GET['report_id'] ) : 0;
	$comment_id = isset( $_GET['comment_id'] ) ? intval( $_GET['comment_id'] ) : 0;
	
	// Validate the report id
	if ( 0 == $report_id ) {
		url_redirect( getlink() );
	} elseif ( 0 == $comment_id || isset( $_POST['cancel'] ) ) {
		url_redirect( getlink('&amp;file=report&amp;report_id=' . $report_id ) );
	}

	// verify the user can delete the comment
	list( $user_id ) = $db->sql_ufetchrow( 'SELECT user_id FROM ' . $projectspro_prefix.'comments WHERE comment_id = ' . $comment_id, SQL_NUM, __FILE__, __LINE__ );
	if ( !can_admin( $projectspro_base) && ( 1 == $user_id || is_user() != $user_id ) ) {
		url_redirect( getlink('&amp;file=report&amp;report_id=' . $report_id ) );
	}

	// User confirmed the delete
	if ( isset( $_POST['confirm'] ) ) {
		// Delete the comment
		$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'comments WHERE comment_id = ' . $comment_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'comments', false, __FILE__, __LINE__ );
		
		url_redirect( getlink('&amp;file=report&amp;report_id=' . $report_id ) );
	}
	
	// Display the confirmation message
	cpg_delete_msg( getlink('&amp;file=report_comment&amp;mode=delete&amp;report_id=' . $report_id . '&amp;comment_id=' . $comment_id ), _PRP_REPORTCOMMENTDELETECONFIRM );
}


if (!$MAIN_CFG[$projectspro_base]['report_enable']) {
	url_redirect(getlink());
}

# Verify the user is allowed here
if ( !$MAIN_CFG[$projectspro_base]['report_comment_allow_anonymous'] && !is_user() ) {
	$report_id = isset( $_GET['report_id'] ) ? intval( $_GET['report_id'] ) : 0;
	url_redirect( getlink(( $report_id ? '&amp;file=report&amp;report_id=' . $report_id : '' ) ) );
}

$pagetitle .= $module_title;
get_lang('ProjectsPro');
$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch( $mode ) {
	case 'save':
		ProjectsPro_report_comment_save();
		break;
	case 'delete':
		ProjectsPro_report_comment_delete();
		break;
	default:
		ProjectsPro_report_comment();
		break;
}