<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Allows a user to submit a bug report                              |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 204 $
| $Author: jday29 $
| $Date: 2006-05-24 19:11:40 -0500 (Wed, 24 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if (!defined('CPG_NUKE')) {
	exit;
}

$projectspro_base = basename(dirname(__FILE__));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Save a submitted report
 **/
function ProjectsPro_report_submit_save() {
	global $prefix, $db, $userinfo, $MAIN_CFG, $cpgtpl, $projectspro_prefix, $projectspro_base, $CPG_SESS;
	
	require_once(CORE_PATH.'nbbcode.php');
	
	$project_id = isset($_POST['project_id']) ? intval($_POST['project_id']) : 0;
	$summary = isset($_POST['summary']) ? $_POST['summary'] : '';
	$type_id = isset($_POST['type_id']) ? intval($_POST['type_id']) : 0;
	$description = isset($_POST['description']) ? $_POST['description'] : '';
	$reproduce = isset($_POST['reproduce']) ? $_POST['reproduce'] : '';
	$expected = isset($_POST['expected']) ? $_POST['expected'] : '';
	$actual = isset($_POST['actual']) ? $_POST['actual'] : '';
	$notify_comment = (is_user() && isset($_POST['notify_comment'])) ? intval($_POST['notify_comment']) : 0;
	
	if (0==$project_id) {
		url_redirect( getlink() );
	} elseif (''==$summary) {
		cpg_error(_PRP_REPORTSUBMITINVALIDSUMMARY);
	} elseif (''==$description) {
		cpg_error(_PRP_REPORTSUBMITINVALIDDESCRIPTION);
	}
	
	// Submit the report
	$db->sql_query('INSERT INTO '.$projectspro_prefix.'reports (project_id, type_id, status_id, summary, description, reproduce, expected, actual, user_id, ip, date_created, date_started, date_finished, notify_comment) VALUES ('.$project_id.', '.$type_id.", '".$MAIN_CFG[$projectspro_base]['status_id_report_new']."', '".Fix_Quotes($summary)."', '".Fix_Quotes($description)."', '".Fix_Quotes($reproduce)."', '".Fix_Quotes($expected)."', '".Fix_Quotes($actual)."', ".$userinfo['user_id'].", '".$userinfo['user_ip']."', ".gmtime().', 0, 0, '.$notify_comment.')', false, __FILE__, __LINE__);
	$report_id = $db->sql_nextid('report_id');
	$CPG_SESS[$projectspro_base]['track_report'][$project_id][$report_id] = gmtime();

	if ($MAIN_CFG[$projectspro_base]['notify_admin_report']) {
		list($project_name) = $db->sql_ufetchrow('SELECT project_name FROM '.$projectspro_prefix.'projects WHERE project_id = '.$project_id, SQL_NUM, __FILE__, __LINE__);
		list($type) = $db->sql_ufetchrow('SELECT name FROM '.$projectspro_prefix.'types WHERE type_id = '.$type_id, SQL_NUM);

		$cpgtpl->assign_vars( array(
			'L_PROJECT_NAME' => _PRP_PROJECTNAME,
			'L_TYPE' => _TYPE,
			'L_SUMMARY' => _PRP_REPORTSUMMARY,
			'L_DESCRIPTION' => _PRP_REPORTDESCRIPTION,
			'L_REPRODUCE' => _PRP_REPORTREPRODUCE,
			'L_EXPECTED' => _PRP_REPORTEXPECTED,
			'L_ACTUAL' => _PRP_REPORTACTUAL,
			'L_SUBMITTED_BY' => _PRP_SUBMITTEDBY,
			'L_REPORT_CREATED_MESSAGE' => _PRP_REPORTCREATEDMESSAGE,
			'L_REPORT' => _PRP_REPORT,
			
			'S_SUBMITTED_BY' => $userinfo['username'],
			'S_PROJECT_NAME' => $project_name,
			'S_PROJECT_NAME_HTML' => htmlprepare($project_name ),
			'S_TYPE' => $type,
			'S_TYPE_HTML' => htmlprepare($type),
			'S_SUMMARY' => $summary,
			'S_SUMMARY_HTML' => htmlprepare($summary),
			'S_DESCRIPTION' => decode_bb_all($description, 1, false),
			'S_REPRODUCE' => decode_bb_all($reproduce, 1, false),
			'S_EXPECTED' => decode_bb_all($expected, 1, false),
			'S_ACTUAL' =>  decode_bb_all($actual, 1, false),
			'S_REPORT_ID' => $report_id,
			
			'U_REPORT' => getlink('&amp;file=report&amp;report_id='.$report_id, true, true),
			'U_SUBMITTED_BY' => getlink('Your_Account&amp;profile='.$userinfo['user_id'], true, true),
			)
		);
		
		ob_start();
		$cpgtpl->set_filenames(array('report_email' => 'ProjectsPro/report_email.html'));
		$cpgtpl->display('report_email');
		$message = ob_get_clean();
		
		send_mail($mailer_message, $message, 1, _PRP_REPORTCREATESUBJECT);
	}
	
	cpg_error(_PRP_REPORTSUBMITTED, _TB_INFO, getlink('&amp;file=report&amp;report_id='.$report_id));
}

/**
 * Submit a report
 **/
function ProjectsPro_report_submit() {
	global $prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix;
	
	$project_id = isset($_GET['project_id']) ? intval($_GET['project_id']) : (isset($_POST['project_id']) ? intval($_POST['project_id']) : 0);
	$mode = isset($_GET['mode']) ? $_GET['mode'] : '';
	$confirm = ('confirm' == $mode);
	$summary = isset($_POST['summary']) ? $_POST['summary'] : '';
	$type_id = isset($_POST['type_id']) ? intval($_POST['type_id']) : 0;
	$description = isset($_POST['description']) ? $_POST['description'] : '';
	$reproduce = isset($_POST['reproduce']) ? $_POST['reproduce'] : '';
	$expected = isset($_POST['expected']) ? $_POST['expected'] : '';
	$actual = isset($_POST['actual']) ? $_POST['actual'] : '';
	$notify_comment = (is_user() && isset($_POST['notify_comment'])) ? intval($_POST['notify_comment']) : 0;
	
	// Invalid report id
	if (0==$project_id) {
		url_redirect(getlink());
	}
	
	$pagetitle .= ' '._BC_DELIM.' '._PRP_REPORTSUBMIT;
	require_once(CORE_PATH.'nbbcode.php');
	require('header.php');
	
	// Create the list of projects to submit a report for
	$result_projects = $db->sql_query('SELECT project_id, project_name FROM '.$projectspro_prefix.'projects', false, __FILE__, __LINE__);
	$projects = array();
	while(list($list_project_id, $project_name) = $db->sql_fetchrow($result_projects, SQL_NUM)) {
		$projects[$list_project_id] = htmlprepare($project_name);
	}
	$db->sql_freeresult($result_projects);

	// Create the list of report types
	$result_types = $db->sql_query('SELECT type_id, name FROM '.$projectspro_prefix.'types WHERE type = 2 ORDER by name ASC', false, __FILE__, __LINE__);
	$type = array();
	while( list($list_type_id, $name) = $db->sql_fetchrow($result_types, SQL_NUM)) {
		$type[$list_type_id] = htmlprepare($name);
	}
	$db->sql_freeresult($result_types);
	
	# Search for similar bugs
	# I'm no search expert so this search is _incredibly_ simple
	if ($confirm) {
		$keywords = explode(' ', $summary);
		$search_terms = array();
		foreach($keywords as $keyword) {
			$search_terms[] = "summary LIKE '%".Fix_Quotes($keyword)."%'";
		}
		if (count($search_terms)) {
			$result_search = $db->sql_query('SELECT report_id, summary, description FROM '.$projectspro_prefix.'reports WHERE '.implode(' OR ', $search_terms).' AND project_id = '.$project_id.' ORDER BY date_created DESC LIMIT 0, 5');
			while($row_search = $db->sql_fetchrow($result_search, SQL_ASSOC)) {
				$cpgtpl->assign_block_vars('search', array(
					'S_SUMMARY' => $row_search['summary'],
					'S_SUMMARY_HTML' => htmlprepare($row_search['summary']),
					'S_DESCRIPTION' => htmlprepare((100<strlen($row_search['description']) ? $row_search['description'] : substr($row_search['description'], 0, 100))),
					'U_REPORT' => getlink('&amp;file=report&amp;report_id='.$row_search['report_id']),
					)
				);
			}
		}
	}
	
	$cpgtpl->assign_vars( array(
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_SUMMARY' => _PRP_REPORTSUMMARY,
		'L_TYPE' => _TYPE,
		'L_STATUS' => _PRP_STATUS,
		'L_DESCRIPTION' => _PRP_REPORTDESCRIPTION,
		'L_REPRODUCE' => _PRP_REPORTREPRODUCE,
		'L_EXPECTED' => _PRP_REPORTEXPECTED,
		'L_ACTUAL' => _PRP_REPORTACTUAL,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		'L_NOTIFY_COMMENT' => _PRP_REPORTNOTIFYCOMMENT,
		'L_SUBMIT_CONFIRM' => ($confirm ? _PRP_REPORTSUBMITCONFIRM : ''),
		'L_NO_RESULTS' => _PRP_REPORTNOREPORTS,

		'S_FORM_OPEN_REPORT_SUBMIT' => open_form(getlink('&amp;file=report_submit'.($confirm ? '&amp;mode=save' : '&amp;mode=confirm')), 'submit_report', _PRP_REPORTSUBMIT),
		'S_FORM_CLOSE_REPORT_SUBMIT' => close_form(),
		
		'S_PROJECT_ID' => select_box('project_id', $project_id, $projects),
		'S_TYPE_ID' => select_box('type_id', $type_id, $type),
		'S_NOTIFY_COMMENT' => (is_user() ? yesno_option('notify_comment', $notify_comment) : ''),

		'S_BBCODE_DESCRIPTION' => bbcode_table('description', 'submit_report', 1),
		'S_BBCODE_REPRODUCE' => bbcode_table('reproduce', 'submit_report', 1),
		'S_BBCODE_EXPECTED' => bbcode_table('expected', 'submit_report', 1),
		'S_BBCODE_ACTUAL' => bbcode_table('actual', 'submit_report', 1),
		'S_SUMMARY' => $summary,
		'S_SUMMARY_HTML' => htmlprepare($summary),
		'S_DESCRIPTION' => htmlprepare($description),
		'S_REPRODUCE' => htmlprepare($reproduce),
		'S_EXPECTED' => htmlprepare($expected),
		'S_ACTUAL' => htmlprepare($actual),
		)
	);
	
	OpenTable();
	$cpgtpl->set_filenames(array('report_submit' => 'ProjectsPro/report_submit.html'));
	$cpgtpl->display('report_submit');
	CloseTable();
}

if (!$MAIN_CFG[$projectspro_base]['report_enable']) {
	url_redirect(getlink());
}

# Verify the user is allowed here
if (!$MAIN_CFG[$projectspro_base]['report_allow_anonymous'] && !is_user()) {
	$project_id = isset($_GET['project_id']) ? intval($_GET['project_id']) : 0;
	url_redirect(getlink(($project_id ? '&amp;file=project&amp;project_id='.$project_id : '')));
}

$pagetitle .= $module_title;
get_lang('ProjectsPro');
$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch($mode) {
	case 'save':
		ProjectsPro_report_submit_save();
		break;
	case 'confirm':
	default:
		ProjectsPro_report_submit();
		break;
}