<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Displays the specifict feature request information                |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 248 $
| $Author: jday29 $
| $Date: 2006-09-15 09:33:45 -0500 (Fri, 15 Sep 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'CPG_NUKE' ) ) {
	exit;
}

$projectspro_base = basename(dirname(__FILE__));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Turn comment notifications on or off
 **/
function ProjectsPro_request_notify_comment() {
	global $db, $prefix, $projectspro_base, $projectspro_prefix;
	
	$request_id = isset($_GET['request_id']) ? intval($_GET['request_id']) : 0;
	if (0 == $request_id || !is_user()) {
		url_redirect(getlink());
	}
	
	list($user_id, $notify_comment) = $db->sql_ufetchrow('SELECT user_id, notify_comment FROM '.$projectspro_prefix.'requests WHERE request_id = '.$request_id, SQL_NUM);
	if (is_user() != $user_id) {
		url_redirect(getlink());
	}
	$db->sql_query('UPDATE '.$projectspro_prefix.'requests SET notify_comment = '.($notify_comment ? 0 : 1).' WHERE request_id = '.$request_id);
	
	url_redirect(getlink('&amp;file=request&amp;request_id='.$request_id));
}

/**
 * Display the request
 **/
function ProjectsPro_request() {
	global $prefix, $user_prefix, $db, $pagetitle, $cpgtpl, $MAIN_CFG, $projectspro_base, $projectspro_prefix, $CPG_SESS, $userinfo;
	
	require_once(CORE_PATH.'nbbcode.php');
	
	$request_id = isset( $_GET['request_id'] ) ? intval( $_GET['request_id'] ) : 0;
	if ( 0 == $request_id ) {
		url_redirect( getlink() );
	}

	list( $project_id, $project_name, $summary, $description, $status_name, $name, $date_created, $date_started, $date_finished, $task_id, $notify_comment, $user_id, $username ) = $db->sql_ufetchrow( 'SELECT re.project_id, p.project_name, re.summary, re.description, s.status_name, t.name, re.date_created, re.date_started, re.date_finished, re.task_id, re.notify_comment, u.user_id, u.username FROM ' . $projectspro_prefix.'requests re, ' . $projectspro_prefix.'projects p, ' . $projectspro_prefix.'status s, ' . $projectspro_prefix.'types t, ' . $user_prefix . '_users u WHERE re.project_id = p.project_id AND re.status_id = s.status_id AND re.type_id = t.type_id AND re.user_id = u.user_id AND re.request_id = ' . $request_id . ' LIMIT 0, 1', SQL_NUM, __FILE__, __LINE__ );
	if ( !is_numeric( $project_id ) ) {
		url_redirect( getlink() );
	}
	
	// Select the report members
	$result_users = $db->sql_query( 'SELECT rm.user_id, u.username, po.position_name FROM ' . $projectspro_prefix.'projects_members pm, ' . $projectspro_prefix.'requests_members rm, ' . $user_prefix . '_users u, ' . $projectspro_prefix.'positions po WHERE pm.user_id = rm.user_id AND pm.position_id = po.position_id AND rm.user_id = u.user_id AND pm.project_id = ' . $project_id . ' AND rm.request_id = ' . $request_id, false, __FILE__, __LINE__ );
	$comment_allowed = false;
	while( list( $user_id, $username, $position_name ) = $db->sql_fetchrow( $result_users, SQL_NUM ) ) {
		$cpgtpl->assign_block_vars( 'member', array(
			'S_USERNAME' => $username,
			'S_POSITION_NAME' => $position_name,
			'S_POSITION_NAME_HTML' => htmlprepare($position_name),
			
			'U_PROFILE' => getlink( 'Your_Account&amp;profile=' . $user_id ),
			)
		);
		if ( is_user() == $user_id ) {
			$comment_allowed = true;
		}
	}

	// Create the comments list
	$result_comments = $db->sql_query( 'SELECT c.comment_id, c.user_id, u.username, c.description, c.date_created FROM ' . $projectspro_prefix.'comments c, ' . $user_prefix . '_users u WHERE c.user_id = u.user_id AND c.join_type = 3 AND c.join_id = ' . $request_id . ' ORDER BY c.date_created ASC', false, __FILE__, __LINE__ );
	while( list( $comment_id, $user_id, $comment_username, $comment_description, $comment_date_created ) = $db->sql_fetchrow( $result_comments, SQL_NUM ) ) {
		$cpgtpl->assign_block_vars( 'comment', array(
			'S_USERNAME' => $comment_username,
			'S_COMMENT_ID' => $comment_id,
			'S_DESCRIPTION' => decode_bb_all( $comment_description, 1, false),
			'S_DATE_CREATED' => 0 < $comment_date_created ? formatDateTime( $comment_date_created, _DATESTRING ) : _PRP_NA,
			'S_DATE_CREATED_HTML' => htmlprepare( 0 < $comment_date_created ? formatDateTime( $comment_date_created, _DATESTRING ) : _PRP_NA ),
			
			'U_PROFILE' => getlink( 'Your_Account&amp;profile=' . $user_id ),
			'U_EDIT' => ( can_admin( $projectspro_base ) || ( is_user() == $user_id && 1 < $user_id ) ) ? getlink('&amp;file=request_comment&amp;request_id=' . $request_id . '&amp;comment_id=' . $comment_id ) : '',
			'U_DELETE' => ( can_admin( $projectspro_base ) || ( is_user() == $user_id && 1 < $user_id ) ) ? getlink('&amp;file=request_comment&amp;mode=delete&amp;request_id=' . $request_id . '&amp;comment_id=' . $comment_id ) : '',
			)
		);
	}
	
	$CPG_SESS[$projectspro_base]['track_request'][$project_id][$request_id] = gmtime();
	
	$cpgtpl->assign_vars( array(
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_REQUEST_SUMMARY' => _PRP_REQUESTSUMMARY,
		'L_REQUEST_DESCRIPTION' => _PRP_REQUESTDESCRIPTION,
		'L_STATUS' => _PRP_STATUS,
		'L_DATE_CREATED' => _PRP_CREATEDATE,
		'L_DATE_START' => _PRP_STARTDATE,
		'L_DATE_FINISH' => _PRP_FINISHDATE,
		'L_SUBMITTED_BY' => _PRP_SUBMITTEDBY,
		'L_TYPE' => _PRP_TYPE,
		'L_REQUEST_DETAILS' => _PRP_REQUESTDETAILS,
		'L_REQUEST_SUMMARY' => _PRP_REQUESTSUMMARY,
		'L_REQUEST_COMMENTS' => _PRP_REQUESTCOMMENTS,
		'L_POSITION' => _PRP_POSITION,
		'L_REQUEST_MEMBERS' => _PRP_REQUESTMEMBERS,
		'L_MEMBER' => _PRP_MEMBER,
		'L_NO_REQUEST_MEMBERS' => _PRP_NOMEMBERSREQUEST,
		'L_NO_REQUEST_COMMENTS' => _PRP_NOREQUESTCOMMENTS,
		'L_COMMENT_ADD' => _PRP_REQUESTCOMMENTADD,
		'L_EDIT' => _EDIT,
		'L_DELETE' => _DELETE,
		'L_TASK' => _PRP_TASK,
		'L_PROMOTED_TO_TASK' => $task_id ? sprintf( _PRP_REQUESTPROMOTEDTOTASK, getlink('&amp;file=task&amp;task_id=' . $task_id ) ) : '',
		'L_NOTIFY_COMMENT' => (is_user()==$user_id ? ($notify_comment ? _PRP_REQUESTNOTIFYCOMMENTTURNOFF : _PRP_REQUESTNOTIFYCOMMENTTURNON) : ''),
		
		'S_PROJECT_NAME' => $project_name,
		'S_PROJECT_NAME_HTML' => htmlprepare($project_name),
		'S_REQUEST_SUMMARY' => $summary,
		'S_REQUEST_SUMMARY_HTML' => htmlprepare($summary),
		'S_REQUEST_DESCRIPTION' => decode_bb_all( $description, 1, false),
		'S_STATUS_NAME' => $status_name,
		'S_STATUS_NAME_HTML' => htmlprepare($status_name),
		'S_TYPE' => $name,
		'S_TYPE_HTML' => htmlprepare($name),
		'S_DATE_CREATED' => L10NTime::strftime( _DATESTRING, $date_created, 0, 0 ),
		'S_DATE_CREATED_HTML' => htmlprepare(L10NTime::strftime( _DATESTRING, $date_created, 0, 0 )),
		'S_DATE_STARTED' => 0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA,
		'S_DATE_STARTED_HTML' => htmlprepare(0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA),
		'S_DATE_FINISHED' => 0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA,
		'S_DATE_FINISHED_HTML' => htmlprepare(0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA),
		'S_USER_COUNT' => $db->sql_numrows( $result_users ),
		'S_USERNAME' => $username,
		'S_COMMENT_COUNT' => $db->sql_numrows( $result_comments ),
		
		'U_PROJECT' => getlink( '&amp;file=project&amp;project_id=' . $project_id ),
		'U_REQUEST' => getlink('&amp;file=request&amp;request_id=' . $request_id ),
		'U_POSITION' => getlink('&amp;file=position' ),
		'U_PROFILE' => getlink( 'Your_Account&amp;profile=' . $user_id ),
		'U_COMMENT_ADD' => ( $MAIN_CFG[$projectspro_base]['request_comment_allow_anonymous'] || is_user() ) ? getlink('&amp;file=request_comment&amp;request_id=' . $request_id ) : '',
		'U_EDIT' => can_admin( $projectspro_base ) ? adminlink('&amp;file=requests&amp;mode=edit&amp;request_id=' . $request_id ) : '',
		'U_DELETE' => can_admin( $projectspro_base ) ? adminlink('&amp;file=requests&amp;mode=delete&amp;request_id=' . $request_id ) : '',
		'U_NOTIFY_COMMENT' => (is_user()==$user_id ? getlink('&amp;file=request&amp;mode=notify_comment&amp;request_id='.$request_id) : ''),
		)
	);
	
	$db->sql_freeresult( $result_comments );
	$db->sql_freeresult( $result_users);
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . $project_name . ' ' . _BC_DELIM . ' ' . $summary;
	
	require( 'header.php' );
	OpenTable();
	$cpgtpl->set_filenames( array( 'request' => 'ProjectsPro/request.html' ) );
	$cpgtpl->display( 'request' );
	CloseTable();
}

if (!$MAIN_CFG[$projectspro_base]['request_enable']) {
	url_redirect(getlink());
}

$pagetitle .= $module_title;
get_lang('ProjectsPro');
$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch( $mode ) {
	case 'notify_comment':
		ProjectsPro_request_notify_comment();
		break;
	default:
		ProjectsPro_request();
		break;
}