<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Allows a user to submit a feature request                         |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 204 $
| $Author: jday29 $
| $Date: 2006-05-24 19:11:40 -0500 (Wed, 24 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'CPG_NUKE' ) ) {
	exit;
}

$projectspro_base = basename(dirname(__FILE__));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Save a submitted request
 **/
function ProjectsPro_request_submit_save() {
	global $prefix, $db, $userinfo, $MAIN_CFG, $cpgtpl, $projectspro_prefix, $projectspro_base, $CPG_SESS;
	
	require_once(CORE_PATH.'nbbcode.php');
	
	$project_id = isset( $_POST['project_id'] ) ? intval( $_POST['project_id'] ) : 0;
	$summary = isset( $_POST['summary'] ) ? $_POST['summary'] : '';
	$type_id = isset( $_POST['type_id'] ) ? intval( $_POST['type_id'] ) : 0;
	$description = isset( $_POST['description'] ) ? $_POST['description'] : '';
	$notify_comment = (is_user() && isset($_POST['notify_comment'])) ? intval($_POST['notify_comment']) : 0;
	
	if ( 0 == $project_id ) {
		url_redirect( getlink() );
	} elseif ( '' == $summary ) {
		cpg_error( _PRP_REQUESTSUBMITINVALIDSUMMARY );
	} elseif ( '' == $description ) {
		cpg_error( _PRP_REQUESTSUBMITINVALIDDESCRIPTION );
	}
	
	// Submit the request
	$db->sql_query( 'INSERT INTO ' . $projectspro_prefix.'requests (project_id, type_id, status_id, summary, description, user_id, ip, date_created, date_started, date_finished, notify_comment) VALUES (' . $project_id . ', ' . $type_id . ", '" . $MAIN_CFG[$projectspro_base]['status_id_request_new'] . "', '" . Fix_Quotes($summary) . "', '" . Fix_Quotes($description) . "', " . $userinfo['user_id'] . ", '" . $userinfo['user_ip'] . "', " . gmtime() . ', 0, 0, '.$notify_comment.')', false, __FILE__, __LINE__ );
	$request_id = $db->sql_nextid( 'request_id' );
	$CPG_SESS[$projectspro_base]['track_request'][$project_id][$request_id] = gmtime();

	if ( $MAIN_CFG[$projectspro_base]['notify_admin_request'] ) {
		list( $type ) = $db->sql_ufetchrow( 'SELECT name FROM ' . $projectspro_prefix.'types WHERE type_id = ' . $type_id, SQL_NUM );
		list( $project_name ) = $db->sql_ufetchrow( 'SELECT project_name FROM ' . $projectspro_prefix.'projects WHERE project_id = ' . $project_id, SQL_NUM, __FILE__, __LINE__ );

		$cpgtpl->assign_vars( array(
			'L_PROJECT_NAME' => _PRP_PROJECTNAME,
			'L_TYPE' => _TYPE,
			'L_SUMMARY' => _PRP_REQUESTSUMMARY,
			'L_DESCRIPTION' => _PRP_REQUESTDESCRIPTION,
			'L_SUBMITTED_BY' => _PRP_SUBMITTEDBY,
			'L_REQUEST_CREATED_MESSAGE' => _PRP_REQUESTCREATEDMESSAGE,
			'L_REQUEST' => _PRP_REQUEST,
			
			'S_SUBMITTED_BY' => $userinfo['username'],
			'S_PROJECT_NAME' => $project_name,
			'S_PROJECT_NAME_HTML' => htmlprepare( $project_name ),
			'S_TYPE' => $type,
			'S_TYPE_HTML' => htmlprepare( $type ),
			'S_SUMMARY' => $summary,
			'S_SUMMARY_HTML' => htmlprepare( $summary ),
			'S_DESCRIPTION' => decode_bb_all( $description, 1, false),
			'S_REQUEST_ID' => $request_id,
			
			'U_REQUEST' => getlink('&amp;file=request&amp;request_id=' . $request_id, true, true ),
			'U_SUBMITTED_BY' => getlink( 'Your_Account&amp;profile=' . $userinfo['user_id'], true, true ),
			)
		);
		
		ob_start();
		$cpgtpl->set_filenames( array( 'request_email' => 'ProjectsPro/request_email.html' ) );
		$cpgtpl->display( 'request_email' );
		$message = ob_get_clean();
		
		send_mail( $mailer_message, $message, 1, _PRP_REQUESTCREATESUBJECT );
	}
	
	cpg_error( _PRP_REQUESTSUBMITTED, _TB_INFO, getlink('&amp;file=request&amp;request_id=' . $request_id) );
}

/**
 * Submit a request
 **/
function ProjectsPro_request_submit() {
	global $prefix, $db, $pagetitle, $cpgtpl, $projectspro_prefix, $projectspro_base;
	
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	
	// Invalid request id
	if ( 0 == $project_id ) {
		url_redirect( getlink() );
	}
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . _PRP_REQUESTSUBMIT;
	require_once(CORE_PATH.'nbbcode.php');
	require( 'header.php' );
	
	// Create the list of projects to submit a request for
	$result_projects = $db->sql_query( 'SELECT project_id, project_name FROM ' . $projectspro_prefix.'projects', false, __FILE__, __LINE__ );
	$projects = array();
	while( list( $list_project_id, $project_name ) = $db->sql_fetchrow( $result_projects, SQL_NUM ) ) {
		$projects[$list_project_id] = htmlprepare($project_name);
	}
	$db->sql_freeresult( $result_projects );

	// Create the list of request types
	$result_types = $db->sql_query( 'SELECT type_id, name FROM ' . $projectspro_prefix.'types WHERE type = 3 ORDER by name ASC', false, __FILE__, __LINE__ );
	$type = array();
	while( list( $type_id, $name ) = $db->sql_fetchrow( $result_types, SQL_NUM ) ) {
		$type[$type_id] = htmlprepare($name);
	}
	$db->sql_freeresult( $result_types );
	
	$cpgtpl->assign_vars( array(
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_SUMMARY' => _PRP_REQUESTSUMMARY,
		'L_TYPE' => _TYPE,
		'L_STATUS' => _PRP_STATUS,
		'L_DESCRIPTION' => _PRP_REQUESTDESCRIPTION,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		'L_NOTIFY_COMMENT' => _PRP_REQUESTNOTIFYCOMMENT,

		'S_FORM_OPEN_REQUEST_SUBMIT' => open_form( getlink( '&amp;file=request_submit&amp;mode=save' ), 'submit_request', _PRP_REQUESTSUBMIT ),
		'S_FORM_CLOSE_REQUEST_SUBMIT' => close_form(),
		
		'S_PROJECT_ID' => select_box( 'project_id', $project_id, $projects ),
		'S_TYPE_ID' => select_box( 'type_id', '', $type ),
		'S_NOTIFY_COMMENT' => (is_user() ? yesno_option('notify_comment', 0) : ''),

		'S_BBCODE_DESCRIPTION' => bbcode_table( 'description', 'submit_request', 1 ),
		)
	);
	
	OpenTable();
	$cpgtpl->set_filenames( array( 'request_submit' => 'ProjectsPro/request_submit.html' ) );
	$cpgtpl->display( 'request_submit' );
	CloseTable();
}

if (!$MAIN_CFG[$projectspro_base]['request_enable']) {
	url_redirect(getlink());
}

# Verify the user is allowed here
if ( !$MAIN_CFG[$projectspro_base]['request_allow_anonymous'] && !is_user() ) {
	$project_id = isset( $_GET['project_id'] ) ? intval( $_GET['project_id'] ) : 0;
	url_redirect( getlink( ( $project_id ? '&amp;file=project&amp;project_id=' . $project_id : '' ) ) );
}

$pagetitle .= $module_title;
get_lang('ProjectsPro');
$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch( $mode ) {
	case 'save':
		ProjectsPro_request_submit_save();
		break;
	default:
		ProjectsPro_request_submit();
		break;
}