<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Displays the task information                                     |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 214 $
| $Author: jday29 $
| $Date: 2006-06-01 17:35:46 -0500 (Thu, 01 Jun 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'CPG_NUKE' ) ) {
	exit;
}

$projectspro_base = basename(dirname(__FILE__));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Turn comment notifications on or off
 **/
function ProjectsPro_task_notify_comment() {
	global $db, $prefix, $projectspro_prefix;
	
	$task_id = isset($_GET['task_id']) ? intval($_GET['task_id']) : 0;
	if (0 == $task_id || !is_user()) {
		url_redirect(getlink());
	}
	
	list($user_id, $notify_comment) = $db->sql_ufetchrow('SELECT user_id, notify_comment FROM '.$projectspro_prefix.'tasks WHERE task_id = '.$task_id, SQL_NUM);
	if (is_user() != $user_id) {
		url_redirect(getlink());
	}
	$db->sql_query('UPDATE '.$projectspro_prefix.'tasks SET notify_comment = '.($notify_comment ? 0 : 1).' WHERE task_id = '.$task_id);
	
	url_redirect(getlink('&amp;file=task&amp;task_id='.$task_id));
}

/**
 * Display the projets list
 **/
function ProjectsPro_task() {
	global $prefix, $user_prefix, $db, $pagetitle, $cpgtpl, $projectspro_base, $projectspro_prefix, $CPG_SESS;
	
	require_once(CORE_PATH.'nbbcode.php');
	
	$task_id = isset( $_GET['task_id'] ) ? intval( $_GET['task_id'] ) : 0;
	if ( 0 == $task_id ) {
		url_redirect( getlink() );
	}
	
	// Create the members list
	list( $project_id ) = $db->sql_ufetchrow( 'SELECT project_id FROM ' . $projectspro_prefix.'tasks WHERE task_id = ' . $task_id, SQL_NUM, __FILE__, __LINE__ );
	if ( !is_numeric( $project_id ) ) {
		url_redirect( getlink() );
	}
	
	$CPG_SESS[$projectspro_base]['track_task'][$project_id][$task_id] = gmtime();
	
	// Select the task members
	$result_users = $db->sql_query( 'SELECT tm.user_id, u.username, po.position_name FROM ' . $projectspro_prefix.'projects_members pm, ' . $projectspro_prefix.'tasks_members tm, ' . $user_prefix . '_users u, ' . $projectspro_prefix.'positions po WHERE pm.user_id = tm.user_id AND pm.position_id = po.position_id AND tm.user_id = u.user_id AND pm.project_id = ' . $project_id . ' AND tm.task_id = ' . $task_id, false, __FILE__, __LINE__ );
	$comment_allowed = false;
	while( list( $user_id, $username, $position_name ) = $db->sql_fetchrow( $result_users, SQL_NUM ) ) {
		$cpgtpl->assign_block_vars( 'member', array(
			'S_USERNAME' => $username,
			'S_POSITION_NAME' => $position_name,
			'S_POSITION_NAME_HTML' => htmlprepare($position_name),
			
			'U_PROFILE' => getlink( 'Your_Account&amp;profile=' . $user_id ),
			)
		);
		if ( is_user() == $user_id ) {
			$comment_allowed = true;
		}
	}
	
	// Create the comments list
	$result_comments = $db->sql_query( 'SELECT c.comment_id, c.user_id, u.username, c.description, c.date_created FROM ' . $projectspro_prefix.'comments c, ' . $user_prefix . '_users u WHERE c.user_id = u.user_id AND c.join_type = 1 AND c.join_id = ' . $task_id . ' ORDER BY c.date_created ASC', false, __FILE__, __LINE__ );
	while( list( $comment_id, $user_id, $username, $description, $date_created ) = $db->sql_fetchrow( $result_comments, SQL_NUM ) ) {
		$cpgtpl->assign_block_vars( 'comment', array(
			'S_USERNAME' => $username,
			'S_COMMENT_ID' => $comment_id,
			'S_DESCRIPTION' => decode_bb_all( $description, 1, false),
			'S_DATE_CREATED' => 0 < $date_created ? formatDateTime( $date_created, _DATESTRING ) : _PRP_NA,
			
			'U_PROFILE' => getlink( 'Your_Account&amp;profile=' . $user_id ),
			'U_EDIT' => ( can_admin( $projectspro_base ) || ( is_user() == $user_id && 1 < $user_id ) ) ? getlink('&amp;file=task_comment&amp;task_id=' . $task_id . '&amp;comment_id=' . $comment_id ) : '',
			'U_DELETE' => ( can_admin( $projectspro_base ) || ( is_user() == $user_id && 1 < $user_id ) ) ? getlink('&amp;file=task_comment&amp;mode=delete&amp;task_id=' . $task_id . '&amp;comment_id=' . $comment_id ) : '',
			)
		);
	}
	
	list( $project_id, $project_name, $task_name, $task_description, $status_name, $priority_name, $task_percent, $date_started, $date_finished, $notify_comment, $user_id, $username ) = $db->sql_ufetchrow( 'SELECT t.project_id, p.project_name, t.task_name, t.task_description, s.status_name, pr.priority_name, t.task_percent, t.date_started, t.date_finished, t.notify_comment, t.user_id, u.username FROM ' . $projectspro_prefix.'projects p, ' . $projectspro_prefix.'status s, ' . $projectspro_prefix.'priorities pr, ( ' . $projectspro_prefix.'tasks t LEFT JOIN '.$user_prefix.'_users u ON t.user_id = u.user_id ) WHERE t.project_id = p.project_id AND t.status_id = s.status_id AND t.priority_id = pr.priority_id AND t.task_id = ' . $task_id, SQL_NUM, __FILE__, __LINE__ );
	$cpgtpl->assign_vars( array(
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_TASK_NAME' => _PRP_TASKNAME,
		'L_TASK_DESCRIPTION' => _PRP_TASKDESCRIPTION,
		'L_TASK_DETAILS' => _PRP_TASKDETAILS,
		'L_STATUS' => _PRP_STATUS,
		'L_PRIORITY' => _PRP_PRIORITY,
		'L_PROGRESS' => _PRP_PROGRESS,
		'L_DATE_START' => _PRP_STARTDATE,
		'L_DATE_FINISH' => _PRP_FINISHDATE,
		'L_TASK_MEMBERS' => _PRP_NOMEMBERSTASK,
		'L_PERCENT' => _PRP_PERCENT . ' ' . _PRP_COMPLETED,
		'L_POSITION' => _PRP_POSITION,
		'L_TASK_MEMBERS' => _PRP_TASKMEMBERS,
		'L_MEMBER' => _PRP_MEMBER,
		'L_NO_TASK_MEMBERS' => _PRP_NOMEMBERSTASK,
		'L_NO_TASK_COMMENTS' => _PRP_NOCOMMENTSTASK,
		'L_COMMENT_ADD' => _PRP_TASKCOMMENTADD,
		'L_TASK_COMMENTS' => _PRP_TASKCOMMENTS,
		'L_EDIT' => _EDIT,
		'L_DELETE' => _DELETE,
		'L_MEMBERS' => _PRP_MEMBERS,
		'L_SUBMITTED_BY' => _PRP_SUBMITTEDBY,
		'L_NOTIFY_COMMENT' => (is_user()==$user_id ? ($notify_comment ? _PRP_TASKNOTIFYCOMMENTTURNOFF : _PRP_TASKNOTIFYCOMMENTTURNON) : ''),
		
		'S_PROJECT_NAME' => $project_name,
		'S_PROJECT_NAME_HTML' => htmlprepare($project_name),
		'S_TASK_NAME' => $task_name,
		'S_TASK_NAME_HTML' => htmlprepare($task_name),
		'S_TASK_DESCRIPTION' => decode_bb_all( $task_description, 1, false),
		'S_STATUS' => $status_name,
		'S_STATUS_HTML' => htmlprepare($status_name),
		'S_PRIORITY' => $priority_name,
		'S_PRIORITY_HTML' => htmlprepare($priority_name),
		'S_PERCENT_DONE' => 0 == $task_percent ? 0 : $task_percent,
		'S_PERCENT_TODO' => 99 < $task_percent ? 0 : ( 100 - $task_percent ),
		'S_DATE_STARTED' => 0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA,
		'S_DATE_STARTED_HTML' => htmlprepare(0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA),
		'S_DATE_FINISHED' => 0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA,
		'S_DATE_FINISHED_HTML' => htmlprepare(0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA),
		'S_USER_COUNT' => $db->sql_numrows( $result_users ),
		'S_COMMENT_COUNT' => $db->sql_numrows( $result_comments ),
		'S_USERNAME' => (0<$user_id ? $username : ''),
		
		'U_PROJECT' => getlink('&amp;file=project&amp;project_id=' . $project_id ),
		'U_TASK' => getlink('&amp;file=task&amp;task_id=' . $task_id ),
		'U_POSITION' => getlink('&amp;file=position' ),
		'U_COMMENT_ADD' => ( ( $comment_allowed || can_admin($projectspro_base) ) ? getlink('&amp;file=task_comment&amp;task_id=' . $task_id ) : '' ),
		'U_EDIT' => can_admin( $projectspro_base ) ? adminlink('&amp;file=tasks&amp;mode=edit&amp;task_id=' . $task_id ) : '',
		'U_DELETE' => can_admin( $projectspro_base ) ? adminlink('&amp;file=tasks&amp;mode=delete&amp;task_id=' . $task_id ) : '',
		'U_MEMBERS' => can_admin( $projectspro_base) ? adminlink('&amp;file=tasks_members&amp;task_id=' . $task_id ) : '',
		'U_PROFILE' => (1<$user_id ? getlink('Your_Account&amp;profile='.$user_id) : ''),
		'U_NOTIFY_COMMENT' => (is_user()==$user_id ? getlink('&amp;file=task&amp;mode=notify_comment&amp;task_id='.$task_id) : ''),
		)
	);
	
	$db->sql_freeresult( $result_users );
	$db->sql_freeresult( $result_comments );
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . $project_name . ' ' . _BC_DELIM . ' ' . $task_name;
	
	require( 'header.php' );
	OpenTable();
	$cpgtpl->set_filenames( array( 'task' => 'ProjectsPro/task.html' ) );
	$cpgtpl->display( 'task' );
	CloseTable();
}

$pagetitle .= $module_title;
get_lang('ProjectsPro');
$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch( $mode ) {
	case 'notify_comment':
		ProjectsPro_task_notify_comment();
		break;
	default:
		ProjectsPro_task();
		break;
}