<?php
/*
+-------------------------------------------------------------------+
| CPG Dragonfly CMS                                                |
| Copyright  2004 - 2005 by CPG-Nuke Dev Team                      |
| www.dragonflycms.org                                              |
| Dragonfly is released under the terms and conditions of the GNU   |
| GPL version 2 or any later version                                |
+-------------------------------------------------------------------+
| Myndworx Asylum Software                                         |
| This software is developed by the programming crew at the Myndworx|
| Asylum for the Programmatically Insane.                           |
| Copyright  2005, 2006 by Myndworx Asylum and the original author |
| listed below.                                                     |
+-------------------------------------------------------------------+
| ProjectsPro module                                                |
| Allows a project member to add a comment to a task                |
| Author - Jason Day and the Myndworx Asylum Dev Team               |
| eMail: support at myndworx dot com                                |
| Website: www.myndworx.com                                         |
+-------------------------------------------------------------------+
| Last modification notes:                                          |
| $Source$
| $Revision: 204 $
| $Author: jday29 $
| $Date: 2006-05-24 19:11:40 -0500 (Wed, 24 May 2006) $
+-------------------------------------------------------------------+
*/
/********************************************************
 * NSN Work Board
 * By: NukeScripts Network (webmaster@nukescripts.net)
 * http://www.nukescripts.net
 * Copyright  2000-2005 by NukeScripts Network
 ********************************************************/
if ( !defined( 'CPG_NUKE' ) ) {
	exit;
}

$projectspro_base = basename(dirname(__FILE__));
$projectspro_prefix = $prefix.'_'.(('ProjectsPro' == $projectspro_base) ? 'prp_' : strtolower($projectspro_base).'_');

/**
 * Display the add comment form
 **/
function ProjectsPro_task_comment() {
	global $prefix, $db, $cpgtpl, $pagetitle, $projectspro_base, $projectspro_prefix;
	
	$task_id = isset( $_GET['task_id'] ) ? intval( $_GET['task_id'] ) : 0;
	$comment_id = isset( $_GET['comment_id'] ) ? intval( $_GET['comment_id'] ) : 0;
	if ( 0 == $task_id ) {
		url_redirect( getlin() );
	}
	
	require_once(CORE_PATH.'nbbcode.php');
	
	if ( 0 < $comment_id ) {
		// Edit a comment
		list( $description, $user_id ) = $db->sql_ufetchrow( 'SELECT description, user_id FROM ' . $projectspro_prefix.'comments WHERE comment_id = ' . $comment_id, SQL_NUM, __FILE__, __LINE__ );
		if ( !can_admin( $projectspro_base ) && ( 1 == $user_id || is_user() != $user_id ) ) {
			url_redirect( getlink('&amp;file=task&amp;task_id=' . $task_id ) );
		}
	} else {
		// Verify the user can comment on this task
		$result_users = $db->sql_query( 'SELECT user_id FROM ' . $projectspro_prefix.'tasks_members WHERE task_id = ' . $task_id, false, __FILE__, __LINE__ );
		$comment_allowed = false;
		while( list( $user_id ) = $db->sql_fetchrow( $result_users, SQL_NUM ) ) {
			if ( is_user() == $user_id ) {
				$comment_allowed = true;
			}
		}
		$db->sql_freeresult( $result_users );
		if ( !$comment_allowed && !can_admin( $projectspro_base ) ) {
			url_redirect( getlink( '&amp;file=task&amp;task_id=' . $task_id ) );
		}
		$description = '';
	}
	
	list( $project_id, $project_name, $task_name, $task_description, $status_name, $priority_name, $task_percent, $date_started, $date_finished ) = $db->sql_ufetchrow( 'SELECT t.project_id, p.project_name, t.task_name, t.task_description, s.status_name, pr.priority_name, t.task_percent, t.date_started, t.date_finished FROM ' . $projectspro_prefix.'projects p, ' . $projectspro_prefix.'tasks t, ' . $projectspro_prefix.'status s, ' . $projectspro_prefix.'priorities pr WHERE t.project_id = p.project_id AND t.status_id = s.status_id AND t.priority_id = pr.priority_id AND t.task_id = ' . $task_id, SQL_NUM, __FILE__, __LINE__ );
	$cpgtpl->assign_vars( array(
		'L_PROJECT_NAME' => _PRP_PROJECTNAME,
		'L_TASK_NAME' => _PRP_TASKNAME,
		'L_TASK_DESCRIPTION' => _PRP_TASKDESCRIPTION,
		'L_TASK_DETAILS' => _PRP_TASKDETAILS,
		'L_STATUS' => _PRP_STATUS,
		'L_PRIORITY' => _PRP_PRIORITY,
		'L_PROGRESS' => _PRP_PROGRESS,
		'L_DATE_START' => _PRP_STARTDATE,
		'L_DATE_FINISH' => _PRP_FINISHDATE,
		'L_PERCENT' => _PRP_PERCENT . ' ' . _PRP_COMPLETED,
		'L_SAVE_CHANGES' => _SAVECHANGES,
		'L_RESET' => _RESET,
		'L_COMMENT' => ( 0 < $comment_id ? _PRP_TASKCOMMENTEDIT : _PRP_TASKCOMMENTADD ),
		
		'S_PROJECT_NAME' => $project_name,
		'S_PROJECT_NAME_HTML' => htmlprepare($project_name),
		'S_TASK_NAME' => $task_name,
		'S_TASK_NAME_HTML' => htmlprepare($task_name),
		'S_TASK_DESCRIPTION' => decode_bb_all( $task_description, 1, false),
		'S_STATUS' => $status_name,
		'S_STATUS_HTML' => htmlprepare($status_name),
		'S_PRIORITY' => $priority_name,
		'S_PRIORITY_HTML' => htmlprepare($priority_name),
		'S_PERCENT_DONE' => 0 == $task_percent ? 0 : $task_percent,
		'S_PERCENT_TODO' => 99 < $task_percent ? 0 : ( 100 - $task_percent ),
		'S_DATE_STARTED' => 0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA,
		'S_DATE_STARTED_HTML' => htmlprepare(0 < $date_started ? L10NTime::strftime( _DATESTRING, $date_started, 0, 0 ) : _PRP_NA),
		'S_DATE_FINISHED' => 0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA,
		'S_DATE_FINISHED_HTML' => htmlprepare(0 < $date_finished ? L10NTime::strftime( _DATESTRING, $date_finished, 0, 0 ) : _PRP_NA),
		'S_BBCODE_DESCRIPTION' => bbcode_table( 'description', 'task_comment', 1 ),
		'S_DESCRIPTION' => htmlprepare( $description ),
		
		'S_FORM_OPEN_TASK_COMMENT' => open_form( getlink('&amp;file=task_comment&amp;mode=save' . ( 0 < $comment_id ? '&amp;comment_id=' . $comment_id : '' ) . '&amp;task_id=' . $task_id ), 'task_comment', ( 0 < $comment_id ? _PRP_TASKCOMMENTEDIT : _PRP_TASKCOMMENTADD ) ),
		'S_FORM_CLOSE_TASK_COMMENT' => close_form(),

		'U_PROJECT' => getlink('&amp;file=project&amp;project_id=' . $project_id ),
		'U_TASK' => getlink('&amp;file=task&amp;task_id=' . $task_id ),
		)
	);
	
	$pagetitle .= ' ' . _BC_DELIM . ' ' . $project_name . ' ' . _BC_DELIM . ' ' . $task_name . ' ' . _BC_DELIM . ' ' . ( 0 < $comment_id ? _PRP_TASKCOMMENTEDIT : _PRP_TASKCOMMENTADD );
	
	require( 'header.php' );
	OpenTable();
	$cpgtpl->set_filenames( array( 'task_comment' => 'ProjectsPro/task_comment.html' ) );
	$cpgtpl->display( 'task_comment' );
	CloseTable();
}

/**
 * Save a task comment
 **/
function ProjectsPro_task_comment_save() {
	global $prefix, $user_prefix, $db, $userinfo, $cpgtpl, $projectspro_base, $projectspro_prefix, $CPG_SESS;
	
	$task_id = isset( $_GET['task_id'] ) ? intval( $_GET['task_id'] ) : 0;
	$description = isset( $_POST['description'] ) ? $_POST['description'] : '';
	$comment_id = isset( $_GET['comment_id'] ) ? intval( $_GET['comment_id'] ) : 0;
	
	// Validate the task id
	if ( 0 == $task_id ) {
		url_redirect( getlink() );
	} elseif ( '' == $description ) {
		cpg_error( _PRP_TASKCOMMENTINVALID );
	}

	if ( 0 < $comment_id ) {
		// Edit a comment
		list( $user_id ) = $db->sql_ufetchrow( 'SELECT user_id FROM ' . $projectspro_prefix.'comments WHERE comment_id = ' . $comment_id, SQL_NUM, __FILE__, __LINE__ );
		if ( !can_admin( $projectspro_base ) && ( 1 == $user_id || is_user() != $user_id ) ) {
			url_redirect( getlink('&amp;file=task&amp;task_id=' . $task_id ) );
		}
	} else {
		// Verify the user can comment on this task
		$result_users = $db->sql_query( 'SELECT user_id FROM ' . $projectspro_prefix.'tasks_members WHERE task_id = ' . $task_id, false, __FILE__, __LINE__ );
		$comment_allowed = false;
		while( list( $user_id ) = $db->sql_fetchrow( $result_users, SQL_NUM ) ) {
			if ( is_user() == $user_id ) {
				$comment_allowed = true;
			}
		}
		$db->sql_freeresult( $result_users );
		if ( !$comment_allowed && !can_admin( $projectspro_base ) ) {
			url_redirect( getlink('&amp;file=task&amp;task_id=' . $task_id ) );
		}
	}

	// Save the task comment
	if ( 0 < $comment_id ) {
		$db->sql_query( 'UPDATE ' . $projectspro_prefix . "comments SET description = '" . Fix_Quotes($description) . "' WHERE comment_id = " . $comment_id, false, __FILE__, __LINE__ );
	} else {
		$db->sql_query( 'INSERT INTO ' . $projectspro_prefix.'comments (join_id, join_type, user_id, ip, description, date_created) VALUES (' . $task_id . ', 1, ' . $userinfo['user_id'] . ", '" . $userinfo['user_ip'] . "', '" . Fix_Quotes($description) . "', " . gmtime() . ')', false, __FILE__, __LINE__ );
	}

	# Notify the user on administrator or task member comments
	list($project_id, $project_name, $task_name, $user_id, $notify_comment, $user_email) = $db->sql_ufetchrow('SELECT p.project_id, p.project_name, t.task_name, t.user_id, t.notify_comment, u.user_email FROM '.$projectspro_prefix.'projects p, ( '.$projectspro_prefix.'tasks t LEFT JOIN '.$user_prefix.'_users u ON t.user_id = u.user_id ) WHERE p.project_id = t.project_id AND t.task_id = '.$task_id, SQL_NUM);
	$CPG_SESS[$projectspro_base]['track_task'][$project_id][$task_id] = gmtime();
	if ($notify_comment && $userinfo['user_id']!=$user_id && 1<$user_id) {
		require_once(CORE_PATH.'nbbcode.php');
		$cpgtpl->assign_vars(array(
			'L_TASK_COMMENT_SUBMITTED' => _PRP_TASKADMINCOMMENTSUBMITTED,
			'L_PROJECT_NAME' => _PRP_PROJECTNAME,
			'L_TASK' => _PRP_TASK,
			'L_TASK_NAME' => _PRP_TASKNAME,
			'L_DESCRIPTION' => _PRP_TASKDESCRIPTION,
			'L_SUBMITTED_BY' => _PRP_SUBMITTEDBY,
			'L_REQUEST' => _PRP_REQUEST,
			
			'S_SUBMITTED_BY' => $userinfo['username'],
			'S_PROJECT_NAME' => $project_name,
			'S_PROJECT_NAME_HTML' => htmlprepare($project_name),
			'S_TASK_NAME' => $task_name,
			'S_TASK_NAME_HTML' => htmlprepare($task_name),
			'S_DESCRIPTION' => decode_bb_all($description, 1, false),
			'S_TASK_ID' => $task_id,
			
			'U_TASK' => getlink('&amp;file=task&amp;task_id='.$task_id, true, true),
			'U_SUBMITTED_BY' => getlink('Your_Account&amp;profile='.$userinfo['user_id'], true, true),
			)
		);
		
		ob_start();
		$cpgtpl->set_filenames(array('task_comment_email' => 'ProjectsPro/task_comment_email.html'));
		$cpgtpl->display('task_comment_email');
		$message = ob_get_clean();

		send_mail( $mailer_message, $message, 1, _PRP_TASKADMINCOMMENTSUBMITTED, $user_email );
	}

	cpg_error( _PRP_TASKCOMMENTSUBMITTED, _TB_INFO, getlink('&amp;file=task&amp;task_id=' . $task_id ) );
}

/**
 * Delete a comment
 **/
function ProjectsPro_task_comment_delete() {
	global $prefix, $db, $userinfo, $projectspro_base, $projectspro_prefix;
	
	$task_id = isset( $_GET['task_id'] ) ? intval( $_GET['task_id'] ) : 0;
	$comment_id = isset( $_GET['comment_id'] ) ? intval( $_GET['comment_id'] ) : 0;
	
	// Validate the task id
	if ( 0 == $task_id ) {
		url_redirect( getlink() );
	} elseif ( 0 == $comment_id || isset( $_POST['cancel'] ) ) {
		url_redirect( getlink('&amp;file=task&amp;task_id=' . $task_id ) );
	}

	// verify the user can delete the comment
	list( $user_id ) = $db->sql_ufetchrow( 'SELECT user_id FROM ' . $projectspro_prefix.'comments WHERE comment_id = ' . $comment_id, SQL_NUM, __FILE__, __LINE__ );
	if ( !can_admin( $projectspro_base ) && ( 1 == $user_id || is_user() != $user_id ) ) {
		url_redirect( getlink('&amp;file=task&amp;task_id=' . $task_id ) );
	}

	// User confirmed the delete
	if ( isset( $_POST['confirm'] ) ) {
		// Delete the comment
		$db->sql_query( 'DELETE FROM ' . $projectspro_prefix.'comments WHERE comment_id = ' . $comment_id, false, __FILE__, __LINE__ );
		$db->sql_query( 'OPTIMIZE TABLE ' . $projectspro_prefix.'comments', false, __FILE__, __LINE__ );
		
		url_redirect( getlink('&amp;file=task&amp;task_id=' . $task_id ) );
	}
	
	// Display the confirmation message
	cpg_delete_msg( getlink('&amp;file=task_comment&amp;mode=delete&amp;task_id=' . $task_id . '&amp;comment_id=' . $comment_id ), _PRP_TASKCOMMENTDELETECONFIRM );
}



$pagetitle .= $module_title;
get_lang('ProjectsPro');
$mode = isset($_POST['mode']) ? $_POST['mode'] : (isset($_GET['mode']) ? $_GET['mode'] : '');
switch( $mode ) {
	case 'save':
		ProjectsPro_task_comment_save();
		break;
	case 'delete':
		ProjectsPro_task_comment_delete();
		break;
	default:
		ProjectsPro_task_comment();
		break;
}